import wtypes
import const
import ops

from memory import *
from const import BASE, CONST, VAR
from wtypes import *
from ops import Dynamic


def test_main():
    x = Dynamic.new(int_, (3,), constness=VAR)
    assert const.switch(x.constness) == 'VAR'
    assert x.type_ == int_
    assert x.read() == (3,)
    assert x.is_var()
    assert not x.is_const()
    dyn_value = x.to_welly()
    assert type(dyn_value) is tuple
    constness, _, t0, payload, ref = dyn_value
    assert constness == 'VAR'
    assert (t0, payload) == int_.read()
    assert ref.block == [3]
    assert ref.offset == 0
    assert ref.size == 1
    y = Dynamic.from_welly(Ref.new(dyn_value))
    assert const.switch(y.constness) == 'VAR'
    assert y.type_.read() == int_.read()
    assert y.read() == (3,)
    x.write((5,))
    assert x.read() == (5,)
    assert y.read() == (5,)
