from .memory import *
from .pack import *


ref = Ref.new((3, 'blah'))
array = Array(Ref.block([12, 13, 14, 15, 16, 17]), 3, 2)


def test_pack():
    p = pack('foo', (5, ref), (), array)
    assert p[0] == 'foo'
    assert p[1:3] == (5, ref)
    assert p[3:5] == array.to_welly()


def test_unpack():
    rl = array.to_welly()
    p = ['foo', 5, ref, rl[0], rl[1]]
    w, r, v, a = unpack(Ref.block(p), 'w1r2v0a2')
    assert w == 'foo'
    assert r.read() == (5, ref)
    assert v == ()
    assert list(a.read()) == list(array.read())


def test_tag():
    assert tag('Var', 3, 4).read() == ('Var', [3, 4])


def test_switch():
    payload = [3, 4]
    u = Ref.new(('Var', payload))
    assert switch(u, {'Var': 'r2'}) == ('Var', (Ref.block(payload),))
