import pytest

from welly.vm.repl import run_file


slow = pytest.mark.skipif(
    not pytest.config.getoption("--run-slow"),
    reason="need --run-slow option to run"
)


@slow
def test_crashes():
    run_file('\xf4rue')
    run_file('t\xf2ue')
    run_file('tr\xf5e')
    run_file('tr}e')
    run_file('tru\xe5')
    run_file('\xb4rue')
    run_file('tru}')
    run_file(' T\x80// \xf0\xcb')
    run_file('\xd4')
    run_file('Yr\xff\x87\xeb\xffA@c\x01\x00eV\x05\x1dcas  ;\x90rutrue')
    run_file('tr\xd6\x03')
    run_file('st-\xc0\xc0\xc0)r\x00\x02\x00k')
    run_file('\x00\x00ue]\xefs\xa2"tt')
    run_file(' tUut%c\xe2\x94')
    run_file('t\x00\x00\x10\x00]ve\xff')
    run_file('$uFFF--1PE0=\x1d>=  \xff\xff\xff\x7f=>\x00\x1b\x00\x00\x82\x003\x1c  iiutrue\x00D--d 0 \xfd[b\xe4')
    run_file('t(ru finall\x86\x16\x87ru\xe5k')
    run_file('\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xf6\xcf\xcf\xb5u\x93b\xf3b')
    run_file('try\x81p')
    run_file('w{\x8f\x95\x89\x00\x7f')
    run_file('\\b\x7f\xf4\x00')
    run_file('\xc6r\xb6\xb6\xb6\xb6\xb6\xb6\xb6')
    run_file('\x00\x00\x028""]\x00\x01\xdd')
    run_file('\xd9\xf9')
    run_file('{\xff\xea')
    run_file('x\x00\x01\x7ftZ &&= rue\\nr\x81rZ\x7feb]|rue\\n\x81ruY\x14b]true\\nraruYe\x81\x81vtae~r\x7fe\x7f(rb')
    run_file('1(ff(truea)e(\xf0\x81 & ')
    run_file('7< t|ue~]ue\xe5')
    run_file(' array const rue\xad\xac\x10\x00\x00\x00')
    run_file('\x0cqrue.a\x00\x00\x00\xff \x16_')
    run_file('\x10];\x8aHu')
    run_file('  ref coef\x0ePocoV cons{st@P\x7f\x15\x12\x0c\x86\x86\x86\x00\x01\x00\x00 consY eQoVst(P\x7f\x15\x12\x0c\x9b\xffxJ')
    run_file('true\n\x00\xff\xffe\xc7d')
    run_file('ttr{e\\tr\xdder{e\\tr\xdde')
    run_file('\x00module {}\xdd\x80\x00\x00\x13\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\x00c\xff\x80>>>[\xf1\xfd\xfd\xff\x80X')
    run_file("module'{\xf9\xbe")
    run_file('\x00\x1fe[1~ei)~\xff~')
    run_file('\x7f\x00u"\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x06\x14ru"\x06\x06\x06\x06\x06\x06\x06\x06\x06\x00\x10\xff\xff\x00')
    run_file('"\xc4\xc4\xc4\xc4\xc4\xc4Qello"')
    run_file('thG\x00G([])\x10GGytyt\x86uec\xff')
    run_file('"~;\x04\x00p(9")\x80e\x00R\xf7l')
    run_file(' array truXvar\xe1')
    run_file('"\xc3b" + "llo"')
    run_file(' return \xe1\xe1')
    run_file("  ref const \xa3\x83\x83\x83\x83\x83\x83\x83\xa3\x83\x83\x8b\xa3\x83\x83\x83\x83\x83\x83\x83\xa3\x83\x83\x8b\x90'pppn\x83\x83\x83\x83\x83\x83\x83\x83OeOra\x90'pppn\x83\x83\x83\x83\x83\x83\x83\x83OeOrarz\x7f'ppppppp\x82ppp\x82ppppppa\x8d\xffwutpppppa\x8d\xffwutrue\xff")
    run_file('1\n5\xfc0')
    run_file('(\xe8(\xf7\xb5')
    run_file('(1, h))')
    run_file('(1, \n))')
    run_file('struct()nt)')
    run_file('struct\nint)')
    run_file('[\xd7\xd6]')
    run_file('\xdbFOO: union {FOO; BAR}, BAR]')
    run_file('[FOO: union {\xc6OO; BAR}, BAR]')
    run_file(' union nion {FOO; BAR}, BAR]')
    run_file(' module ion {FOO; BAR}, BAR]')
    run_file('[fO\x01\x00\x00\x00struct u^alse)R]\xd3FOO\x03\xe8BWR}, \x98AR]')
    run_file('[FOO, FOO(\xc3)]')
    run_file('[F\xc6[ FOO)%OO; FO\x0b)')
    run_file('\x10\x00\x05\x05strucb\x05\x05\x05\x05\x05\x05\x05\x05\x05\x05\x05\x02\x00y\x05\x05\x05\x05\x05\x05true #FO\x05\x05\x02\x00r\x05\x05\x05F\x8eN\xe4\x07\xa3\xb5##\x8e')
    run_file('[0\xcc 2, 3]: array0')
    run_file('P0U;\xf1K')
    run_file("4'\xdfA'\xdf")
    run_file('[1, 2, 3] + \n]')
    run_file('[] \n\x00\xe1\x00')
    run_file('module array\xdfconcat_empty {\n        var x = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        var x = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\n        var x\xd0= []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\n        var x = []\n        x += [\xc6]\n    }\n  ')
    run_file('module array_concat_empty {\n       box  x = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\n        var box  x = []\n        x += [6]\n    }\n  ')
    run_file('.lO" const ]"]')
    run_file('i(\xf4\x80\x80d\x1a(\xf4\x80')
    run_file('+\'\'\'\'>\'\'\x00\x04]\xb3+ ?"["]')
    run_file('3 * [0\xcc 2]')
    run_file('-3 * [0\xcc 2]')
    run_file('[\xc5, 6, 7, 8].slice(1, 3)')
    run_file('[5, 6, 7, 8].slice(0\xcc 3)')
    run_file('[5, 6, 7, 8].slice;1, 3)')
    run_file('fn(x: array0) { x * 3 }h[])')
    run_file('fn(x: array0) { x * 3 }(Z\xdd)')
    run_file('fn(y\xda array0) { x * 3 }([])')
    run_file('fn(x: array0) {\xd0x * 3 }([])')
    run_file('fn(x: array0) { x\xd0* 3 }([])')
    run_file('fn(x: array0) { x )\xe03 }([])')
    run_file('fn(x: array0) { x * 3 };[])')
    run_file('fn(x: array0) : x * 3 }([])')
    run_file('Tii:::::::::V::::::imiii\xc8\xc8\xc8\xd8\xe7\xc8\xc8\xd3\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\x00 >st\x88uct~\x01\x00\x01\x00\x00\x00@\x00\x00\x00\x10\xc8\xd8\xc8\xde\xc8slice\xd3\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\x00 <s\x00\x01\x00\x00t~\x01\x00\x01  irt= M9\x1e \x01 ?\x00 \x01')
    run_file('fn(x: array0) { x * -3 }(Z\xdd)')
    run_file('fn(x: array0) { x\xd0* -3 }([])')
    run_file('fn(x: array0) { x * -3 };[])')
    run_file('fn(x: array0) { 3 * x };[])')
    run_file(' box  () = ()')
    run_file('const box  () = ()')
    run_file('const (a\xdc) = ()')
    run_file('const ( box a,) = ()')
    run_file('var (x,) = (\xc3,)')
    run_file('const (x, (y: int)) = (thred\xcc 1)')
    run_file('const (x, ( box y: int)) = (three, 1)')
    run_file('module ;var x = 3; x}')
    run_file('module {var\xd0x = 3; x}')
    run_file('module {var x = 3}; x}')
    run_file("mo &=\xc8 ^= \x1c'i'K\x072P")
    run_file('module ; const x = 3; module foo { x -= 1 } }')
    run_file('module { const x = 3; module foo {\xd0x -= 1 } }')
    run_file('module { const x = 3; modu fulfil  x -= 1 } }')
    run_file('module { const x = 3; modu return  x -= 1 } }')
    run_file('module { const x = 3; modul throw  x -= 1 } }')
    run_file('module { const x = 3}; module foo { x -= 1 } }')
    run_file('if\xd0(1) { 2 } else { 3 }')
    run_file('if (1) {\xd02 } else { 3 }')
    run_file('if (1) { 2 }\xd0else { 3 }')
    run_file('if (1) { 2 } else {\xd03 }')
    run_file('if (\xce) { 2 } else { 3 }')
    run_file('\n        module nary2 {\xca            var b = 1 > 2\n            b ? 3 : 4\n        }\n  ')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b ? 3 : 4\n        }\n\xe0 ')
    run_file('\n        module nary2 {\n            var\xd0b = 1 > 2\n            b ? 3 : 4\n        }\n  ')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b\xd0? 3 : 4\n        }\n  ')
    run_file("K \x01le narX2  type t    ' \x00\x04\x00\x00 narX2 '   }\n   }\n  ")
    run_file('fn (): str {\xd0return "" }().length')
    run_file('fn (): str { return "" }\n).length')
    run_file('fn (): str \n return "" }().length')
    run_file('fn (): array0 { return [] }\n).length')
    run_file('fn (): (array\xd0void) { return [(), ()] }().length')
    run_file('fn (): (array void) {\xd0return [(), ()] }().length')
    run_file('fn (): (array void) { return [()\xdc ()] }().length')
    run_file('fn (): (array void) { return [(), ()] }\n).length')
    run_file('fn (): (struct(int)) {\xd0return (1,) }().x')
    run_file('fn (): (struct(int)) { return (1,) }\n).x')
    run_file('fn (): (struct(int)) \n return (1,) }().x')
    run_file('fn (): module {\xd0return module {} }().x')
    run_file('fn (): module { return module {} }\n).x')
    run_file('fn (): module \n return module {} }().x')
    run_file('//dule foo {\n        module m { const x = 1 }\n        m.x\n    }')
    run_file('module foo {\n        module m { const x = 1 }\n        m.x}\n    }')
    run_file('\x13b""1"2""\\"\xc8"""\\"u\xc3 fu"""1""""Z"\xe8ou\xc3 fuoFOOfu"""1""""\\"\xe8o\xc3 fu"A"1""""\x0b"1""""Z"\xe8ou\xc3 \\"\xe8ouslice fu')
    run_file('modi ^R le fooE{\n        modulestr{ const e; m.x\n\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\xfa\\\\x    ; m.x\n @  }')
    run_file('module foo {\xca        module m { const x = 1 }\n        const x = m.x\n    }')
    run_file('module foo {\n        module m { const x = 1 }\n        const\xd0x = m.x\n    }')
    run_file('//dule foo {\n        module m { const x = 1 }\n        const x = m.x\n    }')
    run_file('fn(a: array int) {\xd0a["hello"] }')
    run_file('fn (i: int) { [\xc3, 4, 5, 6][i] }(1)')
    run_file('fn (i: int) { [3, 4, 5, 6][i] };1)')
    run_file('print("\xc8ello, World!\\n")')
    run_file('1: fn(){return\xd0int}()')
    run_file('fn(int): int \n return 3 }(3)')
    run_file('fn(t: type) {\xd03: t }(int)')
    run_file('(defer fn(): int);)')
    run_file(' struct n(): int)()')
    run_file('    module cast_to_unfulfilled_type {\xca      const t = defer type\n      5: t\n    }\n  ')
    run_file('    module cast_to_unfulfilled_type {\n      const\xd0t = defer type\n      5: t\n    }\n  ')
    run_file('(box 3)=value')
    run_file('(box 3).v = e')
    run_file('fn(x: int) {\xd0(box x).value }(3)')
    run_file('fn(x: int) { (box x).type };3)')
    run_file('fn(x: int) { (box x).constness };3)')
    run_file('switch FOO(three) {\xd0else {3} }')
    run_file('switch FOO(three) { else {\xc3} }')
    run_file('module ald {\xd0var a = [3]; defer a.length }')
    run_file('module ald { var a = [\xc3]; defer a.length }')
    run_file('module ald { var a = [ ]; defer a.length }')
    run_file('for x in 3 {\xd0x }')
    run_file(')do\xdf\x80\x1a\x00\x00st fg \xbc\x14st catch oa\x81)/')
    run_file('for x in 3 {\xd0if x==1 { break }; x } else { 5 }')
    run_file('for x in 3 { if x==1 {\xd0break }; x } else { 5 }')
    run_file('for x in 3 { if x==1 { break }; x } else {\xd05 }')
    run_file('for x in while  x==1 { break }; x } else { 5 }')
    run_file('for x in  case  x==1 { break }; x } else { 5 }')
    run_file('\n    fn ref8(x: int): void {\n        var x = x\n        var \xda = &x\n    \r   a\n        *a\n    }')
    run_file('\n    fn ref8(x: int): void {\xca        var x = x\n        var Z = &x\n    \r   a\n        *a\n    }')
    run_file('\n  never \n        var\x03Z =   "     vqr Z = &x\xfb\x1f \x00\x80\r   a\n        *\n    }')
    run_file('"\xc6"/SX')
    run_file(' 1. ^ 0e0 ')
    run_file(' 1. % 0e0 ')
    run_file(' 1. & 0e0 ')
    run_file(' 1. / 0e0 ')
    run_file(' 1. | 0e0 ')
    run_file("[FOO] +'\xdbBAR: union{&NO' DAR}]")
    run_file(' 0x1;\xc8\n')
    run_file('asse[^(\xceoduo")')
    run_file('\n    fn ref8(\xc7: int): void\n ')
    run_file('fn (): (ct(i\xdct)) { retqrn () }().x')
    run_file('fn (): (st > t(inu\xc9) { reRurn  bool @\x00\x00\x00')
    run_file('"\xd8\xd8\xd8\xd8\xd8\\tllo\\\xdc\xdc_llo"')
    run_file(' & "h\xe5\x84lo"')
    run_file(' ref "h\xc2llo"')
    run_file(' box "he\xc4lz"')
    run_file('3 >>-\\\n3')
    run_file('3 >> ~\n3')
    run_file('3 <<-\\\n3')
    run_file('3 >>>-\\\n3')
    run_file('(\xed\xd3\xd3)()+3/3')
    run_file('+t(\xdd\xdd)')
    run_file('fn (sts\xcc bool): p(())')
    run_file(' ref[var \xc4')
    run_file('fO (sts\xcc \x00\x00\x00 ): prin')
    run_file("[FOO: union ulf {\xcf: union ulf {\n   = def in q(): int\n  \x08   const'cxpell\n      \x00\x02\x0c\x00bl cop\\\\y = pn(): int { vc\x00\x02\x00\x00 cUll = def in n(): int\n  \x08 cell()\n  \n }\n    ")
    run_file("[FOO: union ulf {O: union ulf {\n   = def in q(): int\n  \x08   const'cxpell\n      \x00\x02\x0c\x00bl cop\\\\y = pn(): int { vc\x00\x02\x00\x00 cU\xecl = def in n(): int\n  \x08 cell()\n  \n }\n    ")
    run_file("[FOO: union ulf {O: union ulf {\n   = def in q(): int\n  \x08   const'cxpell\n      \x00\x02\x0c\x00bl cop\\\\y = pn(): int { vc\x00\x02\x00\x00 cUll = def in n():\xa0int\n  \x08 cell()\n  \n }\n    ")
    run_file('1+  module double_fulfil_forwarding_pointer {\xca      const x = defer fn( -- ): int\n      const y = defer fn(): int\n      fulfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n ')
    run_file('1+  module double_fulfil_forwarding_pointer {\n      const\xd0x = defer fn( -- ): int\n      const y = defer fn(): int\n      fulfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n ')
    run_file('1+  module double_fulfil_forwarding_pointer {\n      const x = defer fn( -- ): int\n      const y = defer fn(): int\n      fulfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\n #\xe0 }\n ')
    run_file('\n    fn ref5(x: int): void {\xd0array const a = &x\n        a\n   (x: ina\n    }(5)')
    run_file('typeof union int_tree {\xccEAF();ABRANCH(int_tree, int, int_tr fn ')
    run_file('typeof union int_tree {LEA\xc6();ABRANCH(int_tree, int, int_tr fn ')
    run_file('    const m = fn (t: type): module {\xca        return module {\n      id(j: t): t { return x }\n        }\n    }(int)\n   ')
    run_file('"(\x7f" -\\udefer------:\x1c"`\x922')
    run_file('    const m = fn (t: type): ule {\xca            fn id     (x: t): t { return     }\n    }(int)\n')
    run_file('"h\\\\b\xce\xce\xce\xcelo"')
    run_file(' array "h\\\x00\x00\xce\xce\xce\xcelo"')
    run_file(' ref var "h\\\x00\x00\xce\xce\xce\xcelo"')
    run_file(' array var "h\\\x00\x00\xce\xce\xce\xcelo"')
    run_file(' ref const "h\\\x00\x00\xce\xce\xce\xcelo"')
    run_file('(1,(0\xcc))')
    run_file('(1(switch(1\xd7\x10\x00')
    run_file('[FOO, & F(\xc3)]')
    run_file('[FOX, & e(3X, \xd6)]')
    run_file(' -0.1e-0  &.0')
    run_file("';';'\xff\xa3\x17';\x07;'\xff\xa3\x17'c\xffr\x00")
    run_file(' * q(\xdf)')
    run_file('O(ZO(\xcf(')
    run_file(' 0.0 ;)')
    run_file('void\n \xff\x7f\xff\xff)')
    run_file('struct((\xce))')
    run_file('struct(h\xdat)')
    run_file(' * struct(i\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc3t)')
    run_file(' new t(in\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xddt)')
    run_file('struct int (\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xd6\xcdint)')
    run_file(' ! [\xd7\xd6]')
    run_file(' & W;)]')
    run_file(' new [\xd7\xd6]')
    run_file(' box [\xd7\xd6]')
    run_file('F(1:int); 2, 3: int)')
    run_file('[1];1]')
    run_file('*(0\xdaint)= arra ** tJ')
    run_file(' box  ():d *= rrr')
    run_file(' typeof nnnnnnnnnn[0\xcc 2] * 3')
    run_file('[FOO,  array int( { a[1\xdd }(j3, 4,  // ])')
    run_file('()\ne)\rn4\x7f\xe1\xe1\x00\xfa\x00\x00\xfaeturnwypereturn\xf7\xf7&@\xfe\xe1\x00uypeof\x8c\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\x10\x00o"')
    run_file('[1] +["\xdd1] +["] *  [4,  *  [4, 5]')
    run_file('[1] +[%\xdd1] +["] *  [4,  *  [4, 5]')
    run_file(" box'\xdb', 2, 3]8 array0")
    run_file('[5,8].length; FFFFF\xcaFFFFFFFFFFFFFFx}')
    run_file('[FOO: union {\xc6OO;!BAR}, BAR]')
    run_file('[F?O: union {\xc6OO; BAR}, BAR]')
    run_file('[FOO:*union {\xc6OO; BAR}, BAR]')
    run_file('[FOO: union {\xc6OO; BAR}? BAR]')
    run_file('[FOO: union {FOO; BAR},(Z\xdd)]')
    run_file('[ new FOO: union {\xc6OO; BAR}, BAR]')
    run_file('[ ref FOO: union {\xc6OO; BAR}, BAR]')
    run_file('[FOO: union {\xc6OO(A); BAR}, BAR]')
    run_file(' case  foo {\xca        moduSm m > const x  while 5 | }\n   ')
    run_file('(box 3(.nu (int\xe9')
    run_file('defer prier (unidefer prier (union on {\xc6OO; BAR}, BAR]')
    run_file(' ref var [0\xcc 2, 3]["he\\\nllo"]')
    run_file('switch eOO(int, 2, three\xd8 4.0) { case FOO(w, x, y, z) {x} }')
    run_file('switch FOO(inthred\xcc 4.0) { case FOO(w, x, y; z) {x} }')
    run_file('switch FOO(inthree, 4.0) {\xd0case FOO(w, x, y; z) {x} }')
    run_file('c[\xdb[[ @x, (y: int)) = (3, 1)')
    run_file('va: (y\xcc) = (3,)')
    run_file('switch FOO(Jnree, 4.0) {\xd0case FOO(w, x, y,w, x, y, z) {x} }')
    run_file('const (x, (y(y\xcc (y: int)): int)) = (3, A)')
    run_file('switch FOO(intOO(w, x, y, z) , 2, three, 4.0) {\xd0case FOO(w, x* y, z) {x} }')
    run_file('module {\xd0module 2, three, 4. \x00\x00\x00 case FO^(w, x, y, z) {x} }')
    run_file('c+  module double_fulfil_forwarding_poinier {\xca      const x = defer fn(): (): int\n      fulfil x = y\n \x08    fllfil y = fn(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n ')
    run_file('[1\xcc 2, 3][1\x0c 5, 3]["hello"]')
    run_file('const (ule intf {\xca      const intf = fnh): int\n   = defer intf\n ')
    run_file('fn (print, boofn (prinu\xcc bool):l): i')
    run_file('fn5(print, boofn (pr\xcfnt, bool):l): i')
    run_file('*   module intf{\xca      const ictf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil k3 = k(3)\n      k3()\n    }\n ')
    run_file('*   module intf{\n      const ictf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil k3 = k(\xc3)\n      k3()\n    }\n ')
    run_file('[1, 2, 3]\n1]: array0')
    run_file('[ 1. ^ 0e0 ] + []')
    run_file('module array_concat_empty {\xca        var x&= []\n        x += [6]\n    }\n  ')
    run_file('modv_= [e aur@yoncat_Cy \x80\xff\xff\xff\xc2\xc2\xc2\xc2\xc2\xc2\xc2ar x = []\n(       $[e arra\xcc\xa7ncat_e ')
    run_file(' union array_concat_empty {\xca        var x = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        v[""] = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        v .a  = []\n        x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        var fulfil         x += [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        var x = []\n        x[]= [6]\n    }\n  ')
    run_file('module array_concat_empty {\xca        var x[1] = []\n        x += [6]\n    }\n  ')
    run_file(' [ 0.0 ]\n        x \xed= [6]\n   fulfiO }\n ')
    run_file('  [ print ]\n       module arra      var\xffw = [ print ]\n        x += [6]\n    }\n  ')
    run_file('B-9[\xc2.4]')
    run_file('3[9 << 999999999999999999]')
    run_file("  r m'''''''''''''\\r''\xa7fil assert ing(1)_pointer {\n ")
    run_file(' *+ module fion_type_check4 { true \xca      conot (subtype, m{dtytype) =\n        (array0, array const int, array int)\n')
    run_file(' *+ module fion_type_check4 { true \n      conot (subtype, m{dtytypd\xc9 =\n        (array0, array const int, array int)\n')
    run_file(' struct k3()\n \xb9 ')
    run_file(' 0x1e : int \n \xb9 ')
    run_file('switch FO & O(tlree) {\xd0else {} }')
    run_file('~ & fn make(tM tfpd~fe\xcfe): mo6{\n   6   (return:mo\n6   }\n ')
    run_file(' 1. % 0e39 >= 2.')
    run_file('u:nst (x, (y:7int)) = (l_forwardin finally `_pointer {\n      const x = defer fn(): iNNNNNNNNNN*/NNNNNNNNNNNNnt\n      const y = defer fn(): int\n     inter {\n      const x = de y = fn(): int { return 3 }\n      fulfil x = fn(): inb { return 3 }\n    }\n   \n  \xa0 } ')
    run_file('u:nst (y\xcc (y:7int)) = (l_forwardin finally `_pointer {\n      const x = defer fn(): iNNNNNNNNNN*/NNNNNNNNNNNNnt\n      const y = defer fn(): int\n     inter {\n      const x = de y = fn(): int { return 3 }\n      fulfil x = fn(): inb { return 3 }\n    }\n   \n    } ')
    run_file('(1[""][\xdd\xdd])')
    run_file(' ref typeof [] ;)')
    run_file(' &  module function_type_check3 {\n      const (subtype, midtype, superty\xd2e) =\n        (int, array int)\n      fn f(x: supertype): midtype { return []: subtype }\n      const g = f: (fn(subtype): supertype)\n      g([]: midtype)\n    }\n ')
    run_file('[FFO: union {FOO; B()\xc88(((((((B (3,=~on(((')
    run_file(' new &(A\xd1RR: union{FR: union{$\x7f$union{FR: union{$\x7f$$$$$$$Y')
    run_file(' new &(AQRR: union{\xc6R: union{$\x7f$union{FR: union{$\x7f$$$$$$$Y')
    run_file(' typeof  typeof struct(irucu\xc8int)')
    run_file('1 > 2 &true ?(\xd9 : 4')
    run_file('module array_connat_inplace1 {\xca        var x: array const int = []\n   \x01    x += [6]\n        x\n    }\n')
    run_file('module array_connat_inplace1 {\n        var\xd0x: array const int = []\n   \x01    x += [6]\n        x\n    }\n')
    run_file('H ?(p\xd3iYt,  ref b\x00oe): i')
    run_file('fn(x: ar(\xdd\xdd)) { x * 3 }([])')
    run_file('fn a (x: array0) { x * 3 };[])')
    run_file('fn(x: array0) { return  x * 3 };[])')
    run_file(' r: (x,) (1)=concat_empty[\xd0print ]\n ')
    run_file('switch FOO(Jnree, 4.0) {\xd0case FOO(w, x, y,w, x,Ay, z)(()) {x} }')
    run_file('switch FOO(Jnree, 4.0) { case FOO(v\xcc x, y,w, x,Ay, z)(()) {x} }')
    run_file('&      f():fn g(): v{\xd0const x = f }\n')
    run_file('switch FO{ case n |\xccbAF; BRANCH(int_[1]e, int, inL_tree)}')
    run_file('switch FO{ case F-O(w, x, y, \xd8) {x} }')
    run_file('switch FO{\xd0case F-O(w, x, y, X) {x} }')
    run_file('switch FOO(4.0) { case FO {\n         throw  Z\xdd\n        x += [6 |   \x0e}\n  ')
    run_file('switch FOO(4.0) { case FO {\n      \xdf\xdf\xdf\x8bhrow  []\n        x += [6 |   \x0e}\n  ')
    run_file('if f (\xd1) {:2 } else {\x00(!) {:2 } else { 3 }')
    run_file('//   module re {\n        var a =*new  5\n        a\n      1 *a\n    }')
    run_file('const () = ((\xdd\xdd))')
    run_file(' box module\n\xa0       var x = []\n          var x = []\n        x += ref var #[6]\n  ')
    run_file('fn (pri == boofn (prinu\xc6 b (())ol):l): i')
    run_file(' box module array_concat_empty {\n        var x = []\n 5}\n\xe0')
    run_file(' -0.1e00 **-0.1e-0 ')
    run_file(' -0. ^ 1e00  *-0.1e-0 ')
    run_file('    fulfil!k3 = j(\xc3)\n   ')
    run_file(' while a_conca(false) {\n        var x = ile array\xdfconca(f6]\n')
    run_file(' typeof module\n\xe1_concat_empty {\n        var\x00\x04\x00\x00 []\n        x += [\x10\x10\x10\x106]\n%   }\n  ')
    run_file('"\xd0-0\x191 if e-0 he"[1] +=    ( 4')
    run_file('const (x, ( * y: int)) = (thred\xcc 1)')
    run_file('const (x, (y[1]: int)) = (thred\xcc 1)')
    run_file('module ;var x =!3; x}')
    run_file('module {var x =!3}; x}')
    run_file('module ;var x =&3; x}')
    run_file('module {var x =&3}; x}')
    run_file('module ;var x = S; x}')
    run_file('module {var x = S}; x}')
    run_file('module ;var x =(); x}')
    run_file('module {var x =()}; x}')
    run_file('switch FOO(4.0) { case FO { box  z += [6]\n    }\n \xdd')
    run_file(' -0.&-1e-0  %-0.1e-0 ')
    run_file(' -0. -1e-0  &-0.1e-0 ')
    run_file(' -0. -1e-0  %-0. ** 1e-0 ')
    run_file('switch+FOO(t\xd0print ) { elseodule {\n    \x1diny)\n&')
    run_file('if ulsq(()) {\xd04 }')
    run_file('module {\xd0while  foo {} }')
    run_file('module {\xd0switch foo {} }')
    run_file('module { var x = 3; x >>-1 }')
    run_file('module { var x = 3; x <<-1 }')
    run_file('module {\xd0const x = 3; switch foo { x -= 1 } }')
    run_file('if&(1) {\xd02 } else { 3 }')
    run_file('if&(\xce) { 2 } else { 3 }')
    run_file('1[\xce] ? 2 : 3 ')
    run_file('1 ? 2[\xce] : 3 ')
    run_file(" while !_concat_empty {\n     &  '\xde':('\xde';; '@/@/ '\x00\x02\x00\x00.0e0 8")
    run_file(" while !_concat_empty {\n     &  '\xde': '\xde';{ '@/@/ '\x00\x02\x00\x00.0e0 8")
    run_file(' while array array const _co_empt9 {\xca        var x = [][1]\n        x += [6]\n     fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil k3 =&k(3)\n      k3()\n    }\n')
    run_file(' while array array const _co_empt9 {\n        var x = [][1]\n\xdd       x +_ [6]\n     fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil k3 =&k(3)\n      k3()\n    }\n')
    run_file(' while arr:ycat_emptq {\xca        var x = []\n       tinu} else { 5 }')
    run_file(' while arr:ycat_emptq {\n        var x = []\n       tinu} else {\xd05 }')
    run_file('if&(le2{\xca @\x00 fn (): modu\\e {\n        modut): t { return x }\n')
    run_file('667666666666666666 >>> 66666666*666666666666666666&66666')
    run_file(' while new  a_conca(fal\xd0if se) {\n        vak x = e new  a_conca(fal ifile array_conca(f6]\n')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n!           b ? 3 : 4\n        }\n\xa0 ')
    run_file('\n        module nary2 {\xca            var b = 1 > 2\n            b ?&3 : 4\n        }\n  ')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n !!         b ? 3 : 4\n        }\n\xa0 ')
    run_file('\n        module nary2 {\xca            var b = 1 > 2\n            b ? 3 : 4()       }\n  ')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b\xd0? 3 : 4()       }\n  ')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b ? 3 : 4[\xce]      }\n  ')
    run_file('\n     var b = box 2\n      `     b ? 3 : 4}\n  ')
    run_file('\n        module nary2 {\xca    var b = 1 > 2\n            b ? 3 : 4 -0.1e-0 }\n  ')
    run_file('\n        module nary2 {\n    var b = 1 > 2\n            b\xd0? 3 : 4 -0.1e-0 }\n  ')
    run_file('\n    module t {\n        var a = 10\n        while a > a > 0 {\xca            a -= 1\n     }\n    }')
    run_file('\n    module t {\n        var a = 1//        while a > a > 0 {\n            a -= 1\n     }\n    }')
    run_file('[ & 9] ; & B]')
    run_file('\n           \n      defer type\n\xa0     const u-= (t,)\n ')
    run_file('\n           \n    fn (): module {\n         fn0(): module {\n  \n     1 }\n    }().x     < fn (): module {\xca  \n    }')
    run_file('fn (): str {\xd0return!"" }().length')
    run_file('fn (): str {\xd0return ""[1] }().length')
    run_file('fn (): str {\xd0continue  }.llbngtg')
    run_file('fn (): (struct(i:t)) {\xd0return (1,) }().x')
    run_file('fn (): (struct int (int)) \n return (1,) }().x')
    run_file('fn (): (struct(int)) { return (1,) }()\n1].x')
    run_file('77 & +77\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n)')
    run_file('[ box 2 &box * &333333333333433333333,3[ box \xc7].ld-g].t')
    run_file(' 0x166666 << 6666666666666666666')
    run_file('[[N]]\nNe.lonjt].lo.l/ng <> [Ne.l].lo.l/n')
    run_file('[ box3* &Mox *!&33333333333343333333333[ box \xc7].ld-g]-t')
    run_file('[ box* &* &box * &33333333333343333333333[ box \xc7].gg].t')
    run_file(' & module//oo {\n        module m { const x = 1 }\n        const x = m.x\n    }')
    run_file(' & module foo{}\n        module m { const x = 1 }\n        const x = m.x\n    }')
    run_file(' & module foo {\n        module m { const x = 1 }\n        const x = m.x}\n    }')
    run_file('fn (i: int) { [3, 4, 5, 6] + [i] };1)')
    run_file('!0x3\n3/33bre3\x18333d\xff\xff\xff\xff333-33\x163333(): i\x00\x19\xf7\xff')
    run_file(' 0x166666666666666 * [2]\n   ')
    run_file('fn(t: type) { 3; t };int)')
    run_file("'o'\nd([])] ; []")
    run_file('          var  t = defer type\nlength    \xd9 5: t\n    }\xeb  ')
    run_file('switch FOO(int, 2, three, 4.0) { case-FOO(w, x\xd6 y, z) {x} }')
    run_file('switch ZO{\xd0case FOO(w, x,  ! y, z) {x} }')
    run_file('fn(x: str) { (box x).type };3)')
    run_file('switch&FOO(three) {\xd0else {3} }')
    run_file('switch FOO(three)[1] {\xd0else {3} }')
    run_file('fn(x:void) { }\n\xa0 ')
    run_file('( new box T)[\xdd\xdd].value')
    run_file('( new box T)\n""].value')
    run_file('module ald { var a =[""]}; defer a.length }')
    run_file('module ald { var a = [ ! 3]}; defer a.length }')
    run_file('module ald { var a = [ box 3]}; defer a.length }')
    run_file('for x in!3 {\xd0x }')
    run_file('for x in[\xce]{ x }')
    run_file('for x in 3() {\xd0x }')
    run_file('for x in 3[\xce] { x }')
    run_file('for x in 3 -0.1e-0  {\xd0x }')
    run_file('for x in 3  >>> -0  { x }')
    run_file('for x in*fo3 {\xd0for ref const   x in*fo3 { for ref const  x i% 5\n ')
    run_file('for x in 3 { x>  x};}')
    run_file(' fulfil  Pm = fn4(t: ty\xdfG): moSu')
    run_file(' fulfil  [\xce]= fn (t: typC): modu')
    run_file(' 1.&+ 0e0 ')
    run_file('ttr*pri == b (print& b9(()\xd9ol):l): i')
    run_file('for x in 3 {\xd0if x==1 { break\x1cfor x in 3 { if x==1 { break }; x } else { reurn  5 }')
    run_file('typeof union imodule {}; BRANCH(int_tree, int, int_trEe)}')
    run_file('typeof union intl {LEA}; BRANCH(int_tree, int, int_trEe)}')
    run_file('typeof EAF; BRFNCH(int\x7ftree, int, int_ne, int, int_trEe)}')
    run_file(' fulfil! Pm (~\xdfue)= fY (t@ typC): mo')
    run_file('for x in 3 {\xd0if x==14(false) for x in  ref var 3 { id x==1 { break }; x } else { return  5 }}; xse { r\x01 { r\x01turn  5  fulfil }')
    run_file('& & &QA(E)& & & &QA(\xc5)')
    run_file('& & &QA\nE)& & & &QA(E)')
    run_file('[[\xd01x#] ? 28: d ] ? 2 : d ')
    run_file('[module {}]  \n2]\n   ')
    run_file(' union {};)d')
    run_file('      ref const    defer type\n\xa0O array const  defer type\n   ')
    run_file('            \n      defer type\n   array const  defer type\n\xa0     ype\n ')
    run_file('fn (tr,*fn (fn\xd0(tr,*fn (tr,*r,*)oo^):bootr,*bool): p((tr,*r,*)oo^):bootr,*bool): p(())')
    run_file(' while  typeoflif&(\xce) { 2 } else {\\c\\ .a \\\\\\lse {\\c\\ .\x0c \\\\\\\\\\\\\\\\\\\\\\_\\\\_\\"\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\Ayse {\\c\\ .aM\\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\ %= \\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AY}')
    run_file(' while  typeoflif&(1) {\xdf\xcd\xdf\x82 else {\\c\\ .a \\\\\\lse {\\c\\ .\x0c \\\\\\\\\\\\\\\\\\\\\\_\\\\_\\"\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\Ayse {\\c\\ .aM\\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\ %= \\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AY}')
    run_file('[1,8].s.sl[0\xcc8].s.sl = 3; FFFl0= 3; FFFRFFF = 3; FFFl0= 3; FFFRFFFFF\xcaFFFFfFFFFFFIFFx}')
    run_file('m >>= ( mod666( *6666666666666626666666666666( * int))*6666666666666626666666666666(\xd0* ind))')
    run_file('const (a,) = 6 << 966666666666666')
    run_file(' 1. ^ 0e39 /2.')
    run_file('if&(1) {  * y\n  obj == 10\n        while a(0\xcc) {\n  "h"\n        }\n   ;}')
    run_file(' defer  neve66(!* mo(!*66266666666666266662666666666666( * int))*6666666666666626666666666666(\xd0* ind))')
    run_file(' dyn [ bop * &!array  new 33333333333343333393333[ box \xc6]([]).lR-g].t')
    run_file('moe66+(!mod666( *6666666666666626666666666666( * int))*66 << 6666666626666666666:66(\xd0* end))')
    run_file('[""]\n rox&3:333335333343333333333[ box 3].ldng].tt')
    run_file('if!(1) { 2 } else {    var a = new 5([])\n    a\xca        *a\n    }')
    run_file('if!(1) { 2 }//lse {    var a = new 5     .  b ? 3 : 4\n        }\n')
    run_file('3 + 2 :union iote {LEAF(iO); \xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdfLEAF(iO); BRANCH(Knt_tintVtr%e)}')
    run_file('    const m = fn (t: type): int //            fn id     (x: t): t { return     }\n    }(int)\n')
    run_file("var (xl) =\n\n\n\n'\xde';; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =(1,)\n\n\n\n'\xde';; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde'();; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde'(A);; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde'[1];; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde'(());; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde'([]);; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file('var (x,) =\n\n\n\n\'\xde\'[""];; \'@/@/ \'@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 \';; \'@/ \'\xde\': \'\xde\';; \'@/1=Je0 ')
    run_file("var (x,) =\n\n\n\n'\xde' .a ;; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file("var (x,) =\n\n\n\n'\xde' -0.1e-0 ;; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde': '\xde';; '@/1=Je0 ")
    run_file('switch 1. ^ 0e0  {  }\n ')
    run_file('for x in 5555555 { break };\xd0x for x in 3 { if x<=1 { brelse { 5\x18}')
    run_file('for x in 5 ** 55 { break }; x for x in 3 { if x<=1 { brelse { 5\x18}')
    run_file(" ! \n\n\n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(" & \n\n\n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(" !! \n\n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(" new \n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(" box \n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file("typeof\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(' * structRR: union{\xd6R: union{FOO\\ B\x00\x04\x00\x00 + [BAR:  union{VR: union{FOO\\ B\x00\x04\x00\x00 + [BAR: union{FR: union{FOO\\ --  BAARaY')
    run_file('1  .a8?  * 2 : j+(\xd0v  .a8?  * 2 : j)\n')
    run_file('[ box 1] \n\x803')
    run_file('fn (): module { rel\xdfe\n    q\n      var*x = []\n        x += [6]\n    }\n')
    run_file('fn (): module { rel_e\n    q\n   \xdf\xdf\xdf\x89ar*x = []\n        x += [6]\n    }\n')
    run_file('m >> _ + ( mod?66( *6666662666666666666666( * int)+6666.66666666( * int))*666666666 >> _ + ( mod666( *66666626666666+6666.66666666( * int))*6666666666:1662662666606\xc526666662666666( * int))*66666666:6662662666606626666666666666( * int))*66E6666666666626666666666666( *6 > 666666666( * ind))')
    run_file('m >> _ + ( mod?66( *6666662666666666666666( * int)+\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce6.66666666( * int))*666666666 >> _ + ( mod666( *66666626666666+6666.66666666( * int))*66type6666666(\x10\x00662662666606E26666662666666( * int))*66\r66666:6662662666606626I66666666666( * int))*66E6666666666626666666666666( *6 > 666666666( * ind) ')
    run_file(' fulfil [\xc5,8].sl = 3; FFFFF\xcaFFFFFFFFFFx}')
    run_file('6666&66%6666 >>6;\xc6&66%6666 >>6 >> 666&66')
    run_file('6666&66%6666 >>6 - 66%6666 >>6 >> 666&66')
    run_file(' box fn(x: int) {\xd0box fn(x: int) { (box x).t(A) }(3)(box Z).type }(3)')
    run_file(' while FUO(thile \xc6UO(t) {) {  }\n')
    run_file(' new  defer fn(): int\n\xa0 ')
    run_file(' box  defer fn(): int\n\xa0 ')
    run_file('//   module re4 {\n        var a =*new 5\n      ("")        *a\n    }')
    run_file('\n*new 5\n         modulb re4 }\n        va\x80ssertnew 5\n   \x01\x00 ("")\n    module        *a\n    }')
    run_file(' ! (tr,*fn ((()r,*r,*boy\xda):ool): p((\xdb)')
    run_file('fn (i: int) { [3, 4, 5, 1+ i] };1)')
    run_file("if&(1) { 2 } else  if&(1) {ig\xc6(1) {ls }  } else {\x00 &(e {iv&(1' { 2 3  2ls \x01\x00 lse {if&(1)  3 ")
    run_file("if&(1) { 2 } else  if&(\xce) {if&(1) {ls }  } else {\x00 &(e {iv&(1' { 2 3  2ls \x01\x00 lse {if&(1)  3 ")
    run_file("if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {\xdf &(e {iv&(1' { 2 3  2ls \x01\x00 lse {if&(1)  3 ")
    run_file('switch FOO(inthree, 4.0) {\xd0case FOO(w, x, y? z) {x} }')
    run_file('~~~~~*new 5\n\xa0    module {}    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('B(3 << 33333333333333333): int\n ')
    run_file('va: new  (y\xcc) = (3,)')
    run_file('*   module intf{\n      const ictf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil(\xdd\xdd)= k(3)\n      k3()\n    }\n ')
    run_file('~~*new *new 5\n .   modu\x07\xff\xff\x05} \xd5\xd5\xd5\xd5\xd5*a\n5\n .   module {} \xd5\xd5\x00\x00\x00\x80a\n')
    run_file('~~*new ~*new 5\n  modul\x00\x04\x7f\xff.   \xedodu\xff\xfful\x88\x7f\xff} \xd5\xd5\xd5\xd5\xd5*a\n')
    run_file('if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {jjjjjjjjjj &= j\n      for n in 3 {jjjjjcjjjjjjjjjjjj\xd1jjjjjjjjjjjjjjjjjjjjjjjjjjjj &= jjjjjjjjj\n      constdjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = u\nj\n     (v,) = u\n      5: v\n    }\n constdjjjjjjjjjjjjjjxjjjjjjjjjjjjjjjjjjjjjjjjjjjjj = u\n      5: v\n    }\n ')
    run_file('if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {jjjjjjjjjj &= j\xca      for n in 3 {jjjjjcjjjjjjjjjjjjQjjjjjjjjjjjjjjjjjjjjjjjjjjjj &= jjjjjjjjj\n      constdjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = u\nj\n     (v,) = u\n      5: v\n    }\n constdjjjjjjjjjjjjjjxjjjjjjjjjjjjjjjjjjjjjjjjjjjjj = u\n      5: v\n    }\n ')
    run_file(" & \n\n\n typeof \n'\xde';; '@D@/\\\x7f9@/@%H )")
    run_file(" new \n typeof \n'\xde';; '@D@/\\\x7f9@/@%H )")
    run_file(" array typeof \n'\xde';; '@D@/\\\x7f9@/@%H )")
    run_file(" var v =\n\n\n typeof \n'\xde';; '@D@/\\\x7f9@/@%H )")
    run_file("typeof typeof \n'\xde';; '@D@/\\\x7f9@/@%H )")
    run_file('[[]] \n\x00\xff[  +]]')
    run_file(' defer ref var  struc66(\xd1* mod666(!*662666666(!*6626666666666626626666666666626666666666666( * int))*666626666666666666( 66666626626 % 666666626666666666666( * int))*66662666666666666666 != 6666( * int))*66662666666666666( * int))*66666646666666266;6666666666( * ind)')
    run_file(' fulfil ref8(y\xda int): void= &x\n ')
    run_file('+oe666(!mod666(\xd0*6666666666%66626666666666666( * int))*66 << 666?66662>( *6666666666266E6666666666(*66666666666666266666666666&6( * int))*66 << 6666666?26( *666666666666662:666666666666( * int))*66 << 66666666&66666666:66( *  * i * int))*66 << 66666666666666666:66( * ind))')
    run_file('3[999999999999999999*[""]]')
    run_file(' & 3[9 << 99999999999999]')
    run_file(' * 3[9 << 99999999999999]')
    run_file(' new 3[9 << 999999999999999999]')
    run_file(' ref 3[9 << 999999999999999999]')
    run_file(' box 3[9 << 999999999999999999]')
    run_file(' defer 3[9 << 999999999999999999]')
    run_file(' array 3[9 << 999999999999999999]')
    run_file(' typeof 3;99999999999999999999999]')
    run_file(' typeof 3[9 << 999999999999999999]')
    run_file('for n in 3 { mjjjjjjjjjjjjjjjjj\n      const (v,) = u\n      5: v\n   jjjjjjjjjjjjjjjmodulejjjjjj\xd8jjjjjjjjjjjjjjjjjj\n      const (v[""],) = u\n      5: v\n   jjjjjjjjjjjjjjjjjjjjjjjj\n      const (v,) = u\n      5: v\n    }\n')
    run_file(' dyn [3[!box&33333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:3337333433333333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:333733343333333633[ box 3].l=ng333343 ** 33333[ box \xcf33633[ box 3].ldng333343333333333[ box O].ldng].tt')
    run_file('    fn f(): void{}\ncox = f }\n &3')
    run_file('    fn f(): void {\nconst x = f }\n\xa0       g()\n   ')
    run_file('for x in 3 { +5555 >>~  x }')
    run_file('for x in 3 { +5555 >>-  x }')
    run_file('for x in 3 { +5555 >>>- x }')
    run_file(' 0x33333 << 3333333333333333333: int\n  \x08')
    run_file(' 0x3333333333333333 << 33333333: int\n  \x08')
    run_file('[ module {}].slice;1, 3)')
    run_file('for x in n (u\xda type):\nule {\n   com = fn (t: type): ule {\n           ;5 * 5555+55555 || 55555555555555555555555555 }\n  [""]         ;55555555+55555 || 55 }\n ')
    run_file(' box module array_concat_empty {\n        var x = print}\n\xe0')
    run_file('\x9f\xb5\xa7o\xfef\x03')
    run_file('\xff\x7f\xff\xfb\x00\x00')
    run_file('\xe3\x7f\xff\x9f')
    run_file('\xea\x00')
    run_file('\\" a\r\xada \xc5 d')
    run_file('\xdc')
    run_file('\x1e|Q\x00 \x01ef z/\x13\x13* d(1)m catC\x12 \x01H\x13* d(1HH$\xff\x89vF\x1b')
    run_file('\xd2D=~ false \x93\xdcL\x00')
    run_file('t ar <<\x1c )Ay \x84ar  \x00N<\x1c )Xy \xffar  \x00NNet > \x00\x10\x00et > \x00N var 4Pe')
    run_file(' pa{\x89\x89>>>>>>\x8b\x89\x84\x02\xe2')
    run_file('\xf3=\xf3==')
    run_file(']ru\xe5')
    run_file('tru ref e\x8d\x10\x00e')
    run_file('z\xd4\x14')
    run_file(')')
    run_file('\n\xff\xff\x05')
    run_file('\xff\xcc %/\xdf\xb1 \xff\xcc %/\xff\xec\xffC\x86%\xff\x7f%\x86\x81c{\x7f\xe8')
    run_file('|l\x03 \x1d0xd) \x8by ( ) ~')
    run_file('\xd1\xff')
    run_file('* array var \xd0*\xd0\xd0')
    run_file(']e')
    run_file('"SJereturn "SJere\xe1 ||= J\xe1')
    run_file("'' c \x00\x02\x00\x00c \x8a< \xcf")
    run_file('>"")m')
    run_file('(\x00irow t}m\xff\x80dt\xfdr\xff\x80d!ow\x00\x16t\x87r \x00')
    run_file(' {|d\x00\xe6')
    run_file(" '*\x7f'*\x7f? r\x89y\x88\x00( <<\x00fa?alse)*5cqTch a? r\x89y{\x04( <<\x00false)*5cqTch a]rrM\x82\x00 ")
    run_file('\x01 .a  \x00\x00zzz\x82q\\\xbe\x00\x00zz')
    run_file('(\xc3\xc3\xc3\xc3"")')
    run_file('(module {}a) ,?\x98m')
    run_file('tr (t: type): type G return re\x88 const t }(int)')
    run_file('tr (turn | type): trn ref*/ t\x9cpe  aJ \x95 t  || n\x00\x10\xbb\xbb\xbb@\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\x7f\xffstr\x00\x02\x00\x00\xeb\xee\xee\xee\xee\xee\xee\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb\xeb)')
    run_file('tr3(t: typpe): type {\x12return ref conse): type {\x12retur\x10\x00ref cons@ \x96 }#in[)')
    run_file('tn(x: int) { var x = x; box x \x9a(3)')
    run_file('t ref var n(x: int) { va\xff\xff\xff\xff= x; box x }(3)')
    run_file('tn(x: (x: in}d\x00\xe3\xc0var x = x;\xff\xffox(3)')
    run_file('tn(x:!i .a { var xtn(x:!i .a {  =\x17v;7b]ox m\x0b}x }\xe2\xe2\xe2\xe2\xe2\xe2(3)a {  =\x17v;7b]ox m\x0b}x }\xe2\xe2\xe2\xe2\xe2\xe8\x033)')
    run_file('yn(\x00\x00 in(1,) van\xa5x: ix; sox x \xdf(3)')
    run_file('"\x06(a)"/?)')
    run_file('bhIulw {\n    mmmmmmmmmmmmmmmmm    fn (): e {kkkk         mo\ndule  {-ce m {\x80\x00\x00\x00st x (1() m { cons\x93 x = SSSSSSSSSSSS')
    run_file('(new\x00"w\x0e"1 -= ))1 -= ))')
    run_file('};')
    run_file(' array\nc;\x88\x88\xa0 \x7f')
    run_file("9 switch ''''''''D''''''''',''\x00\x02cadch  u\x13\x85'\xdc}*e\x00\xffh uzat[h S\x85'\xdc4(\x1b\x05")
    run_file('\x7f module @\x07|9 ~\x8cp\xa3\xc2ppp\x05\xff while \xff\x05p\x00\x00 \x8b')
    run_file('3 dule {\n       \x10fo (): module\x00\x00\x00\x7f  \x01        module m { cons}\n            return m\n     \x00\x80\xff\xff().x\n    }')
    run_file('N \n3 \x0c\x80 \x1b$\x101')
    run_file('module k\n        fn E): mo case dule {\n            moduoe m { X   r          module m { X   return m\n        }().x\n    }')
    run_file('"\x80\xff\xdb(" @ \x1f\x85lo"')
    run_file('"h\xc5\xc5\xc5" + "lllo"')
    run_file('"\xe3\xc3\xc3\xc3\xc3\x02\x00\xc3\xc3\xc3"')
    run_file(' return \x7f!\x7f\x96\x00\x02\x00\xff(A)= \x00< \x00\x00\x00\x7f \x7f\x96\xfc\xff\xff\xff\x80=\x95\x80=q<_]L= \x7f\x96\x00\xff\xff\xff\x7f\xff\x80=\x7fD')
    run_file('"he\x1c\x1cB+  while +  while\x1c"ll"he\x1c + \x0cl\x81"')
    run_file('"\\\'he" +\xfe!llo"')
    run_file('"\xdb\xdb"')
    run_file('module {\n        fn (): module {\n \xd3         t x \n        fn (): module {\n \xd3    = 1 }\n    }().x\n    }')
    run_file('module {\n    !!      fn (): modul} {\n            module m { const x = 1 }\n    }\x80\x00\x0b\xff\n    }')
    run_file('module m { const x = 1 }\n  !=  {M            m\x7fdule m { co^^^^nst x = \x00\x80}\n  @ }().x\n :  }')
    run_file('module {\n        fn\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2 (): module {\n            module m { const xe {\n       }().x\n    }')
    run_file('1 r x in 3 { if x==1 { continue }; \x00\x00\x80\x00els\x80 { 5x in 3 { if x==1 { co\xadtinue }')
    run_file('[FO(1,)nion{FOOD BAR}] [BA\xff]')
    run_file("1+  module fulf {\n)   \x1f c\x00\x02\x00\x00 cUll : def in n(): \x80\xff\xff\xff  \x08   co\x8dst'cspyell\n      \x00\x02\x0c\x00il culf {\n    \x1f c\x00\x02\x00\x00 cUll = def op\\\\y = fn(cUll = def in n(): int\n  !! ell()\n  \n }\n    ")
    run_file("1+  module fulf {\n  \xc8 \x1f c\x00\x02\x00\x00 cUll = def in n(): intnt\n  \x08 cell()\n  \n }\n\x02 \n     \x80\x00\x00\x02\x0c\x00il cUll = def\x00\x01n n(nt\n  \x08   const'cxpy): int\n  \x08 cell()\n  \n }\n\x02   ")
    run_file("1+  moyule fulf {\n    \x1f c\x00\x02\x00\x00 c8lld\x00\x05\x00ef io n() fulf & int\n  \x08`  const'cxpyell\n  H   \x00\x00\x00\x10il\x05\xff\xff\x05\\\\y = fn(): int { rc\x00{{{{{{{{{{{{{{{}n n(): in\x8d\n  \x08 ce\x03\xe8()\n  \n }\n    ")
    run_file("1+  module fulf {\n    \x1f c\x00\x02\x00\x00!cUll = def in n(): int\n  \x08   const'c int { rc\x00\x02\x00\x00 cUll = dp\\\\y module fulf {\n  \x07 \x1f c\x00\x02\x00\x00 cUll = def\xb6in n(): int\n  \x08 cell()\xff\x7f\xff\xff \x1f     ")
    run_file("1+  module fulf {\n    \x1f c\x00\x02\x00\x00 cUll = def in n(): int\n  \x08   const'cxpyell\n      \x00\x02\x0c\x00il module {}fn(): int { rc\x00\x02\x00\x00 cUll = def i fulf {n n(): int\n  \x08 cell > ()\n\xbd \n }\n    ")
    run_file('1+  mod -= fulf0{\x04  \x14 \x1f c\x00\x02@\x00 c\x00ll\x19([])f\x01in@nc): \xea\xea\xea\xea\xea\xea\xea \x00\x02\x0c hn(  \xe7\xe7 *=  Mop\\\\z var ()\x17 in }\n    ')
    run_file('AF(); arrat, int A _tree)}')
    run_file('93,i<Q throw QCQQQ\x03\xe8QQe)')
    run_file("(1, 2,dule fulf {\n    \x1f c\x00\x02\x00\x00 cUll = def in q(): int\n  \x08   const'cxpell\n      \x00\x02\x0c\x00il cop\\\\y = pn(): int { vc\x00\x02\x00\x00 cUll = \x00 cUll = d\x85f in q(): int\n  \x08   cdef in n(): int\n  \x08 cell()\n  \n }\n    ")
    run_file('([*\xce(X\x0cD')
    run_file('struct(i6rray;int).slice(1\x7f\xff3)')
    run_file('modul([[[[[[[[[\xcf\x00@d[[[[[[[[[C[\xcf\x00@d[[[[@_[')
    run_file('modul[[\xcf\x00@d[[[[[[[[[[{\xcf\x00@d[[[[[k[')
    run_file('m[ !! [[[[S[[[[\xcf[[[[[k[')
    run_file('([]: array var onion {FOO} array vyr union {FOO}) + \x80FOon {FOO})) +\x01\x00\x00\x00O\x00')
    run_file("[gkO: union ulf { \x08   const' = pn\n    \x1f c\x00\x02\x00\x00\x02\\dcUll = zef in q in int\n  \x08 ?\n }\n    \xd3const' = pn(): nt { vc\x00\x02\x00\x00 cUsl = def\x7f\x00\x95\x00n(): int\n  \x08 cell()\n ?\n }\n    ")
    run_file('[\\OO: union ulf {\'    \x1f cnconst\'\x01xpell\n(true0 !    \x00\x02union ulf {\' \x0c\x00il cop\\\\y = pn():$int { vc\x00\x02\x00\x00 cUll = def [n n(\': struct  inR\n  \x08 cell()\n  \n }[""]\t\xfe   ')
    run_file("int\n  \x08   co\xffo\xffst'cxpellO\x00\x00\xd4union \n  ell\n      \x00\x02\x0c\x00il cop\\\\y = pnf in q(): int\n!\t\x07   \\\\y = pn(): int { vc\x00\xf0 **=  ^ = ): int\n  \x08 ceXl()\n  \n }\n    ")
    run_file(" '. '.. ').2M\x7f\x7f\x000M0M\x7f\x81\x000M\x7f\x7f\x00")
    run_file('[FOOmoduldin finally g_pointer {\n      const x = defer fn(): iNNNNNNNNNNNNNNNNNNNNNNnt\n      const y = defer fn(): int\n      fulfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = \x00\x00\x7f\xff: int { return 3 }\n    }\n    ')
    run_file('[F[FO\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3ert assdr` (falsH\x02!!B(fahsH\x18 "!!!!"\x16')
    run_file('    module intf {\n      const intf = fn(): int\n      co\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xdanst k3 = defer intf\n      fn k(x: int): intf {\n        returnint { return x }\n      }\n      fulfil k3 = k(3)\n      k <<     }\n    ')
    run_file('    modul <> e intf {\n u    const intf = fn(): int\n   /  consf tf {\n      const intf = fn():return x }\n     \xeb}t intf }\n     \xeb}t intf = fn\n     \xff\x00ulfi\xb2 k3 = k\x00\x00\x00\x16  C   <<= \n    }\n<   ')
    run_file('[1, \xeb\xff\x7fA] + [$:[$,\x135], 5]')
    run_file('[15 2,dule intf  . fn(): int\n      cons case t k3 =0d dynamic \n      fn k(x: int): intf {\n\x18   0.0    const k3 = de\x80er i \x00\x00\x00\x80 return fn(): int { return x }\n.........6.... }\n    ')
    run_file("mo' ' [d fu ^=\xe36\x00\x01\xff\x7f\x00\x00\x02\x00\x11,]")
    run_file("'\xc9'\x1bH<")
    run_file('2\n>\x00\x80\xe5\xed\xf0\xe5\xe5\xe5\xe5\x01\x00 Q  ')
    run_file('3 * [odule double_fulfil_\xdcorwarding_pointer {\n      const x = defer fn( -- ):@\x00\x00\x00\n    ): int\n #    const y =  int\n      fulfil x = y\n      fulfil\xff\xff\xff\x7f fn(): int { retu\x92n 3 }\n      fulfil x = fn(): \n      const y = de  }\n  d\x00')
    run_file("[5, 6, 7, 8].slice(-t'cxpyiqnnn in\xcd\n  \x08 eell\x1f)\nnnnnnnnn.= \x00\x0c\x00il cop\\sy = ln():ef in \xee():  &< in\xcd\n  \x08 eell }\n   +")
    run_file('[5, 6, 7, 8] ;)')
    run_file('[] \n\n\n\n\n]\n"\n\n\n\n\x1d\n {z + v\\\\le7le7{ \x1bssesert } }\x87\x89X &ld\x00\nkzv\x8ce7{}2}\x87\x89X &le\x07{} \x04{} {y\x87\x89\x00:\x00\n\x1d\n {zv\\\\le7l\n\n\n\n]\n\n\n\n\n\n')
    run_file('fn(xay0) { x * -3 }([: array0) \xa3 x * -3 }([])')
    run_file('fn(x: arra\xd80) { 3 * x }([])')
    run_file('fn << (x: arrayL) { -38x==1 {2bWei array0) { -3 x==1  else { aj }) \xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8\xe8} else\x14{ 5 }')
    run_file('Honst (x\xc8 (y: int)) = (b,\x131)')
    run_file('const (x, (yM\xcf\xcf\xcf\xc7)) = (3,>1)')
    run_file('fl (&(&\xc6 ![""]\xc6 tl (.x')
    run_file('fn (i: int) { [3 =    \x156     mon\\\\t\\\\\\\\\\\\\\\x18\\ && \\;\\\\\\\\\\\\\\\x18\\ && \\;\\\\;\\\\\\wn[\xcf\\wn[\x00\x02')
    run_file('print("\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9Hevlc, Worldr\\n")')
    run_file('    module \n   \\to_unf\xff\xff\x7f\xffll\x00    cons\t)t t =0defer \x00\x10\x83e\n   "  5: `\n   \\t}\n  ')
    run_file('fn(): int\n   \x00  constmo\x00\x00\x00\x7f fulfil_\xff\xffpy_of_defen(): int\n      const cell = defer fn():"i\x80t\n   \x00\xff     fulfi\x00\x00\x10\x00py = f\x8a(): int {  = fn(): int { retur. 3 }\n  } new ')
    run_file('\n    module ref2 {\n        var a\xc2= &5\n         module ref2a\n        *a\x00\x00\x00@ }')
    run_file('\n  new 5\n \xd8    &&&&&&&&&&  *a\n    g')
    run_file('\n    module ref4 {\n        var a \xd0 new 5\n    \x17   a\n        *a\n    }')
    run_file('\n     var a = new 5\n\xff\xff\x80\x00   var a = new 5\n        a\n        *a\n    }')
    run_file('\n      var a = new 5\n        a\n  !     *a\n    }')
    run_file('fn (s: struct float (int, int, int, int))  == 1] }((3, 4, 5, 6))')
    run_file('for x in 3 { if x==1 \\ continue }\x1e x } else { 5 }')
    run_file('(\xde\xde\xde\xdecx 3).type')
    run_file('(b\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xceoxx 3).c^nstnes')
    run_file('assert(t\xc2\x02  ref b[oe): int')
    run_file('[FOOd + [BAR: union finJ\xdfly {\n 1    --    / \\z&&\x10\\;\\\x01;\\\\bw\x01[ \\kn[\x00\x02')
    run_file('fn(t: tyOe) { 3: t4}():\n module {\n            \xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdcx\n    }')
    run_file('\n   &fn ref8(x: int): void {\n \xd7 n ref8(x: int    \x1b var a = &x\n        a\n     #  *a\n    }(5)')
    run_file(' never \n    f\xb3\xb3.&= @d6rn ( &&=B1,) }().x')
    run_file("\x01\x00\x15'/ \x15'\x15' if /\x15'/ \x15'\x15'/\xae0")
    run_file('3/n(on\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce(((n(((((((((((((((((((((8(((\x1f(((( (3, con(((')
    run_file('\x00\x00\x00\x00e\xde\x84] \xde\x84]v\xde\x00\x00\x00\x84\x84')
    run_file('fn (): (\xd7truct(Nnt)) { return  true (A,\x00\x00\x00@).x')
    run_file(' box "heV\xd5o"')
    run_file(' new "helc\xd0"')
    run_file('( & +& & & & +& _  & & &(A& & +& . \xcaA&(A(A)')
    run_file('[XOO, kOO(3 ref2 {\n        var a = &5\n        a\n    onst a = ([]: ar int) + [1, 2, 3, 4, 5]\n            var (i, j) = (0, a.length-1)\n            while i < j {\n7             (a[i] a[i])\n              i      }\n            a; i; i\xfa      3 }\n    ')
    run_file('switch FOO(\xca\xcat, 2, thyee &= , 4.0) { case FOO(w, x, y, *  z) {x} }')
    run_file(' typeof \n    fn (): module {\n        module m \xd6 const x = 1 }\n    }().x\n     return module {\n                fn id(x: t): t { return x }\n            }\n        }\n        const m#= make(in )\n        m.iM(3)\n    }\n    ')
    run_file(' ()\n:d *= \x86rr')
    run_file(' ():d *=B[fT (<n ( **\r[ (<g (Byf)\x00d\x00\x04[luI\xc8ule (< lu[f)[lu[l`Ldu D6LS\x00m(<g (B[fT (<g -B[f\x08[ (<g\x04\x10\x00\x00e (|g (Byf)B[f)[lu[lule (< (BCf)[\xff')
    run_file(' (("tr(" ?(("")"|| **  ?= || e= || **  ?= u\xdb e')
    run_file('    module intf {\n      con\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4st intf = fn()Z int\n     f* k(x: int): intf {\n        Teturn fn(): int { retuJn x }\n      }\n      fulfil k3 = k(3 1')
    run_file('[]: array JJ(((\xd1y JJ(((\xd1(((((((8(((((((( (3, con(((')
    run_file(' 0xf\n    ) ar\x94ay\x13v (()\xd2k(x8 i^) ar\x94ay\x13vulfild \x03\xe8r\x94ay\x13v (()\xd2k }\n  0 ')
    run_file('[P] \n\xff3')
    run_file('st( switch " finall\xdd,")(int)')
    run_file('s[1][\xdb[a0R[o[f[1][[[ay0')
    run_file('struct( d\xdafe\x7f\x00int)')
    run_file(" '\xde';; '@/ d@\x7f\xff")
    run_file(' !zstruct(i\xc4t)')
    run_file('(1)\n\xdb\x05r')
    run_file('    module generic_identity {\n        fn make(t: type): module {\xc7            return module {\n                fn id(x: t): V { fn  return x }\n            }\n        }\n     \x0f  const m = make(int)\n        m.id(3)\n    }\n    ')
    run_file('va: (x[[\xcf\x00@d[[[[[k[')
    run_file('[F?O: union {F\xc4O; Bn(((')
    run_file('[FOO:*union {\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xf0\xff\xffOO; BAR}, BAR]')
    run_file('module Lrray_concat_var_dynamic {\n        var\xdcaE= []\n        (a: array var union\x04{FOO}) + [FOO]\n    }')
    run_file('  print \n        fn (): module {\n            modq switch le\xd6m { congt x = 1 }\n  fn (): module {\n  }().x\n    }')
    run_file(' 0.0\n \xaf\xaf\xaf\xaf\xff\x01}\xee\x00\x006\xc6}6\xea&1 4\xf0\x1f\x00\n \xaf\xaf\xaf\x15\x01\x00\x80\x00 ')
    run_file(' ref var [1, 2,\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb 3I["he\\\nllo"]')
    run_file('fn (print, boofn9(print\xd7 bool):l): i')
    run_file('\n   a = ne+ [4, i(""\type_ch eck2 {\n      const ( ^< ype, midtype, supertype) =\n        (array;, array const int, array int)\n      fn         (arraidtype) super >>> typ: y;, array const iype, superf(x: supertype)/ subtype { return []: midtype }\n      cons\x89 g =\x00\x80: (fn(midtype) super >>> typ: midte)\n      g([]: subtype@\n    }\n    ')
    run_file('[""]\n\xff*\xcf\xcb\xcb\xdc\xcb\x7f\x00\x00\x00\xb6\xb6\xb6\xb6\xb6\xcc\xb6\xb6\xb6\xb7\xb6\xb6\xed\x00\x00\xfa/*')
    run_file('switch FO{ cas\xd8 FOO(w, x,,y, z) {x} }')
    run_file('switch FO{ \xddas{ case}e}')
    run_file(' bsx  & &IA&(\xca\xca\xca)')
    run_file(" & array '\xde': '\xde';;:'@/@/ '@/ 1 str Os uer @/;,;\xde';0 '@1 '\xde': *\xde';; / 1@/ 1.0e0 8")
    run_file(' r: (x,) (1\xd9=concat_empty {\n        var x = [ ,) (1\xd9=concat_empty {\n      print ]\n        x += [6]\n    }\n  ')
    run_file(' box  &  (1)=concat_empty[ print ]\n        x \x7f\xff{\n ,) &   var x = [ pri\xe2\x02 ]\n     *! p I= [6]\n  \x8d }\n  ')
    run_file('module { var x = 3;on(false)\xc3\xc3\xc3\xc3\xc3\xc3{\n\x00\x00\x02\x00 module {}   var x ) []\n        x += [6]\n   \x00L\n  ')
    run_file('[[1]]\'\'\'\'\x07\'\'\x1f\'\'\'\'\'\\r\'\'\'\x7fil assert ing\x081)Op array0\x00\x10ynter {\n  \x83\x83\x83\x83\x83\x83\x83\x83\x83\x83x = dNfer fn && in\x8d\n  >>  cTnst y = wefer fn()> lfi\x8c x = \x94\n  defer lfi\x8c x = y\n\t\x1f     lfi\x8c x = \x94\n\t\x1f    fuXfil y =nfn():\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\x0brefst y = weker fn(): f { \\"ret << -\xb6}\n\x1b   }\n    ')
    run_file(' new new * d[[[[[[[[[[[\xcf\x00@d[[[[[k[')
    run_file(' new new *   n *   [[[[[[\xcf\x00@d[[[[[k[')
    run_file(' union array_c_ncat_empty {\n      [[[[[[[\xcf\n      \x00@d[[[[[k[')
    run_file(' while array_concat_empty {\n        v\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xc7\xda }\n  ')
    run_file('        var x = []\n    t\xff\x7f{\n     "  var x =,m]\n        x += [ un\\rion }\n  ')
    run_file('module array_concat_empty {\n\xd0    v[""] = []\n        x += [6]\n    }\n  ')
    run_file(' *+ module fion_type_check4 { true \n[+\xc8[""] [BAR: un; BA+1[\\ unio gn AR}]')
    run_file(" array module \n     c\x81ncat_emp\\'= []\n     *a\xea    }")
    run_file(' new module array_concat_empty {\n\xd4       var x = []\n        x += [2]\n    }\n ')
    run_file(' ( (str,fn?\xcestr, bool): str,fn?\xcestr, bool): int')
    run_file('      var x = [()]\n        x +=\x00\x00\x80\x00\n    }\n')
    run_file('module a_concat_empty {\n      \xcf\xcf\xcf\xcf\xcf\xcf\xcfF= [()]\n    e a_concat_empty;\\\\\\wn[\x00 >>> \xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf`wn[\x00\x02')
    run_file('&4\n &5\xb1 ')
    run_file('  type\nf typeof \xff* 3')
    run_file(' -03; FFRFFFFF\xcaFFFFfFFFFF.1e-0   -0.1e-FFl = 3; FFFRFFFFF\xcaFFFFfFFFFFFIFFx}')
    run_file(' typeof nnqnnunnnn[1\xdb] * 3')
    run_file('    module function_type_check2 {\n      const (subtype, midtype, supertype) =\n        (array0, array const int\xdd, array int)\n      fn f(x: supertype): subtype { return []: midtype }\n      const g = f: (fn(midtype): supertype)\n      g([]: subtype)\n\x1e   }\n    ')
    run_file('1 ? j+(boofn \xd5prm~t,,boo2 : j+(boofn \xd5prm~t,,bool):l): i')
    run_file('    module intf {\n      const intf =Bfn(): int\n    \xd9 const\x00\x00\x00\x01= defer intf\n      \x01n e(x: incon\x00\x00\x00@): intf {\n       2 inurn fn(): int { return x }\n      }\n      fulfil k3 = k(3)\n     %k3()\n    }\n    ')
    run_file('fn(x:\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdcx * 3int -0.\\/-0 @  ref bYoeprprint,  re\xdc\xdc\xdc\xdcx * 3int -0f booint, ): int')
    run_file('~8\n((A\x7f(\x80A((\x80\x00)')
    run_file(" box  & &I\n<array\x00\x80\\'(false)\xd7\xe3\xc3\xc3\xc3\xc3{\n")
    run_file('[ \xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8bo([])] + [][ bo([]?] + []')
    run_file(' typeof module\na_concat_empty {\n   \x00\x80   va\xdb\x00\x04\x00\x00 []\n        x += [\x10\x10\x10\x106]\n% \x03 }\n\n ')
    run_file(' ref module array_concat_empty {\n     fn make(t: type): m\xd9dule {\n            return module {\n                fn id(x: t): t { return x }\n            }\n    *    B }\n        c(x: t): tmake(int)\n        m.id(3)\n    }\n ')
    run_file(' box module\n  \x95 = []\n \xafYr x = []\n \x80      x |= () += rea var int \n\x0c ')
    run_file(' -       module test_ternary1 {\n            const b = \xc9 > 2\n            b ? 3 : 4\n        }\n    ')
    run_file('const () = (moXule {}\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7)')
    run_file(" while !_concat_empty {\n     &  '\xde': '\xde';# '@pointer {\n      const x = defer fn(): iNNNNNNNNNNNNNNNNNNNNNNnt\n      const y = defer fn(): int\n     inter {\n      const x = de y = fn(): int { return }\n      fulfil x = fn(): inb { return 3 }\n    }\n   \n    } ")
    run_file('module { [(& + A[(& + & &(18& + & 0(A(A[(18& + & 0(A& &(18&\xdb\xdb\xdb\xdb\xdb + &+0(A(A[(& + F\x00\x00\x00\x018A))')
    run_file(' box FOO;5BAR}]')
    run_file(' if le {         fn (): module {\n           \xd0turn m\n        }().x\n1  \x0f}')
    run_file('(\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5      \x00 union op\\= def)? 2 : j+( ulf {\n    \x1f c\x00\x02\x00\x00 cUll = def in q(): int\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5      \x00 union op\\\\y = pn(): in[*/ vc\x00\x02\x00\x01 cNll = def en n(): int\n (\x08 cell()\n  \n }\n  ')
    run_file(' box  mo[|\xc9\xc9\xc9\xc9\xc9\xc9\xde\xe9\xc9\xc9\xc9\xc9\xca-0.\x1a((()C')
    run_file('\n      array var int\n\x1f\xff      }\nNNNNNNNNNNNN      }\nNNNNNNNNNNNN    ')
    run_file('switch FOO(Jnree, 4.0) { case FOO(w,\xd4x, y,w, x,RR: union{FR: union{$\x7f$$$$?$$Y')
    run_file('if!(1\xcc\xcc\xcc\xcc\xcc) { 2 } else { 3if! }')
    run_file('if(""\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7 -- \xc7\xc7\xc7\xc7\xc7\xc7e, 4.0) {')
    run_file('if  ref le {\n    print     \xc3f\x00\x00()[<[[[[  }')
    run_file(' & &I\n<arra(fal\x83h)\xc3\xc3\xc3\xa8\xc3\xc3{    \x00\x00\x80\x00 var \x00L\n\x10\x00')
    run_file('\n *      module nary2 {\n            var b = 1 > 2\n\xc7     \x12     b ?!3 : 4\n        }\n\t ')
    run_file('\n    module t {\n        var a = 10\n        while a > 0 {\n         \xce\xce\xce\xce\xce\xce\xce\xce\xce union \xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce \x1f a -= 1\n            if a\r< 5 { typeo& e }\n            "h"\n        }\n    }')
    run_file('\n    module t {\n   \n   0 }\n    }')
    run_file('\n    module t {\n        var a = 10\n        while a > 0 {\n            a -= 1\n      \xc9     if a < 5 { typeo& e }\n           \x1c"h"\n        }\n    }')
    run_file(' +  module double_fVlfil_forwarding_pointer {\n \xdc    cons \x00x = defer fn(): int\n      const\n      fulzil x = y\n      Dulfil\x01y = fn(): intfulfil_forw }\n   ')
    run_file('(1,)\n   gA( jor B g (Byf)B[f)[lk[lule (< \x1a ;g\x1c( for B g\x0f(Byf)\xff\xfff)[\x80\xffB\xdbfyf)B[f4[\x00\x00\x01\x00ul\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e int \x8e\x8e\x8e\x8e\x97\x8e\x8e\x8e\x8e\x8e@\xc8\xc8 \x06< (B[f)[B@f)B[f)[lfule (< (B@\x00yf)B[f-[\xff')
    run_file('\n    &  module; u {\n        va-= |\x00\x10     a < 5 { \xff\x7fpeo& z })[lu[lule (< (B[f:[\xff')
    run_file('[] *module caotmtonforwarded_type {nst t =\xcaCefer type\n    \x0c const u = (t,)\n      fulfil t = int |     Eul    }\n')
    run_file('fn(x:int) { var x = x; (box x).c *= ness }((3)')
    run_file('\n                  var b = 1 > 2\n !!         b ? 3 : 4\n        }\n   : 4\n        }\n  ')
    run_file('\n        module nary2C{\n    var b = 1 > 2\n  \xde\xde\xde\xde\xde\xde\xde\xde\xde   \n    var  ref const b = 1 > 2\n            b ? 3 : 4 -0.1e-0 }\n  ')
    run_file('________________________________________________\n        moduQe nary2C{\n    var b = 1 > 2\xf6     \n    var b = 1 > 2\n   \x00\x00\x00d     b ? 3 : 4 -0.1e-0 }\n  ')
    run_file('[FOO: union {\xc6OO; BAi}, BAR]')
    run_file('"hel\xcb\xd3\xd3lo f\\t "')
    run_file(' -0.1e-0 \n    }\n    }')
    run_file('\n    module t {\n        var a = 10\n        while a > 0 {\n     \'           \xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdwhile a > 0 {\n         a -= 1\n            if a < 5 {2typeo& e }\n   %       "h"\n        }\n    }')
    run_file('\nNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN;else | B }')
    run_file('\n                \n      defer type\n      const \x84,)\n ')
    run_file('c &=  (~ 8 \xd4\x7f 1)')
    run_file('fn (): (A) { retuSn\xd53 }')
    run_file('fn(): int { return 3 }\n    }\n    ')
    run_file('fn (): ((((((((((((((B(((((((((\xca((((((((((((((((\x7f((((L(((((LSulule (<g (B[f) (<g (B[f)[hu[lule (< true [\xff')
    run_file('1+  77\n            b *= 1\xfb            \xff\xff\xff\xff = 88\n            a[1    a[2]\n      \x1b     b[2]\n   print    a[3]\n   \x1d        b[3]\n        }\n    ')
    run_file('fn(x: array0) { x("") +([]:(((\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4 assert \xc4\xc4\xc4\xc4\xc4\xc4(((((( ((((8(((((((([]:((((((((( ((((8((((((9( ((((8( ((((8(<\t((((((((C("(8(((((((( \x133, co\x00\x00\x10\x00')
    run_file("[ &x:ref var rXai_conca('/'',''''''\tHnr,th'?'''''''''''''''\xc4''''''''\x00\x10'Hnt,th''''''''''('''''''Hnt, gth")
    run_file('[ & 3]\n    }\n    ')
    run_file('[ box 333336]\n!/= }\n  ')
    run_file('[ box union ulf {\n    q(): int\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5      \x00\x02\x0c\x00il cop\\\\y = pn(): in[*/ vc\x00\x02\x00\x01 cUll = def en n(c\x00\x02\x00\x01 cUll = def en n(): pnt\n *\x08 cell()\n  \n }\n   ')
    run_file('fn (): ( ref  void) { retur\xde\xde\xde\xde\xde\xde 0x1 \xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xden [(), ()] }().length')
    run_file('[""][ rox&3333333333334333333[ rox&33333333333343333333333[ box 3].ldng].tt3333[ box\xd63].ldng].tt')
    run_file('fn (): (struct(int)) { retuUn (\xd8, assert ) }().x')
    run_file("f &  '\xc3': '\xde';; '@/@/ '\x00\x02\x00\x00.0e0 8")
    run_file(' array mo[[[[[[\xcf\x00\xcf\x00@d[[[[[[d[[[[\xcf\x00@G[[[[[k[')
    run_file('[ box* &* &byx * &33333333333343333333333[777777777777%77777777777777777777777777777\xc47 box G].gg].t')
    run_file(' 0x1666F - 6666\n    ! mod .a {\n  \x7f\xff\xff\xff {\n      .   - 6666\n    ! mod .a {\n  \x7f\xff\xff\xff {\n      .     module m { con\xf3^^^^^[[[[[[[  }   module m { con\xf3^^^^^[[[[[[[  }')
    run_file('[ box *  module nary24{\n            var b\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3 3 :&4.\n      \x01\x00\x00\x00\n  (   p     b ? 3 :&4.\n      \x01\x00\x00\x00  ')
    run_file(' 0x1666666666666/666866;\xce\xce\xce\xce\xce6&6666666666666')
    run_file(' 0x1666666&666666666610\n  =   \x00\x80while a0 {\n      if a <  { contin &&=             "h"\n        }\n    }')
    run_file('!0x1666666B6666666\n\n\n\n\x00)Q(fzUse,\x13M,\x13 \x1bF\x13M,\x13 \x1bF Z"\x1f')
    run_file(' *   fn ref8(x: inz):mvoid {\n        var x = x\n        var a = \xcfx\n    &   a\n    76777777777777777777777>777   *a\n    }(5777777777777777777777777776877777777777777777777777777777/7777777777877777777)')
    run_file(' void;\xe8')
    run_file('!!0x33 \nmo++9refBvar  \xf3\xf3\xf3 \x00(\x00\x00\x00@ \x0e\xa4 ) urue  ue  conti\xf4\x0cd !!0 ref var  ref nev\x00r \xf3\xf3\xf3\x00\xf3\xf3 \xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\x80\x00\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf$\xaf\xaf\xb1\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xbf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\x9d\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf\xaf \xff\xf8\x7f\xff\x16\x05\xff\xff\x05\x87duU|9c^ullllllllllllllllllllll,llllllllllllllllllllllllllllllllllllllllllllllllullllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllKlllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllnt {\n#    \xf3\xf3\xf4\x04t\xf3\xf3\xf3\xf3\xf3\xf3\x00\xd7\xf3 \x00\x00\xa7continu >>>=  ')
    run_file('!0x33>333333343333333333[\xc5to~ ]-z')
    run_file('3^3^\n3\n\n366666666\x9d\xff\xff\xff\x7f&666666^\n3\n\n366666666\x9d\xff\xff\xff\x7f&6666666666666\x00\x1066666&6666&6666666666666666\x00\x1066666&6666&6666666666166661')
    run_file(' + \n 1 \n 1 ? 2 :\xbe ? 2 : C ')
    run_file(' new fn(a: array int) { a["hello"]\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\x00d\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xa2 union ulf {O: union ulfA{\nell\n      \x00\x02\x0c\x00 cUll = def in n\x00\x00\x10\x00int\n  \x08 cell()\n  \n }\n dynamic     ')
    run_file('\n5% \n5\n(A) \n & 4\xf37       >\n    \x00   *a>    }')
    run_file('&5? 2 :union int_tree {LEHF(\xc4\xc6\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4ee)}')
    run_file('&5? 2 :union int_tree {\xccEAF\\r(); BRANCH(Vnt_tree, int, intVtree)}')
    run_file('&5? 2 :union int_treu {L\xcaAF(); ;RABCH(Vnt_tr:ee,ntVtree)}')
    run_file('1: r( 0& & & +& _  & & &(A& & +& & (A&( str  @& assert &\xda}?+& & CA(A)')
    run_file('module array_concat_ncat_empty {\n        v\xc7r x = []\n   ~       x +=  []\n   ~   }\n  ')
    run_file('IJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJPJJJJJJJJJ ;= s  }')
    run_file('fn(t: type) {}\n    }\n    ')
    run_file("'o'[module function_type_check1 {\n      const \xcbsubtype, midtyp{, supertype) =\n        (array0, array const int, array int)\n      fn f(x: supertype): midtype { return []: subtype }\n      const \x00\x01\x00\x00f: (fn(midty\x01e): supertype)\n      g([]: subtype)\n    }\n    ")
    run_file('3  : int\n  +   ret **\x00drn fk3dn x \xfd\n    # }\n  D   fulfil k t\n      const k3defer \\ntf\n  \xa0 \x8e = fn(): int\n  +   ret **\x00drn fk3dn x \xfd\n    # }\n  D   fulfil k  k3( struct     ')
    run_file('\n5\n \n5\n \n &5\n &!\n 5\n \n\xfc\xfc\x1b\x0b &5\n*\n5\xf1 \n5\n \n &5\n &!\n 5\n \n\xfc\xfc\x1b\x0b &\x14\x14\x14\x14\x14\x14\x14 array0 \x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x14\x145\n*/5\x00\x01! % 5\n/5\x00\x01! % 5\n\xd3')
    run_file('( & module castmto_forwarded_type {\n       c\xddnst t = defer type\n      const u-= (t,)\n      fu **= t = int\n      coWst (v,) = u\n [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[     5: v\n    }\n\x1f\xfe  ')
    run_file('( new bo( new box\xc8\x10 x\xc8\x10 [\x07')
    run_file('3  * []\n\xa0arr.[]')
    run_file('fn(x:void) { }\n  \x7f\xff\xff\xffn  ')
    run_file('*(1&\xdfnt)= arra ** tJ')
    run_file('switch&FOO(three) { e\xe0\x87e {3} }')
    run_file('switch&fOO(three) { else {\xd5}\x10\x00O }')
    run_file('switch defer  FOO(th2 else {3}defer  FOO\xc8three) { else { }')
    run_file('switch FOO(t) { else {\xc6ret\x00\x00\x00\x103} }')
    run_file('switch FOO(tch FO\xd4\xd4\xd4hree) .a  { e}')
    run_file('switch FOO(uhree) .a  { el\xd1e {3} }')
    run_file('switct:*i = (p\xde)\n  3')
    run_file("module ald { var a = [ ! E]; defer a.lenOO: union ulf {O\xc5 uniont'chpell\n      \x00\x02\x0c\x00 cUll = def in ;n():  -=  \x08 cell(\x00\x10  \n }\n dyna int\n\xa0 \x08 cell()\n  \n }\n dynamic     ")
    run_file('uuK=+ union ulf {O: union ulb\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\x08 cell()\n  (1)\n }\n dynamic     ')
    run_file('for x in 3 {[] \xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\x8a\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca3 k[]> 0 {\n         \t    Y"\n        }\n    }')
    run_file('for x in 3 .a  { \xd3\xd3\xd3\xd3\xa4\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\x00\xd3\xd3\xd3@\xd3x }')
    run_file('for x in 3 { Wf\x00\x7f<=1 { break  x in <=1 { break };e { 5`}; x3 { Wf x<=1 { break }\x1d x } else { 5`}; x } x } else { 5`}; x3 { Wf x/=1 { break }; x } else { 5`}; x } else { 5`}')
    run_file(' box new  module\n        var x = []\n\x03\xe8        var x = []\n     \xfd\x1f x += ref var\x1a#[6]\n  ')
    run_file('\n4\n \n5\n \n &5\n & box 5\n  &5 %\n\x89])')
    run_file('for x in&3 { u\xca\xca\x00\x00\x7f\xff\xca\xca\xca\xca\xca\xca\xca\xca\xb2\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xcan: union{FR: union{$\x7f$$$$$$$Y')
    run_file(' fulfil  typeof  R=        mongth[Ns.ho.l       [V[N][N\xdd.ho.lonjt          [V[N   onjt].lo.longth[Ns.ho.l       [V[N][N].ho.lonjt].lo.yongth[Ns.ho.lonjt].l][N].ho.]. o.lo].lo.yongth[Ns.ho.lonjt].l][N].ho.lonjt].lo.longth[Ns.ho.lonjt]. o.lon')
    run_file(' ref const  [o(\xc6f')
    run_file('" d\xdbnamic ".x')
    run_file('\n        module nary2 {\n   \xd0 d       +  b = 1 > 2\n            b ?Q3 :[]\n        }\n  ')
    run_file('&5? 2 :union intst_concat_dynamic {\n        var a = UUUUUUUUUU\xcbUUUUUU array#const oncat_dynamic {\n     var a = UU    union {FOO; BAR}) + [BAR]\n    }')
    run_file(' 1. % 0e0 ')
    run_file('if typeaf  (1) { 2 } else       var{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{\x85]\n ')
    run_file('1[11[1] ? 2(()) : \xd5 ] ? 2 : d ')
    run_file('    const m = fn (t: type): mxdule {\n        r\xc6turn module {\n            fn id(x: c): t { return x }\n  \x17     }\n    }(int)\n  ')
    run_file('  const m =  module \nbreak }; x } else \x89 5 5 }')
    run_file('tr.r.tAr.r.r.tAr.r.tA*= (~(*~u*-  (~(*-  (~C*-  ( ar\xcbay  (~  (~(*-   ( > ~(*~u*-  (~(*-  ~(~(*-  ~~u(~(*-   (~(*~u*-  (*-   (~(*~u*-  (~(*-  (~C*-  (~\\/  (y(*-   (~(*~u*-  (~(*-  ~(~(*-  ~~u')
    run_file('\n    module ref2 {\n         \xc2             (a[i], a[j]) = (a[j], a[i])\n              i += 1; j -= 1\n            }\n')
    run_file('for x in 3==1 { continue\xc2}; x ():   ro"  }')
    run_file('  t(): module { *etur0retur\n     b3=01 >!2\n   ur\n     b = 1\xde> 2\n        &  b ? ++  3 : 4\n &  b ? 8+  3 : 4\n      b ? ++  3 : U\n   1    }\nXXX')
    run_file('~\\\\\\\\\\\\\\ubbbbb\xff\x80\x00\x00be')
    run_file('[2] *7\n1,+2] *7 else \n3')
    run_file(' ref "h\\ int \xcelo"')
    run_file('for n in 3 {ulejj\nfor n in 3 {ulej\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4j\n    }\n   \x1a }\n ')
    run_file('3.<<2\n     @mkdule {} ?*3 : <<    3\x14  }\n  ')
    run_file('1: fn(){\xd9retur: iretur: int}()')
    run_file(' union {};+KKKK}')
    run_file('-3 -3 \n\n\n\n throw \n\n\n\n*\n != )')
    run_file('-3 *  fn(): int { cell = fn(): int { ret\xc9rn63 }\n    }\n  return 3 }\n      fulfil cell = fn(): int { return63 }\n\x7f\xff\xff\xff}\n    ')
    run_file('module {}\n_\n_yB\xffiB\xed')
    run_file('3: st (Fes\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xc7\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8t (x,)!=x, FesR (FesZ (x.)!=x,)!= (tgree,))!=d(Fest (Fest bool  (x,)!=x, Fest (FesZ tgree,)')
    run_file(' box  & &([]) \n bo\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9r')
    run_file('box\n box  box  & &I\n box\xf2 boxbox\n box  3 \x08')
    run_file('  (ty, (m:l6,)) = (3, \xc81)')
    run_file('if&(1) {  * y\n  obj == 10\n        while a(1,) {\n  "h"\n     \xcearray    }\n   ;}')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b ? 3 : 4\n        }\nonjt].lo.longuc[Ns.ho.l \x1c     [V[N][N].ho.lonjt].lo.yongth[Ns.ho.lonjtF.l][N].ho.lonjt].\xff\xff\xff\x7fongth[Ns.ho.lonjt]. o.lo].lo.yongth[Ns.ho.lonjt].l][N].ho.lonjt].lo.longth[Ns.ho.lonjt]. o.lon')
    run_file('fn (): module\n{ return mreak }; x for x in 3 { if x<=1 { break }; X } else { 5\x18}} else { 5\x18}')
    run_file(' while  typeoflif&(1) { 2 } else {\\c\\ .a \\\\\\lse {\\c\\ .\x0c \\\\\\\\\\\\\\\\\\\\\\\\\\\\_\\"\\\\\x01q\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ .a\x0b\\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\]\\\\\\\\\\\\\\"\\\\\\\\\\c\\ %= \\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\xff\xff\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\:\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AY}]')
    run_file('66 >> 6666\n:\xe9\xff }\n\xff\xff  \xff\xff }\n ')
    run_file('\n    module t {\n\xcdv!r a\x14= 10\n `   b =  ~ 1 > 2\n        &  \x7f ? ++  \x00\x10: 4\n      ^ ? ++  3 : 4\n        }\n  ')
    run_file('\n    module re {\n        var a =*new  5\n        a\n }\n       \xa0    "h"\n    \n        va\n            if a < 5 { cSn\x19    \\\n    }')
    run_file('\n    module t {\n        var a =   "h"\n        }\n    }')
    run_file('fn (): (  defer new  fn (): (  defer new  void) { \xcaetur(true) () int .length\x10oid\x01fn (): \x0b  defer new  fn (): (  defek new  void { r}(1)')
    run_file('* &5\n  &5 \x80\x005\n 5\n \x00&5 \x80\x005\n ')
    run_file('\n typeof 5\n \n5+ \n &\x87\n  5 &5  + %\x00\x00\x00\x80')
    run_file(' 11.0e39 /.0e39/2.')
    run_file('\n   var a= new 5\n   a= new 5\n   \x10    a\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\x00\x00\x00\x10\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\xbe\n ')
    run_file('\n   var a= new K\n   a= ne\x94 5\n   \x10    a\n ')
    run_file('\n        module nary1 {\n            const b = 1 > 2\n            b ? 3 : 4\n        }\nUll = d\xff\xff\x80\x00n n\x00\x00\x10\x00int\n. \x08 cezl\x00\x80\xff\xff \n }\n dynaqic \x08   ')
    run_file('&5? 2 : k383V[N          [V[N][N].ho.lonjt].lo.yongtj[Ns.ho.Uonjt\xde.jt].lo.yongth[Ns.ho.lonjl][N].ho.lonjt].lo.longth[Ns.ho\x15lo % njt]. o.lon')
    run_file('[ new new 3]\n; ;[] int  *= ]')
    run_file('fn (): (struct ant (\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\x00\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xd4\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9int)) { return (1,) }().x')
    run_file('co>   co>   struct () + nrt >   struct (!!\xd3struct () + nrt >   struct (!!\xd3')
    run_file('+oe666(!mod666( *6666666666%66626666666666666( * int))*66 << 6666666626( *6666666666666626666666666666(*6666666666666626666666666666(666666666666:66( *  * i * int))*66 << 66666666666666663:66( * int))*66 << 6666666626( *6666\xc966666666626666666666666( * int))*66 << 66666666666666666:66( \x0c  * i * int))*66 << 66666666666666663:66( * ind))')
    run_file("const (a,) =  fn (): modul/ '\xde': '\xde';; '@/@/ '@/ 1.0e0 8@/@/ '@/ 1.0e0\n    (   fn (): module {\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; 'odule {\n FOOe {\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; 'odule {\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; '@/@/ '@/ 1.0e0 8@/@/ '{\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; 'odule {\n FOOe {\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; 'odule {\n #OOs uer @/;/;~';; '@/ '\xde': '\xde';; '@/@/ '@/ 1.0e0 8@/@/ '@@/ 1.0e0\n    (   fn (): modulF {\n FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; 'odule {\n FOOs uer @/;/;\xde' cfnst '\xde': '\xde';; '@<@/ '@/ 1.0e0 8@/@/  \x00\x00\x001.0e0 ")
    run_file('const (x, (y: i.t)) = (ty\xcaee, 1)')
    run_file('[[1]]\n      uce cat_ >>>= empty {\n        var x = [[1]]\n        x += \xff\x7f\xff\xff    }\n  ')
    run_file('fn (): arrFy0 { \xc2eturn [] }(H.len(a)')
    run_file('fn(x: int) {_ }\n    }\n    ')
    run_file('fn(x: int) { (box x).type }\n   6]\n    }\n  ')
    run_file('(1, ( prer, ( prer (defer prer (un[defer prier (unir (uRN={FO\x01\xdf\xdf\xcc\xe1\xdf\xdf\xdf\xdf\xdf\xdf\xdf r')
    run_file(' defe7 (struct(inct(int) (struct(struct(inct(in\xde) (struct((struct(int) (struct(ireturn struct(intB (struct(in((struct(int) (struct(ireturn struct(int) (struc <> t(int).x')
    run_file('[\xce][ [3]\xd7N fn .lobjt].lo.lona = 10\n ')
    run_file('  com = fn (t: type): ule {\n           ;55555555+55555       fulfil\xc5x = fn(): int { return 3 }\n if&(1) {  array var  fulfil y = fn(): bnt { return 3 }\n      fulfil x = fn(): int {    }\n@')
    run_file('\n5* \n55* \n5\n \n &hN  type array0 NN\xff\xff\x00\x80N\x01\x0bNN\x00dNRNNNNNNNN\x1a/= *NNNN6NNNNNNN\x00\x01NNnNNN\x02\x02\x02\x02\x02NNNN+NNNNN\x7fNNNNNNNNNNNNNNNNNNNN@?NNNNNDNN[NNNNNN;ellNN\x00@ZNN\xcdN;{{ \x15 }')
    run_file('            \n      defer type\n   array const  defer type\n      const u-=       const \xb7-= (t,\x15\n ')
    run_file('      ref const    defer type\n O array cons try fe\x90 type\n   ')
    run_file('      ref const        ref const    defer type\n O arrOy rOy ]onsefer type\n defer type\n O arrOy rOy ]onsefer type\n   ')
    run_file("if&(1) { 2 } else {if&(1) {if&(1) {\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda&(1' { 2 3  2ls } else {if&(1)  3 ")
    run_file('    const m =S\n   \x80\x00       fn id(\xe7: t): t { retur[ x }\n   ')
    run_file('fn(x: array0) { x * -3 }\n\xfd\xe9\n\n\n\n\n\n\n\n\n\n\n\n\nu(*E  (~g\x8c~ue')
    run_file('if!(1) { 2 } else {    var a = new 5([])\n    a\n   \xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7 - \xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7     *a\n    }')
    run_file('module foo {\n        module m { const x = 1 }\n        m};\n            reVuRn\x03\xe8\n  \x00\x00\x7f\xff  } / ().x\n 8  }')
    run_file('fn ():   modbconcat_eoncat_empty {\n        var*x = [\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce]\n        x +var*x = []\n   \x1c    x += [6]\n    }\n      var*x = []\n        x += [6]\n    }\n  ')
    run_file(' 1.&+ 8e0 ')
    run_file('for x in 3 { if x<=1 { break }; x } \n        var x } [][1]\n   retu in 3 { if x<=1 { break }; x } \n        var x = [][1]\n   returrn x }\n   ')
    run_file('*box().h*box(\xcc\xef\xd3\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc().h*box(\xcc\xef\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc3')
    run_file(' fulfil  Pm = fn4(t:\xce\x02y_G): moSu')
    run_file('fn(x: array0) { 3 * x }\n            var b = 1 > 2\n            b \xff\xff3 :()\n    box }\n  ')
    run_file('\n& 0x1 \n))')
    run_file('  var b = 1 > 2\n  b = 1 > +  0\n     \xad("") ? K*= 4\n')
    run_file('fn (): str { ret\xd4rn&"nplace1 {\n         var x: array const int = []\n        x += [6]\n        z\n    }\n    ')
    run_file('fn (): module { rlturn\xc7array  module {       return : module { return array  module {       return module le { return array  module {  array  module {       return module le { return a  \n  module}(i(())nt)\n ')
    run_file('for x in 5555555 { break }; x fo66686666626666666666666( * iind))')
    run_file('[] *1\n { x * \x1f\xef\x1f    ')
    run_file('\n        module nary2 {\n     +        \xc2======\xd6===var b = 1 > 2\n            b ? 3 :&4\n        }\n  ')
    run_file("if&(1) { 2 } else {\xcef&(1) {if&(1) { 2 } els } else {if&(1) {if&(1) { 2 } else {\x00 &(e {iv&(1' { 2 3\x13 2 3 ")
    run_file('3 << 3\n\xc2\xc2\xc23')
    run_file('switch F { case XOO(w, x, y,\xd6, x, y, z, y,w, x, y, z) {\x7f} }')
    run_file('for x in 3 { while 1 { break };!x  } else {  \xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce[]\n    \x7f   x  = [6]\n  A0}\n ')
    run_file('1  .a8?  * 2 : j+( v 7.a\xcc?  * 2 : j)\n')
    run_file('[5, 6, 7, 8].slice\n      }ef  + const new 5\n        a\n  falle *a\n    }')
    run_file(' fulfil [5,8\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb array const \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xde\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb].sl = 3; Funion{$\x7f $: unk$$$\x00\x00$ +pc\x00iBQR\x00\x02 unioP{FR:  union{F6: enion{$\x7f \x08: unk$$$$$$ &pc\x00iBQRR: union{FR\x00\x01union{$\x7f$$\x04$$$$union{$\x7f$$$$$$\x15Y')
    run_file(' box module y_cm {};\n          return arra    rra        }().x\n   ')
    run_file('["]9,!swit\xcdh 3"] * 7')
    run_file(' defG7 (t(struct(inct:int) (struct((struct(int) (struct(ireturnuct(int) (struct(io((struct(int(struct(inct(int) (struct(struct(inct(int) (struct((struct(int) (struct(ireturnuct(int) (struct(i\xdb((struct(int(int) (sgruc|\x18ireturx struct(int) (struc <> t(int).x')
    run_file('6666&66%6\n66 >  -0>!0x33/3330   -0>1e-0    -0>!1\x1c\x7f\xff\xff3330   60>1e-0 ')
    run_file('\n! -0  \n  \x00 var b =       mo\x00\x00\x00\x01 naay var\xa0b = 1 > 2\n\n    var\xff \xfd\xe9  \n     # \n   \x00var= 1 > 2\n     \x02    \x0c3b ? 3\x01: 4 -0.1e-0 \n\x0c  ! }\n  ')
    run_file('& new GNN3NNNNNNNNNNNNNNN\n    }\n\x04\x01\x00\xdd')
    run_file(' while FUO(thile A \x00(t) {\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc) {  =\n')
    run_file('1 (1 \xdb1)?.5 .lng[Ne.l].lo.l/n')
    run_file(' new  & &  & & new  & &  & &I\n bo\x00\xea\xff\xff box,  & &II\n b')
    run_file('     module count {\n        va\n            if a < 5 { continue }\n  \xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf          "y"\n        \\\n    }')
    run_file('18> 2 &true; int)')
    run_file(' new  &true;?() t)')
    run_file(' if lefn() { return typcL **\xcen };  i {ux ux u }% 3 [ if lefn() { return tynt }\\/ eu }\x01 {5co)"ntinux u }e\x1c}; kn  \n [ ')
    run_file('\n     return [(), (: i\xddt { return 3 }\n      qulfrn [(), (: int { return 3 }\n      fulfilturn 3 }\n    }\n ')
    run_file('\n  new *   new 5\n   a= neT 5 /= \na\x00\x00\xff\xff\x00\x00[]\x00\n  \x10\x10   \x10 \x80\xff\x03Y\n ')
    run_file(' ! (tr,*fn ((\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb *= \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb()r,*r,*boyZ):ool): p((\xdb)')
    run_file("if&(1) { 2 } else  if&(1) {if&(1) {ls } else {if&(1) {if&( el\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdd\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdcse {\x00 &(e {iv&(1' { 2 3f&(1) { 2 } else  if&(1) {if&(1) {ls } else {if&(1) {if&( el\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdd\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdcse {\x00 &(e {iv&(1' { 2 3   2ls }\x00 lse {if&(1)  3 ")
    run_file('\n   new.5\n \x0f     *`\xee  \x0f     *`\xee <<     }')
    run_file('[FOO: union {FOO~~~~~~~~~~~~~~~~~~~~~~~~~\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4~~~~~~box *  box  & &bo[ box * * 433[ bbax * &box *  box  & &bo[ box * .t')
    run_file('f: module { return array  module {       re\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8    retprn module le { retu  }\n    }(int)\n  modn (): module { return array  module {       return : module { return array  module {       return module le { retu  }\n    }(int)\n  module}(i(())n\x00\x00\n ')
    run_file('[5, 6/ 7, 8];slice(3,type): modul{\x0c      [5\x05\x05\x05\x05\x05\x05\x05\x05&\x05\x05\x13\x05\x05\x05\x05\x05\x05\x05\x05\x05\x05\x05\x05$dynamic {\n@     \xfe  }(\x01\xd6t)\n   (i~t)\n   ')
    run_file('for x in 3 { if x\xd3=1 { bd\x00\x00\x00 for x in 3 { if x==1 { break }; x } else { return  5 }}; x (v,) = u\x17\x00 for x in 3 { if x==1 { bd\x00\x00\x00 for x in 3 { if x==1 { break }; x }\nj\n     (v,) = u\n      5: v\n    }\n ')
    run_file('if!(1) {.2 };else {    5([])\n        *a\n   *a\na ref vAr ( few [)]\x00\x80\xff\xff)]')
    run_file(' *p=(pp=(\xd6')
    run_file(' [()]\n \t      x += [6\xff\x80 = [()]\n \t      \xb4 += [6]}\n   ')
    run_file("&     '\xd7'&     'W'")
    run_file(' case  FOL(three) { case FOO(x) {wi\xd4ch FOO(threu) {itch F     \x01\x00\x00\x00    }')
    run_file('[ union ion {      defer type\xde\xde\xde\xde\xde\xde\xdetype\n ;defer type\n   type\n  defer type\n  Wy con(t  defer type\n      const u-=      (t,)\n y con(tWy con(t  defer type\n      const u-=      (t,)\n y con(t  defer type\n array var  u-=      (t,)\n ')
    run_file('module m{\n   x += tpeof  [6]\n  r\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcet  [E]\n   x +- typeofoh  [6]\n  rtypeof  [6]\n  rt  [6]\n   x += typeofoh  [6]\n9 rt  [6]\n   x += typeof  [6]\n  ty  }\n')
    run_file('6|6;666&66666 >>)')
    run_file('defer fn(): int\n (())\xe2co  ')
    run_file(' typeof    & typeof    & &I\n b\x8fx I\n box   |= 9 &I\n<a')
    run_file("const x  =\n\n\n\n'\xde';; '@/@/ '@@Ga/ 8+/ 1of FO dynamic \x00\x00\x00 ';; '@/ '\xde(1)': '\xde';; '@/1=Je0 ")
    run_file('      const intf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n    0.0      return fn(): \x80nt { return x }\n..............\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda.................       int     }  module intf {\n      const intf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n    0.0      return fn(): \x80nt { return x }\n..............\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda.................       int     }\n    ')
    run_file(' [_] * 0333313333333333')
    run_file(' [6]\n  typeof  [6]\n ]\n   }\n  ')
    run_file('    const m = fn (t: type): module \n        }\n    &I\n bo')
    run_file(' while array array const _co_empt9 {\n   7\xc3   var x = [][1]\n        x += [6]\n     fn k(x: int): intf {\n        return fn(): int { return x }\n  *   }\n      fulfil k3 = array &k(3)\n      k3()\n    }\n')
    run_file(' 1.\n&\n\n\n\n\n 1.\n1.\n\n\n\n\n\n\n\x8a\n\x00\x00\n\n\n')
    run_file('~~~*new 5\n .   modqle {}    !!!!!!!!!\x10!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5 *a]\n   ')
    run_file('~~~*new ~~*new 5\n].   modu]3 {}    !!\x9d!!!!(tr\x80\x00)!!!!!!\xa1!!!!!(A)!!!!\x02\x00\xd5\xd5\xd5\xe0\xd5 ')
    run_file('if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {jjjjj\xd3jjjj &= j\n      for n in 3 {jjjjjcjjjjjjjjjjjjQjjjjjjjjjjjjjjWjjjjjjjjjjjjj &= jjjjjjjjj\n      constdjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = f&(1) {if&(1) {ls }  } else {jjjjj\xd3jjjj &= j\n      for n in 3 {jjjjjcjjjjjjjjjjj = u\n      5: v\n   jjjj }\n ')
    run_file('fn(int): int  \n\x00\x80turn 3 }(3)')
    run_file('module m{\n   x += typeof  \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb[6]\n  typeof C[6]\n    }\n')
    run_file('+~~*new 5\n .   module \x81} \xc6\xc6\xf4\xc6 ')
    run_file('F(1:int)\n defer   \x00\x00    fn n (): mod && le m\xff\x82 cgnst x = 1 }\n        (): mod odule m \x83 cgnst x = 1 }\n             -- rn m\x1d        }().x\x00 ')
    run_file('[5, 6, 7,+8].slice;1, 3)')
    run_file('-3 *~*new 5\n \x97 * module {}    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n    }')
    run_file('[]*4*1**4*0 \n      defer type\ndefer type\xc07  array con(t  defer type\n      const u-=      (t,)\n ')
    run_file('3 >>~00')
    run_file('[1] + [6]\n    }\n& ')
    run_file(' & module foo {\n        module m { const x = 1 }\n    1 }\n   \x00\x00\x10\x00\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x80\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x00H\x08\x00\x10\x08n ulf {\n case     \x1f c\x00\x02\x00\x00 cUll = fef in q():-(): int\n \x06\x08 cell()\n  \n }\n    ')
    run_file('[module {}]; defer a.length }')
    run_file('\n    fn ref8(x: int): void {\n        var x = x\n  55555555555555 }\n    }(int): void {\n        var x = x\n  55555555555555 }\n    }()\n')
    run_file(" box \n'\xde';; 'b/@ uer @/;/;\xde'\\/ '@/ *\n\n\n\n\n\n*\n\n\x1a\n\n'\xde';; '@/@/ '@@/@/28 / 1of FOOs u\xaar  const @8;0e0 ")
    run_file('  new false \n    mod]\x1f\r 3')
    run_file('coconst :(\xd9, ( int)) = (\\r3 int')
    run_file('!1.\n\n\n\n\n\n\n 1.\n1.\n\n\n\n\n\n\n\n1.\n\n\n\n\x80\xff\xff\xfe\xfa\x00\x00\n\n\n')
    run_file('1    ;  var x = typeof  []\n    x += @6]\n    \x11     while a > 0 {  while a > 0 {\n\'contHHHTn &&=              \n  "h" >>=     }\n    } >>=     }\n    }')
    run_file("+ box\n'\xde'(1,)\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n3].lqng].tt")
    run_file('; box * &NNNNNNNNNNNNNNNNNNNNNNNNNNNN\nNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNbNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN\x00\x80\xff\xffNNNNN1NNNNNNNNNNNNNNNNNNNNNNNNNNNdNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN continue  var NNNNNNNNNNN;else { 5 }')
    run_file('const f =  struct ();const f =  str\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6ukt (); int int')
    run_file('\n    fn ref8(x:\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7 x:\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7inz):m6666666')
    run_file(' while array_conca4_empty {\n     \xc4  var x[1] = []\n        x += [6]\n    }\n  ')
    run_file('    fn make(t: type): module {\n        return module { 3: t }\n    }\nHHHHHHHHHHHHH\x00\x00\xff\xffHHHHHXH |  = FHHHHHHHHXHXHHFHHHHHHHHH')
    run_file('fn (tr,*fn (t\xc4,*boo(t switch r,4r,*booZ):ool): p(()r,*Bdefer r,*booZ):ool): p(())')
    run_file('struct( )\n  \n }\n  ')
    run_file(' var x = 3; x  = 3; x -=\t1 }')
    run_file('S("")\nrubt\\\nZ\xf5ue')
    run_file("3 <\n\n\n\n'\xde';;1of FH < \x10'@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; '@/")
    run_file(' box        \n      defer type\n   array cons=\xa0(t,)\n ')
    run_file('[1> 2]      \n  \xe0 2]      \n    \n defer  < te\n         defer  defer type\n')
    run_file(' ["\xde"]["\xde"]')
    run_file('for x in 3 { x      }\n        }\n')
    run_file('\n     var a =*new[]\n  \x0b \xa05   \x00\x00\x00      *\x00@  oy *o  struct *boy *"&x case &bo.x *\\\n[ box * bbox * &ox *boy *ox *boy \x00\x00\x00\x80 * 4a =*new=]\n  \x0b \xa0    \x00\x00\x00      *\x00@  oy *o  struct\x9a * &ox *boy *ox *boy \x00\x00\x00\x80 * 43 &*x * &oxm*bo\x93 *o *boy * &x \n \'3 &bo.x *o.x 333333[ j\x7f\xff1G].ld-g3 &box o.x *\\\n[ box * bbox * &ox *boy *ox *boy \x00\x00\x00\x80 * 43 &*x * &ox *bo\x93 *o *boy * &x \n \'3 &bo.x *o.x 333333B box1G].ld-g].t')
    run_file(' &  & & *new  & &  & & new  &  & &  &  & &I\n box I\x1d \xe2ox,  & &I\n box I\x1d box,  & &II\n b')
    run_file('tr*= &(AQRR: union{F6: uniontr*= &(AQRR: union{F6: union{$\x7f $: uaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaank$$$$\xc5$ Hpc\x00y +ew &?AQRRM union{F6: union{$\x7f $: unk$$$$$$ Hpc\x00i +pnt\n      }\n ')
    run_file('  array var  typeof    & &I\n b\x7f\xff(I\n box   |= & &I\n')
    run_file('   &[6]\n   }\n')
    run_file('[6.]\n\x1f\xfe  bre\xf5\xf5\xc3\x14!\x01        var\xaex = \x00\x10\n    }\n]\n\x1f\xfe  bre\xf5\xf5\xf5\xf5 \x01        var\xaex = []\n    }\n')
    run_file(" return'\xde';; '@/@/\\b@@/return'\xde';; '@/@/\\b@@/@8 !!  1of FH < uer @/\x00\x15\x00 ';; '@/ !!  1of FH <\x16uer @/\x00\x00\x00 ';; '@/")
    run_file(' dyn [3[!box&33333733343333333333[ box 3]\x00\x00\x01\x00g33334333\xda333333[ box 3].ldng].tt:33\x0173334333\x113333733343333333333[ box 3].ldng33334333J333333[ Zox333333[ box 3]\x00\x00\x01\x00g33334333\xda333333[ box 3].ldn 3].ldng].tt:333733343333333633[ box 3].l=ng333343 ** 33333[ box O33633[ b333333[ box O].ldng].tt')
    run_file(' var a = &5\n        a\n    onst a =&([]: ar\x92ay var int) + [1, 2, 3,\x1d4, 5]\nj - unio false n = 1\n            j - union = 1\n  0         }\n')
    run_file('* new    module intf{\n ;}\n return modu   =}\n')
    run_file(' ref const  ref [[[[[[[[[[\xcf\x00@d[[[[[[[[[[[\xcf\x00\x00\x02\x00\x00[[[k[')
    run_file("+ \n'\xde';; '@/@/ '@@/@/ 8@/ 1of FOOs uer @/;/;\xde';\n\n")
    run_file('    fn f(): void {\nconst x = f }\n    **= g((\xf8   ')
    run_file('fn (s: struct(int, int\xc8 iYt,nt, int)) { s[1\x15')
    run_file(' 0x33333333&3333333333333333333: int\n \xff\x08')
    run_file(' typeof     typeof    & &I\nypeof \xdd @& typeof    & &II\n b')
    run_file('fn (): module { return module {} }()\n  \x01\x00    eturn x }\n  \x17     ]\n    }(int)\n  ')
    run_file('"h 1.0e0 \xcae" +!"llolo"')
    run_file(' while+FQG(thihile+FQG(thile(UlUO(t\xc8) {) {  }\nle(UlUO(t\xc8) {) {  }\n')
    run_file(' box fn(x: int) {5555455555555 }\n\x80\x00 ')
    run_file('[5.8].s[5,8 .sl = 3; FFFFF\xcaFFFFFFFFFFFFFFl = 3; FF].sl = 3; FFFFF\xcaFFFFFFFFFFFFFFFF\xcaFFFFFFFFFFFFFFx}')
    run_file('[[]] ; L]')
    run_file("!0x333333;33333333334 <> 3333333333333333;33335\xde';;'\xde';; 5;/;\xde';;/;\xde';; '@/ '\xde';;'\xde';; 5@ '\xde';;'\xde';; 5;/;\xde';; '@/ '\xde';;'\xde';;;$'@/ '\xde';;'\xde';; 5;/;\xde';; '@/ '\xde';;'\xde';; 5@/ '@/8")
    run_file('fn (): (mod666( *666\xca666666%66626666666666666( * int))*66 << 666?666626( *6666666666266E6666666666(*66666666666666266666666666&6( * int))*66 << 6666666?26(\x0e*666666666666662:666666666666( * int))*66 << 66666666666666666:66( *  * i * int))*66 << 66666666666666666:66( * ind))')
    run_file('""*4*0*011\n*0*$*0\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x181**4\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x18\x181C*0*1**\x00\xff""*4*0*011@*0*0*011*0*1**4*0*0')
    run_file('box  [6]\n    }\n ')
    run_file(' (\xd8: a  G): a < rrY= rrY')
    run_file('\n       var a = 10\n            a -= 1\n     }\n    } }')
    run_file(' ref        \n      defer type\ndefer \x84ypd\n         defer type\n[ tZpe\n      Ponst u-=      (t,)\n ')
    run_file(' * * ( y  \xd9 \x00\x00\x00dbV\x07une g) = (3')
    run_file('\n        module nary2 {\n         \xc8  var b = 1 > 2\n\x00           b ? 3 : 4[1]      }\n  ')
    run_file('\n  new      \n      defer type\ndefer type\n\x00\x00\xff\xff  \x01\xff\x7fdefer type\n[ tZpe\n      Po\x00 t u-=      (t,)\n ')
    run_file("switch FO & O(tlree) { e*se { 1of FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; '@/@/ '@= 1.0e0 8")
    run_file('   var a =*new 5\n      [""]        *a\n        [""]        *a\n    }')
    run_file('if&f&(1) { 2 } else if&(1) { 2 } else  if&(1\xdf { 2 } elsR  if&(1) {if&F1) {ls\x00\x7f  if&(1)else  if&(1) . {if&(1) { array f&(1) {if&(1) {ls  }')
    run_file('[1> 2]  *8\n\xf2\t8x1\x11\x01\x00\t\xfe\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n33333103\x80\x00 b[x&G.\x92')
    run_file(' typeof  typeof typeof( +6666\xc4626666666+(A)6.66666666( * i66666666666( * int))*66666666:6662662666606626666666666666( * int))*6666666666666626666666666666( *66666666( * ind))')
    run_file(' &              \n      defer type\ndefer type\n         defer ty >>= \x8de\nd         \n)     defe defer r typed\x00efer type\n    \x03\xe8   d( defer type\nd   \x1f  efer tVpe\n  tZpe\n      \x7f\x00nst u-=   tZ//pe\n      const u-= \x05    (t,)\n ~ &= f  ')
    run_file('module foo {\n         \xd8ase  m { const | =   }\n        m.\x01\x00    case  m { const x =   }\n     }')
    run_file('"\xcce":* "llo"')
    run_file('switch FOO(th\xdc: int): void {\' \x01\x00     &\\\\\\\\\x00 @v\\\\\\\x03\\\\Ayse {\\c\\ .aM\\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\ %= \\"\\\\\\\\\\c\\\\"\\m\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\\x03\\\\Ay`e {\\c\\ .aM\\\\\\\\\\\\\\ = \\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\a\\\\\\\\\\\\"\\\\\\O\\c\\ %= \\"\\\\\\\\\\c\\\\"\\\x00\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ . &&= \\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\o\x01\\F\\\\\\\\b\\\\\\\\\\\\\\a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\w\\\x03\\\\AY}')
    run_file('[1, 2, 3][1]\n        f\x00\x00(): m\x00\x10ule {nss^^\x00\x00\x00\x80a^^^^^^^([[[[[[[  }')
    run_file('const (x, ( * y: int)) = (three\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3,uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu 1)')
    run_file('switch FOO(4.0) { case FO { zlse {\\c\\ .a \\\\\\lse {\\c\\ .\x0c \\\\\\\\\\\\\\\\\\\\\\_\\\\_\\"\\\\\x01\xdd\\\\\\\x00 @v\\\\\\\x03\\\\Ayse {\\c\\ .aM\\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\F\\ %= \\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AY}')
    run_file(' box  &  &I(A)\n<arra\xff\xff\xaf, ref ')
    run_file('module { var x = 3 }\n     \x03 nninue }\n   ')
    run_file('fn (): array0 { return [] }\n)\x0flength')
    run_file('&     "h"\n        }\n\xe5 \x02\x00}')
    run_file('if&(1) { x * y\n      fulfil y = fn(): bnt { reet\xcdrn 3 }\n  return    }\n ')
    run_file('  new 0x1 \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x80\xff\n\n\x7f\x10\x00\x00\n')
    run_file(' 0x1-\n0x1 \n\nef\xafc ue ue')
    run_file('"c\xde" * "llo"')
    run_file('struct( new i7( *6666666666%66626666666666666( \xd2 int))*66 << 6666666626( *66666666666666266&66666666f6(*6666666666666626666666666666( * int))*66 << 6666666626( *6666664666666626666666666666( * int))*66 << 66666666666666666:66( *  * i8* int))*66 << 66666666666666666:66( * ind))')
    run_file('       var a = ()\n      \xff\x00\x00\x00\x00@ =\x04B0\n   var a\x00\x00= B0\n       var L\xc6= B0\n   ')
    run_file(" typeof \n'\xde';@y>%\x7f9\\'@%Hd)")
    run_file('S([]); x}')
    run_file('fn (): array_concat_empty {\n   []\n \xdfmodule array_concat_empty {\n   []\n      . (1\x0c) [6]\n        var x =\x0b\x00\x00d        (1\x0c) [6]\n    }\n   //fn(): bnt\x00{([]) return 3 }\n ?$   fulfil x&= fn(): int { retur \x00\x00\x00}\n    }\n ')
    run_file('1 % 1 % \n       111111111 == 11111111111111\n            module m { const x = 1 }\n           ()       }(){.x\n   ')
    run_file('fn (): (array void)// rerurn [(), \n)] }(ngth')
    run_file(' fulfil ref8(x:\xc5rnt): void= &x\n ')
    run_file(' box [3[!box&33333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:3337333433833333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:333733343333333633[ Aox 3].l=ng333343 ** 33333[ box O33633[ box 3].ldng333343333333333[ box O].ldng].tt')
    run_file(' -0. %1e-9  % 0.0 -0.1e-0 ')
    run_file('\n8<= 4\n \n"\x0b \x02\xffyyyyyyyyy\x04\x00yyyyyyyyyyyyyyy\n 0x1 \x02\xffy@yy\x00\x00\x00\x80modulQ  >=  &\x00\x00\x00\xff\xff&5 %\n &5\n')
    run_file('for x in 3 { if x==1 { bd\xe2\xff\x00 for x in 3 { if x==1 { break }; x } else { return  5 }}; x (v,) = u\x00\x00 for x in 3 { if x==1 { bd\x00\x00\x00 for x in 3 { if x==1 { break }; x }\nj\n     (v,) =4u\n      5: v\n    }\n ')
    run_file('for x in 3 { if x==1 { continue }; x } \n   x += typ\xff\xff\xff\xffswitch of  [6]\n  rt  [6]\n   x += typeof  [6]\n  ty  }\n')
    run_file(' new "\xd2\xd2\xd2\xd2\xd2\xb1\xd2\xd2\xd2\xd2\xd2he" + "llo"')
    run_file('module a_concatMempty {\n    var x[module array_concau_empty {\n        var x\\\n = module arra\xde_concatMempty {\n        var x[module array_concat_empty {\n        var x[] = []\n    `  #x[]= [ fanal = ly 6]\n    }] = []\n  &=  float     9  x[]= [@]\n   .0}\n[]\n    `  #x[]=![ final = ly 6]\n    }] = []\n     9  x[]= [@]\n   0}\n')
    run_file('* new* new union {FOO}; BAR]')
    run_file('4 &~~~~~*new 5\n     module {}    !!!!!!!\x15!!!!!\\t!!!!!  module {}    !!!!!!!!!!!!!!!!!\x10\x00\x00\xe0!!!!!!!!!!!!!!=!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\x05*a\n   ')
    run_file('   var b =  0.0 \n!!          b ? 3 : 4\n  R     }\n var \n!!\x16            }\n  ')
    run_file("  box\n'\xde'\nbox\n'\xde'*\n\n(false)\n\n\n'\xde';; '8/@/ '@@/@/ 8@/ 1o\n")
    run_file("  box\n'\xde'\nbox\n'\xde'*\nM\n\n\n\xff\xff\xff\x80\n\n\n'\xde';; '8/@/ '@@/@/ 8@/ 1o\n")
    run_file("  box\n'\xde'\nbox\n'\xde'*\n  box\n'\xde'\nbox\n'\xde'*\n\n\n\n\n\n*-/@/ 8@/ 1o\n")
    run_file("  box\n'\xde' .a \n'\xde'*\n\n\n\n\n\n*\n  box\n*/'\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '8/@/ '@@/@/ 8@/ \n\n\n\n'\xde';; '8/@/ '@@ ref var /@/ 8@/ 1o\n")
    run_file("  box\n'\xde'\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n&'\xde';; '8/@/ '@@/@/ 8@/ Jo\n")
    run_file('defer 3333[ boy&33333333343\xca33333338 _ [ box 3].ld ** ngU.tt333334333333333333343333333333[ box 3].ld ** ng].tt33?3343333433333[ box 3].ld ** ngfn(): int\n ')
    run_file('    module cast_to_unfulfilled_type {\n      const t = defer type\n    t\n    }\n}  ')
    run_file('module m { const x = 1 }\n        m.x\n&  = 1 }\n        m.x\n    }')
    run_file('\n       var b =  0.0 \n !!         b ? 3 : 4\n        !         b ? 3 : 4\n        \xe8\x03  ')
    run_file('[ typeof 6]\nDDDDDDDDDDDDDD}\n')
    run_file('switch FOO(4.0) { case F<O(nnnnnnnTnnnnnnnnnnnnnnnnnnnnnnnnnnnw,\xddx, y, z) {x} }')
    run_file('"le\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4"[1] + "llo"')
    run_file('[1] +["]1] +\xdb"] *  [4,] -["]1] +["] *  [4,  *    * \\\n4, 5]')
    run_file("3: \n\n\n typeof \n'\xde';; 'c?@/\\\x7f9 /3: \n\n@%H )")
    run_file('module array_concat_empty {\n \n        var x = []\n       union odule {}}\n        var x =  >>=      union odule {}}\n  ')
    run_file(" -0. -1e-0\n  -0.1em?7 <> witOh ' ',mo'\x00'[\xff' ',[' 'm\x00\x00 [' 'm?77h ' 'mo'\x00'[]' ',s' 'm?7 <> witOh ' ',mo'\x00'[]' ',[' 'm\x00\x00 [' 'm? _ 77 ")
    run_file('\n    module t {\n        var a = 10\n     a -= 1\n     }\n    }{\n       \x16    a -= 1\n     }\n    }')
    run_file('3 %1 \nO(true)\n\n\n\n\n\x84\x00\x00\x00\n')
    run_file('\n  555555555555555555 << 5555555555355')
    run_file(' typeof()\n  \n }\n ynamic     ')
    run_file('\n   1 >=2\n    \xa0[]}\n  ')
    run_file('     var x = box  []\n            }\n')
    run_file('  +1. +1.66&+ +1.6 +1.66&+ +1.6 +1.6666&+ +1.6 +1.666+ ++1.6666&+ +1.6 +1.666+ +66  ')
    run_file('for x in 3 { continue }; x Lls{ if x==1 { conti  S : 4\n       \xff   b ? defer  S : 4\n        }\n  ')
    run_file('      !! \n!3.\n!\xff\xff\xff\x7f!1.\n\n!1.\x15\n 1x *1.\x16\n\n 1x\xff\xff -3\xff\xff\x1ds)')
    run_file('module Wld { var a = [ ]; defer a.length }')
    run_file(' 1./ 1./  .0/2.')
    run_file(' new     module naryP {\n            var b = 1 > 2\n      }\n  "h"\n        }\n')
    run_file(" ref typeof\n\n\n'\xde';; '@/@/1of FO < uer @/\x00\x00\x00 ';; '@/ '\xde'E '\xde';; '@/1=Je0 ")
    run_file('switch Fj{ case boO(w, x\xdb y, z) {xa \x99')
    run_file('\n    \n\n\n\n\n!1.\n! ! 1.\n\n!1.\n\n!1.343333333333[*b - ox[*b - o*b - ox&33333433333333333333[ bo\x95 3]]&31333433333333[ box 3]].t3333[ box 3]]&31333433333333[ box 3]].t')
    run_file('     fn increment(x: int): int { return x + 1 }\n    ` ircreturn x + 1 }\n    ` i\xff\xff\xff\x7fmejt(3)\n  \x1f }\xf0\x1f   ')
    run_file('"he" \n\'\xde\'*J\n\n\n\n\n*\n\nbox\n\'\xde\'(\n\n\n\n\n\n*\n\nox\n\'\xde\'\x00\x80\n\n\n\n\n*\n\n\n\n\n\'\xde\';; \'@/\n\'\xde\';; \'@/@/ \'@@/ 8\xff\x7f\x00\x00[\n   ')
    run_file(' 1.2 ^ 0e0 ')
    run_file('  print  \n & \n print  \n &5\n &5\n &5\n 5\n print 5BAR]')
    run_file('\n  & \n\n\n\n\n!!1.\n\n! FOO}, BAR]')
    run_file(' box  defer fn(): int\n \xe4\xe4 ')
    run_file('[ & 2] *\n0x1 \n\n\n\n\n\n\n\t\xf5 - \n\n\n\n\n\n\n\n\n\n\n\n\n\n\x10\n\n\n\n0x1 \n0x1 \n\n\n\n\n\n\n\t\xf5')
    run_file(' typeof     \n      defer type\ndefer t\xe1\xe1\xe1\xe1 << \xef\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xf8\xe1\xe1\xe1\xe1\xe1\xe1\xe1  (t,)\n ')
    run_file('    0x1 : int\n\x00 //r\x80tq ')
    run_file(' fulfil  typeof *    55555555555555(tr\xc6e)= []\n        xzz\x04\x00zzzzzz = fn(): int { rety = fn(): int { retururn 3\xfe|\n 3 }\n    }\n\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xe9\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5    ')
    run_file('       var a = +0\n       var a =) {ls }  } else {jjjjjjjjjj &= j\n      for n in 3,{jjjjjcjjjjjjjjjjjjQjjjjjjjjjjjjjjjjjjjjjjjjj\xa2jj &= jjjjjjjjj\n      constdjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = u\nj\n     (v,) = u\n      5: v\n    }\n constdjjjjjjjjjjjjjjxjjjj@jjjjjjjjjjjjjjjjjjjjjjjj = u\n      5: v\n    }\n ')
    run_file(" new  defer fn(): int\n@/ '\xde':@/ \x14\xde': '\xcf';; '@d@I\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91\x91 '@\x00\x801.0e0 8")
    run_file('66 >6 >>> 66\n)"eturY@\xff\x7f\x00"eturY@\xff\x7f\x00\x00n*"" }" }()ng\xff\x7f\x00\x00n*"" }" }()ng }()ngt')
    run_file('fn (): module { retur0rek\xd1r\n     b = 1 >!2\n   ur\n     b =  return       &  b ? ++% 3 : G\n &  b ? ++  = 1 >!2\n   ur\n     b = 1 > 2\n       \x04&  b ? ++\x0f 3 : G\n\x00&  b ? ++  3 : 4\n      b ? ++  b ? ++  3 < U\n   3  \x00\x04}\n  ')
    run_file('(1)\n(F,)\n(\x88\x89\x01\x1a\x00\x00Ht \xff\x05\x10')
    run_file(' -0.&0.1e00  *-0.')
    run_file('F(module {}); BRANCH(Vnt_trpe,  new type  int += VCH Vnt_trpe,  new intVtree)}')
    run_file(' ref  \nmodule \n  HH\x80\xff\xff\xffHH <= HHHHHHHHHHHHHHHHHHH \nmodulee \n    \xe8&\x00va\n ')
    run_file('[]II( d\x7ffer \n\n\n\n\n\n\n\n\n\x00\x04\x00\x00\n\n\n\n\n\n\n\n\nQ\n\n\n\n\x0f\n\n\n\n\n\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\n\n\n\n\n\n\n\nmutatet) + \n   (d \n\n\n\n\x0f\n\n\x1c\n\n\ner \n\n\n\n\n\n\n\n\n\x00\x04\x00\x00\n\n\n\n\n\n\n\n\nQ\n\n\n\n\x0f\n\n\n\n\n\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet) >= \x00\x00\x03\xe8 _       3 \n')
    run_file(' box  & &I\n box\n box  +9\n\xc8box\n box\x00\x80\x00\x00 >\x00\x00conot (subt\n (false)(array0, ar\x8eay const int, array int)\n')
    run_file('for x in 3 { if x==1 { bd\x00\x00\x00 for x in 3 { if x==1 { break }; x } else { returjjjjjjjjjjjjjjjjjjjjjjjjjjj\n      box t (v,) = u\n      5: v\nA   }\n ')
    run_file(' box  & ()\n   box  +\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f\x7f     \x85\n  ')
    run_file("var (x,) =\n\n\n\n'\xde'[1];; '@/@/ '@t - tf = fn(): int\n      conbt k3  ^= fer intf\n  \x10   const - tf = fn(): int\n      conbt k foo     consw - tf = fn(): int\n      conbt k3  ^= fer intf\n      const - tf = fn(): int\n      conbt k3  ^= fer intf\n \x9e     thro  thro      thro  throw fn k(x: int): i{    ")
    run_file('3  >6 >>>-6>>  66 >>>  66 > -0.1e-0 >>>6 >>>  66 >>>  6666')
    run_file("  typeof(1,)\n\n'\xde';; #@/@/ '@@/@/ 8@/ 1of FOOs uer @/;/;\xde';; '@/ 'uer @/;/;\xde';; '@/ '")
    run_file(" new '\xde';; 5@/ '@/8")
    run_file('switch FO{\xcecase FOO(w, z, y, z) { Wetur\n x} }')
    run_file(' box[]\n1]\x0b ')
    run_file('for x in*fo3 {\xdefor x in*fo{\n \xd7   $for!x in*fo3 { Wor x  = []\n  var x[1] = []$        x += [6]\n \n        var x[1] = [] x += [6]\n  \x01   ~   x += [6]\n   4    x\n  }\n')
    run_file(' & module m { const x =&1 }\n        const x = m.    \x13const x = \x9a.x\n  \r }')
    run_file('for x in[mod\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0ule {}] { x5}')
    run_file('Q(3)\n    }\n     ')
    run_file('fn (i: int) { [3, 4, 5, 6][i] }\n  conti\x00\x10\x00    }\n')
    run_file('switch box  YOO(three) {\xc7else {3} }')
    run_file('va: (\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\x94,) .a  = (3,)')
    run_file('"h\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdcQ" + typeof  "llo"')
    run_file('switch FOO( .0) { case FO { switch FOO( .0) { case FO{ switch FOO( .0) { { z += [\xc7\xc7\xc7\xc7\xc7\xc7\xd3\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7    \xc7\xc7\xc7\xd3\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7n       \x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\\t\x17\x17\x17\x00\x00d\x00\x00\x00\x7f\x13\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x1e\x17\x17\x17\x17\x17\x17\x17\x17\x17\n ')
    run_file("  box\n'\xde'*\n\n\n\n\n\n\n\n\nbox\n'\xde'*\n\n\n\n\n*\n\nbox\n'\xde'*\n\n*\n\n\n\n\n'\xde';; '@/@  '@@\x1a@/ 8@/ 1\x00\x00\x00d ")
    run_file('3 <<~~~~*new 5\n     }odule {}    !!!!!!!!!!!!!\\t!!!!!   var @ {}    \x1c!!!!!!!!!!!!!!!>\x10\x00\x00\x00!!\x00\x00\x04\x00!1!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('fn (): str { return "" }\n) / ngth')
    run_file(';box  fn(): int\n      \xcd\xcd\xcd\xcd): int\n      consn \xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdcop\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdcopy = cell\n')
    run_file('[module ]\n        x += ]\n    }\n  ')
    run_file('fn (): (struct(int))\n +  }')
    run_file('for x in 3 { x <<-   x }')
    run_file('\nNN4(int)\n\x00\x00\x80\x04')
    run_file('3 * [6]\n    }\n  ')
    run_file('\n             var b =  0.0 \n!     -     b ? 3 : 4\n        }\n  ')
    run_file('        var a = 10\n        while a>> a > 0 {\n            a -= 1\n     }\n    }')
    run_file('module foo {\n        module m {  var  x = 1 }\n        const x = m.x}\n    \xd9')
    run_file('  print  ("")\n &5\n 5\n j}int  \n & 5\n\x00print  \n &5 n  \n 5\n \n &5')
    run_file('if&(1) { x * y\n     \xd2fulfil y = fn(): bnt { re += tur var \n      fulfil x []= fn():  assert ()(')
    run_file('  1.| \\\n1.| \\\n3')
    run_file('\n        var b =  0.0 \n!    +-     b ? 3 : 4\n   \x03\xe8 \x0b-     b ? 5 : 4\n')
    run_file(' while arrturn9(t_    const intf\xcd= fn()Z int\n      \x01\x00nst k3 = de\x04er intf\n     int): intf {\n        Teturn9fn(): int { retu[n x }\n ')
    run_file('for x in 3 { x } else {5+555555555 }\n55*55555555455555555 }\n')
    run_file('if ulsq(()\xc8\xc8\xc8\xc8\xb1\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8) { 4 }')
    run_file(' typeof int\n): int\xf28')
    run_file('""*4**4**4*0*0')
    run_file('   var a =*new  5\n        a *=    1 *a\n    }')
    run_file(' & (1, )\n= ,)')
    run_file('   -0. -1e-0   -0.1e-0 !=    -0. \n   array const  defer t\x80\x00\x00\x00   ')
    run_file("*&box'\xde'*\n\n\n\n\n\n\n'\xde'\nbox\n'\xde\x0f\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '8/@/ '/ So\n")
    run_file('11. *+93.3**1. ;  typeof typeof array c{}onst    typeomodule {\n      if(j: t): t { retur\x85 x }\n        }\n    }(int)\n   ')
    run_file('module a_concamodule {}\n        var x = []\n   x = []\n        x += [6re\x86 var  ref var \x04 <,= \x00"*e} v@e\x02 ref var  7ref\x17vap\x19 ref;ref var   var \x00 &  ref var  rxF var \x04\x00 *\x00\x10 &  ref var ar \x00 &\x12 r\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5\xa5var \x04\x00 *\x00\x10 &  ref var box  \x00"*3')
    run_file('[(1,)]\n    var \x00\x00\x03\xe81 > 2\n          \x0c3b ? 3 : 4 -0.1e-0  \n \x1d  for b = 1 > 2\n     }    va\xef \x10 = 1 > 2\n\n    var b =(1 > 2 + J     \n\x1czzzzzzzzzzzzzzzzzzzz\xcezzzzzzzzzzzzzzzzzzzzzzzzzzzzzxzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\x87rzzzzzzzzzzzz\x83zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz += zzzzzzzzzzzzzzzzzzzzzzz\x8czz      \n    var b = 1 > 2\xf0          \x0c3b ? 3 : 4 -0.1e-0  \nvab\x80= 1 > \n    var b = 1 > 2\n          \x0c3b ? 3 : F -0.1e-0  \n \x1d  for b = 1 > 2\n     }    va\xef \n\n    var b =(1 > 2 + J     \n\x1czzzzzzzzzzor b = \x7f\x00\x00\x002\n     }    va\xef b = 1 > 2\n\n    var b =(1 > 2 + J     \n\x1czzzzzzzzzzzzzzzzzzzz\xcezzzzzzzzzzzzzS br  for b\x01= 1 array    ')
    run_file('[ - 1,82] * ~~~~~~*new 5\n  /1.0/  1.0+.0/2.~*new 5)\n  /1.0/  1\xdb\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb.0+.\x00\x00\x00\x10')
    run_file('[ 0.0 ] *5\n \n5\nA5\n \n5\n \xf24\n \n5\n 5\n&%\n \n&%\n  ')
    run_file('\n        var b =  0.0 \n!  ! +-     b ? 3 : 4\n >    \x00\x04     b ? 5 :\xff4\n')
    run_file(' * new  "" +  "h" \n : >= : >= )) (foot)) (3, 1 {\n / ')
    run_file('( box S, box box 1, box  O); LEF(ie {\n      const t = defer defer      5: t\n   (): iNNNNNNNNNNNNNNNNNNNNN array var Nnt\n   \x07  const y = defer+fn(): int\n    inally filYYYYYYYYYYYYYt \x88 urn 3 }\n      fulfi  }\n   ')
    run_file('11. **991.11')
    run_file('3/ ~~*new 5\n     \x81odule {}    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n \x18 ')
    run_file('for x in 5555555 ** 55 { break }; x for x in 3 { i].t')
    run_file('(.1,.1&.1, .1, (.1,.1,.1, .1, ))')
    run_file('module array_connat_inplace1 {\n        var x: array const int = []\n         }\n    }(int)\n  module}(i(())nt)\n ')
    run_file('fn () { return 3 }\n +  }\n  ')
    run_file('1\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nonlt u << -\n\n\n\n\n\n\n\n\n\n\n\n\n\x88e ^ \n   )  conlt\n\n\n\n\n\n\n\n\x00\x01\n\n\n\n;y\x88e ^ \n      conlt u << -= (t,)\n')
    run_file('for x in+5555555 { break }; x fBAR\\\n]')
    run_file('3 <~~*new 5\n\x02    mod/*u\x01e {od/*ule {}    - !\x00\x02\x00\x00!!!!!!!!!!\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xc0\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde$$$$$J$$$$$ -= $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ in $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\x7f\xff$$$$$$$$$$$$$$$\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde!!!!!!!!!!!!}   \x00\x80!!!!!!!!!!!!!!!!!!!!!!!!\x00!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file(' typeof "he\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd"  + "llo"')
    run_file("defer typeof  '\xde'*\n\n\nmodule {}\n\n\n*\n\n\n\n\n'\xde';; 0x1 / '@@/@/ 8@/ 1of\x19FOOs uer @/;/;\xde'\r; '@/ 0e0 ")
    run_file(' * q(131+module nary2 { arraq const \n        * \xd2(131+module nary2 { arra4\n            module nary2 { array const \n     \x0b\x04     defer  S :.4\n   }\n  ')
    run_file(' var  * NFTD: union {FOO; FP\xd7}= _ARV')
    run_file(' * NFOO: ref  union {P\xdaO; FOO}=jjjj\n      const (v,) = u\n  const (v,) = u\n      5: v\n    }\n')
    run_file('"h\xd1" + + typeof  "o"')
    run_file('\n              var x = 4\n           var x = 4\n            1 > 2 ? 3 : x\n        }\n\x08 ')
    run_file('&   box     I\n box(1,)\n box     I\n box I\n  array var tree)}')
    run_file('fulfil struct (x,  sw\xc2uct ) = (3\x10 1)')
    run_file(' typeof  array int\n  -     \x04   x: array cons} int\n   \x86}\n   ')
    run_file(' & module foo {\n   const x =!1 }\n        const x =  module m { const x =!1 }\n        const        con\x96t \x85 =  module m { c\x82nst x =!1 }\n\xa0 ')
    run_file('[5, 6, 7, 8].slice(3,1 >>> 5)')
    run_file('[[""]] *1 \n\n\n\n\n\n\n\n\n\n\n\n\n\n\t\xfc\n\n\x85\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\x7f\x00\x00\x00\x02')
    run_file('(">=  &\xd3", "co", "WorlN")')
    run_file('66 >6 >>>-66 >>>6 >>>  66>-W6 >>>6 >>>  66 >>>  66')
    run_file(' typeof fn a (l: array int) { a[" ref const hel\xcdo"] }')
    run_file('   const x = []\n            x: array int\n            \x87: array const int\n       =    x: array var int\n     x: array int\n            x: array const int\n       =    x: array var int\n        }\n ')
    run_file('box !3; x}')
    run_file('[1] +["]1]\xca+["] *  [4,  *  S4, 5]')
    run_file(' 0x1  ?"lhe" ([]): "ll\xc4o"')
    run_file(' &  fn(): int\n      }\n   ')
    run_file('3 *  module t {\xcb\xcb\xcb\xcbr a = 10\n        while a : 0 {\n                 whil\n        va\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcbr a = 10\n        while a : 0 {\n                 while a > 0 {\n         a -= 1\n                while a          if a < 5 { typeo& e }\n           "h"\n        }\n    }')
    run_file('3 * [\n[]] \n [L []] ]\n [L  * [\n[]] \n [L [[]] ]- [')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n            b ?[1]:[]\n     }\n \xd2')
    run_file('switch Foo {\n    t  \xc9 case  m { const x =   }\n        case \\n z co && nst x = \r }\n        m.\x01\x00   \x14case  m { con        m.\x01\x00    caxe  m assert  {"const x;=  m { const x =\xff  } m { const x =   }\n"       m.\x01\x00    case  m { con       m.\x01\x00     m { con       m.\x01\x00    caxe  m assert  {"const x;=  m { const x =   } m { const x =   }\n        m.\x01\x00    case  m { con       m.\x01\x00    caxe  m  m { const x =   } m { const x =   }\n        m.\x01\x00    case  m { con       m.\x01\x00    caxe  m  }\n     }')
    run_file(' if le {sl0FFF5\xcaFFFFl= 3; if le {sl[1,8].s.sl = 3; FFFRFFF =3; iF FFFRDFF = 3;[1,8].s.sl ')
    run_file(' [ print ]\n        x += K6]\n    }\n  ')
    run_file(' "  \xd9\xd9\xd9n"(E)')
    run_file("const (x, (y:*int)) =\n'\xde'*\nJ\n\n\n\n*\n\n\n\n\n'\xde';; '8\x19@/ '/ So\n")
    run_file('if (): (s\xe8\x03\xcdc{}i:t& .a )\n {\xff')
    run_file('switch FO{\xdd\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5 case F-O(w, x, y, X) {x} }')
    run_file('switch FO{\xd5case bOO(w, x- y, z) {xW \x99')
    run_file(' ref const  od666( *66666626666666+6666.66666666( * int))*666666666 >> _ + ( mod66*6666666666666626666666666666( *6 >\\\n 66666666666666:6662662666606626666\xd966666666( * int))*6666,666:6662662666606626666666666666( * int))*6666666666666626666666666666( *6 >\\\n 666666666( * ind))')
    run_file("defer\n'\xde'()\nbox\n'\xde'\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\xff\n\n'\xde';; '8/@/ '/ So\n")
    run_file('fn(x:  bool ) {  }\n   \x1b}(int)\n  module}(i((\n        n(\x88:  bool ) {  }\n   \x1b}(int)\n  module}(i((\n        }\n   \x1b}(int)\n  module}(i(()\xff\xff\x7f\xff   \x1b}(int)\n  module}(i(())nt)\n ')
    run_file('for x in " {\'55 x\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7 in " { 587+  x+555+  x }')
    run_file(' 1. < 0e333333\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x80\n\n\n\n\n\x1c\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xff\x7f\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet) + \n   ')
    run_file(' typeof  0x1\n    fn (): module;{\n         fn0(): module {\n\x80\x00\x00\x00(a) 1 }\n    }().x     < \x0en (): module {\n  \n    }')
    run_file('3 *4*0*011*66 < 6666666666&6 < 666666666?&3 : new  Q\n   \x19    }\n ')
    run_file('( new box 3)\n    fn (): module {\n   1 > 2\n    \xff\xff\xff\x7f  var b = 18>7         \n    fn (): module {\n   1 > 2\n  odule {\n   1 > 2   \n    var b = 1\x16> 2\n            b \x00\x013 : 41-0.1}\n  2\n            b ??3 : 4 -0.1}\n ')
    run_file("  box\n'\xde'\nbox\n'\xde'*(())\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '8/@/ '@@/@/ bo(A)\xde'*(())\n\n\n\n\n\n*\n\n\n\n\n'\xde';0 '8/@/ 8@/ 1o\n")
    run_file('for x in n (t: ty\xdae):\nule {\n   com = fn (t:Ptype): ule {\n           ;5 * 5555+55555 || 55555555555555555555555555 }\n  [""]         ;55555555+55555 || 55 }\n ')
    run_file('31+~~~~~~~~~~~*new 5\n     module {}    !!!!!!!!!!!!!\\t!!!!!  struct jjjjjjjjjjjj\xbfjjjjjjjjjjjjjjjjjjjjjjjjjj\n ')
    run_file('[J,K2]\nct( d\x10fer\x02inttrk))')
    run_file("1 > 2 ? 3 :\n\n\n'\xde';; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';\x19 '@/ '\xde': '\xde' | '@/1=Je0 ")
    run_file(' box 3[99 << 9999999999]')
    run_file('fn(x: array0) {return x }\n      }\x1f   \x00\x00\x00  c\xff\x7f\x00Z k3 = defer ict     k3()\n    }\n ')
    run_file('\n      var a =*new []\n        a\n           var a =*new []\n        a\n      1 *a\n    }1 *a\n    }')
    run_file('[(())] *(1) \n \xb6    defer type\n \x0e    const u-= (t,)\n ')
    run_file('&  struct  k3()\n \xb9 ')
    run_file('module foo {\n \xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xcaif&(1) { 2 } else{ 2 }\n(1')
    run_file('fn((dule \xca ((d \x1f}{* *= ((d }}{  *= ((d }')
    run_file('1 > 2 ^true \n    fn \x80\x00\x00\x00  \n   \xa0}')
    run_file(' while arr:yc_emptq {\n        var x = []\n       tinu} else { 5?&N : new  4\n       HHHHHHHHHHHHHHH\n     TTTTTTTTTTTTTTTTTTTT\xd0\n    var b = 1 > 2\n     }\n  ')
    run_file("+ box\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*555555555555555555555555555\n\n\n\n\n\n*\n\n\n\n'\xde'*\n\n\n\n\n _ '\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\x10\x00;; '@/@/ \n\n")
    run_file('UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU\n struct       k3()\n    }\n')
    run_file('fn (): module {\xc9\xe4\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9  switch drue  {} }().x (): module {  switch drue  {} }().x')
    run_file('\xff)\xf6\xf6\xf6\x13 %  \x00\x02')
    run_file(' swit\x80h t\xb0ue')
    run_file('\x08}\\r}')
    run_file('\xca')
    run_file(')\x90')
    run_file('()\x00\x1c[g\xdd\xf3false \x02\x14se \x02f')
    run_file('@r bool u@r\x825')
    run_file('(A\x1c\\[\xfe\xab\x00\x80 / \xaa \xcf')
    run_file('\xee\xbab\x85')
    run_file(' c f\x02\x00 for \x87ue')
    run_file('ss >>>\x11])')
    run_file('\xe0<')
    run_file('\xf1\xd5\xf1\xef\xd1\xf1\xf1\xd5\xf1\xef')
    run_file('3)<\xd2B\x8d')
    run_file(';\xea! \x18\x11')
    run_file(' \x00-0 """,""\x16\t\x00\x10\x00\x16\x16 \x00\x00\x00\x00""""""""""""&"""""""\x16\x00\x00\xd5\xd1\xd1\xd1\x10\x00\x00\x16\x16\x16""""""""""""""&"""""""\x16\x00\x00\xd5\xd1\xd7\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xed\x10\x00\x00\x00')
    run_file('d\xd7\x00W')
    run_file('\xca\x00\xac\xef\xd9\x0c\xca\xa0\x8d\xa0\xa0\x86\xaf\xad\xb9\xa0\xa0')
    run_file('tr(\x00]I\xb6e')
    run_file(')')
    run_file('t1(1,)] ')
    run_file('{\x7f\xff\x18\xee')
    run_file(' \xcb\x00\x00\x00 >>= HoY\x10\x00\x00\x00\x00\x00 >>= HYY\x18\x00Yd\x10~ seY(faSse)YYY\x13YY\x00/ ')
    run_file(' c/ntw\xff\xff\xba\x00\x00\xff\xff\xd7\x80 ca\x7f\xff \xff# \x82oi\xc7 \xd7\x80 case \xff#\xba 0.0 \xbc\x00\x10\\}\x10\xfd')
    run_file(' 0{\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xb3\xc4\xc4\xc4\xc4\xc4')
    run_file('B= t\x10v`C t\x80\x80l\xfd\xff\x8e')
    run_file(' C\x10Vg.s.cZO|\xfd=\x1d')
    run_file('\xd8\x00 array v\x01\x00##############\x00###\x11##d\x00\x00\x00####')
    run_file(' K[=K[Gi[1\xea\xfeGi\x1b1\x00\xff')
    run_file(" & \x7f\x00\x00@\xe1\xff1''\xc21''\x00\x00\x00\x7f >>>= ' \x00\xf6\xff\xff\xff\xff\xdc\xff\xff\xff\xff\xff\xff\x80\xff\xff\xff\xff\xff\xff\xff\xff\x1a\xe2\x7f'(\x1c(4((\x0f\x0f\x0f")
    run_file('\x1a\x00\x00 \x1a\x00\x00 ref \x00 \x1a\x13\x00 re == \x00-\x00\xe9\xff\x01\xe9\xff\x01\xff\x00\x10\x00\x05\x00\t\x00\xff\x00\x00\x01\x00')
    run_file('module {\n    ; "Yfn \r): \x00\x02{}de \x92\n< \xff\' 4\x00  \x01\x03\xffmoFu^m m(}({ const x   %   \x00\x00\x01\x00 } int    \x00 } ).  \x80).  0    d}\xf4 >>>= )w\xfb r\x81f const    0     \x84e {\n\x00\x80\x00\x00    d\x01- Xo }')
    run_file('module {\n        fn (): module {\n            module m { cons\x01 x = 1 }\n            return\xffm\n        }().x\n    }')
    run_file('modulE\x00\x10\x04\x02       fn (): mod && l cVns\xeb a\xfa\x00\x00\xfa\xeb\xeb\x00\xebulE\x00\x18\x00\x00\x10\x00     gn (): mod & (     & \n    }')
    run_file('module {\n        fn (): module {\n            module m { const x = 1 }   \x00\x80().x\n    }')
    run_file('m  w ref var hile  {\xfd \x00\x00\x7f\xff %    \x8bnst x \x10\x001  const x \x10@\x00 }\n        $  \xff\x7f\xff\xfft\x10/ons \x10 >> \x009 \x10\x001u\x8bn _  ]    }().X\n ++ }')
    run_file('module\x00\x00\x01\xff , ():=m\xaddulens\x7f x\x02\x00\x131\x05\xff\xff\x05\x00 \x7f(     retu\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84\x84rn\x03m   \x0f\x96\x84\x84\x84\x84rn m  "}().x\t    }')
    run_file('module {\n        fn (): module {\n            module m { const x = 1 \x7f\n            return m\n        }().w\xe7    }')
    run_file('("")le  >=    c\x00ngt x\x00  1 }\n\x96    \x1c      WodulS\x15m { const x0=  < }\xfc\x95\x00\x00\x00     #  Wodu\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xca\xcf\xcf\xcf & \xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\x1b\x1b\x1b\x1b\x1b\x1b\x1b\n\x96    \x1c      WodulS\x15 rg arx\n\x04   ~ odule\x15m\x00\x00\x00\xffonsV -}')
    run_file('modul ? \n  \x80 >\x16 fne {\nd\xafm { con\x00\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9 \x00 type re\x00\x02\x00\xafm { conretur\xff\xffm\n \xf9\xf9m\n   $  { co\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9n **= \x00 type re\x00\x02\x00\xafm { conr !! \xff\xffm\n   $ \x00\x00\x00\x7f?).x\n  >\x03}')
    run_file("`  %\r  ;    \x04\x00 array const   \x1f\xe4\xff\xfeCo (1,)1 (A)\x10 %   ;     \x00rue `   ||=  ;\x19  \x00(\xff true `   ;\x19  m \x89nt  \x93eak x\n ?' w")
    run_file(' fn (C: mo\x00jae {\n 1   \x156     mo\\\\\\t\\\\\\\\\\\\\\\x18\\ && \\;\\H;\\\\\xf3\xf3\xf3\xf3\xf3\xf3\xf3\xf3\xf3\xf3\\wn[\x00\\wn[\x00\x02')
    run_file(' fn (C:} \xffo\x00jae {\n 1   \x156   \x00\x04mo\\\x8a\xc7t\\\\\\\\\\\\\\\x18\\ && \\\x1c\\\\;\\\\\\wn[\x00\\wn[\x00\x02')
    run_file('tr  fn make(t: type): mod\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbd\xbdule {\n\x00\x01      return module { 3: t }\n    }\n    ')
    run_file('[\xcd[\xcd\x1d')
    run_file('\n    fn ref5(x: int): void {\n        var x = x\n        var a = &x\n   +=       a\n        *a\n   0}I5)')
    run_file("\x0e''''' \x01*/o !!\x0bz\x00\x04\x01\x00ch $ca\x1d. void'''''''''' \x01*/o !!\x0bz\x00\x04\x01\x00ch $ca\x1d. void  \xa8`p\x10#\x14\xea _ \x7f5\x0b ref chfnst \x01")
    run_file('\n    fn rOf8(x:\xc6i\x16t): void {\n               a\n        *a\n    }(5)')
    run_file('[5, 6, 7, 8].slice(\xda\xda\xda\xda\xda\xda\xda\xeb\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda3, 5)')
    run_file('[6@ 78\x14,),  || 8].s\xfd \xff\xffbc\x8eact\x08ice([3, 5)')
    run_file("[5, 6, 7$ 8].sWQCe(3,\x11@\x00\x00\x00''''!'''''(3,\x11@\x00\x00\x00''''!'''''''@'\xa7''&''\x08')")
    run_file('6\n\xd9\xd9\xd9\xd9\x17')
    run_file('%).\xd7')
    run_file('fn (): (struct(it(int))nt)) { return (,) }().x')
    run_file('fn (): (s > truct(int)\x00\x7f{ return\x05(1,) }(\xff\x00x')
    run_file('fn \n): (stuuc_(int)) { ,) }().x')
    run_file('fn (H (H: (struct(V[t))\x00\x7f ret\x81r \x00) }().x')
    run_file('(\x00||= \x15"")hhhhhhhh\x7f````````````hhh`````````````````\x7f\xffhhh\x89)h\\t\x89\x1b')
    run_file('C\n\xd8\xf9')
    run_file('([])\nWse\x00\x02\xffS`tS`t\x00\x04')
    run_file('"he\xd7\xd7\xe6\xd7\xd7llo"')
    run_file('"hw" + "ll\xc5"')
    run_file('"\xdce" + "\x00,o"')
    run_file(' -[\xce(')
    run_file('"h\\\\e" +~\x8f~~~~~~~ "ll')
    run_file('" array hD >= " + "\xe8\x03o"')
    run_file('1+       module array_repeat_mutate {\n            const a = ([]: array var int) + [1, 2, 3, 4, 5]\n            var b = a\n            b[2] = 77\n            b *= 1\n            b[3] = 88\n     \x83      a[1]\n             b[1]\n            a[2]\n            b[2]\n            a[3]\n            b[3]\n        }\n    ')
    run_file("1+'''''4' m\x86dule ''''repDai_Wut\\\xe8\x03t\x80 {\n\x00\x0c\x01\x0c\x0c\x0c\x0c\xed\xff\x00\x01   \x13    c}ns)))\x7f\xff)))) \x7f\xff\xff\xff t___'______j_______\x82______et) +____ __\x00\x01_et) + K\x1f, ,  \x00\x802   \x1a aL7]\x7f@1    0  1  bL3]\n@1         \x0bb[3]\n     ")
    run_file('(1, (modul\x00\x10\x00\x00unt {\n        var x = 10\n   \xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0  \x0f  a -= 1 0. box     <<        if a < 5 { continu\x01\x00}\n       \x7f\xff   "h"\n\xe8\x03      }\x00\x01   }')
    run_file('(1\xcc (module count {\n        var a = while      while a > 0 {\n            a -= 1\n          \x14 if a < 5 { continue }\n            \x10\x00"\n        }\n    }')
    run_file('struct(in\xc2)')
    run_file('s   module double_fulfil {\n      const cell = defer fn(): int\n      fulfil cell = fn(): int { return 3 }\n      fulfil cel\x00\x00= f\x82(): int { return 3 }\n    }\n    ')
    run_file('[[]: array const union {FOO})d+ \x91FOO]')
    run_file('@FO throw O: un\x00\x01n {FOO; BAR}, \xf9AR]')
    run_file(" >>= -0.1e-0 \x00 ~> ~>'=  ~>'iiii\xefi\xc0ihcon\xffin\r)s ){'=  ~>'iiii\xefi\xc0ihcon\xffin\rs ){ \xffC8 ! \x8a\xfa\r>>= l\x00\x80} \x00\x00\x1a ")
    run_file('a+       module array_repeat_mutate {\n           \tconst a = ([]: array var int) + [1, struct  2,  `  vardb = a\n            b[2] = &&  77\n        b[3] = 88\n            a[1]\n       @\x00   b[1]\n            a[2]\xfa\x00\x00\xfa        while   b[2]\n            a[3]\n        \xfd   b[3]\n     \t  }\n    ')
    run_file('[1, 2,\xd5 -  3]: array0')
    run_file('\\"|1 \x05   \xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\xed\x7f\x00\x00\x00\x17\x7f \xff\xff\xff\x7f !! +#+ +;<#/\x17()+    \x10f[\x10\x02d: \x8eo$ule++++++\x17++\x7f}')
    run_file('py = fn(): i[\xda, fil mopy = fn(): int {module fulfil_\x00@py_of_defer_ct mell = defer opy_of_defer_ct cell = del mopy = fn(): int a re(ct mell =   ')
    run_file('for x in 3 { if x=\x00\x00\x10\x00 continhe }\x1a x } e\x83se { 5 }')
    run_file('[\xe6\xf1\xff\xff, 3] + []')
    run_file('[\xdbe].length')
    run_file('        var x = []\n        x     const x = defer fn(C: iNNNNNN=NNNNNNNNNNNNN\x7f\xff\xff\xff\n      const y = defer fn(): int\n\x10\x00    fulfil x = y\n      fulfilnally g_pointe\x80 {\n      y = fn(): \x00\x00\x92\x00{ return \xff\xff\x80\x00fn(): int { return 3 3 }\n      fulfil x = fn(): int { r\x81turn 3 }\n    }\n    ')
    run_file("3 * modulecd\x00st'const'c\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x9f\x00il cop\\sy = jn():ef in n():  && in\xcd\n  \x08 eell\x1f)\n  \xf2\x1c\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d }\n    ")
    run_file('-3 * [1,\xca]')
    run_file("\x19'\xf2'\xf2.\x03 y\x04\xd7\xf1\xfb\xff\xdf ref \r\x01\x13\xd8(\t\x04\xd7\xf1\xfb\xff\xdf ref \r\xf1.\xdd\xdd\xd1\xdd3\xdd\xdd\xdd\xdd\xdd\xdd\xdd{\x00\x00\x00\x80\xdd\xdd\x03\x7f")
    run_file('[5, 6, \xc9, 8].slic += e(3, 5)')
    run_file('fn(x:\x05arra break y0) { }([])]\x00')
    run_file('-3 \n\x1f\xf6+]\n>\x7f -\x0f/+\xd8\xe5')
    run_file('fn(\xc4\xc4\xc4ar(())ray0) { 3 * x }([])')
    run_file(' f[\xc2\x00@  f[\xc2\x00\x00\x1b')
    run_file(' str\nP\x7f\xff\xff\xffe\x0f{ co  0y1 <\xf02G\xff\x7f@\x00\xf1')
    run_file('module { co\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\x01\xdd\xdd\xdd\xdd\xddnst x = 3; module foo { x -= 1 } }')
    run_file('if (\xd6) { 2Cy else { 3 \x7f')
    run_file('if (1) { (A(\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca +\x01& &(A( >>>>?=A)')
    run_file('1 ? 2(\xf2')
    run_file('1   &fn ref8(x\xda int): void {\n      Ln ref8(x: int   var a = &x\n    7   a\n    0   *a\n    }(5)')
    run_file('fn (): array0 { r\xd1tu    const intf  / = fn(): int\n   fer intf\n      fn kt intf  / = fn(): int\n   return fn(): int { retur    const k3dn x }\n      }\n      fulfil k3 =2k(3)\n   0.0 3()\n    }\n    ')
    run_file(' type \n         i (true\x1d   if a\x00\x01ont\t@us  A       \x00\x00K 5\x0c{\x10ront %=  })\x9e\xb0\x9e\x9e\x9e  }\xc5\xc5\xc5\xc5\xc5\xc5\xc5\n ** n')
    run_file('module  foo {\n   1;}\n  ]     m.x\n    }')
    run_file('module foo {\n        modul//>=   count   ` @=  %=  2 5 { cont\tnue  A       \x00\x00\x00\x00"\n \x01       i (true)   if a cont\tnue  A       \x00\x002 5\x0c{\x0fro\x84t\tnue })   **= }\n  * }')
    run_file('fn (prin5, b\xdaol): int')
    run_file('fn(tt (x, (y: in finally t)) = (theat_mutate {\n  nst a =8([*/ array \x10\x00\x14 int\x0f:+ [1, 2, ,, 4, \x13\x7f\x8a     \x08      var77\n         \x10\x06 b *= 1\n   y[1 type ]\n  ` module {}       \x02b[1]\n         \\2] [2] = 77\n e-b *=  a[3]\n     consf     ')
    run_file('*   module intf {\n      const intf = fn(): int\n      cons\xc6 k3 = defer intf\n      fn k(x: int): i(): int { re  return fn(): int= defer intf\n      fn k(x: i { return x }\n      }\n      fulfql k3 = k(3)\n      k3()\n    }\n    ')
    run_file('\xdc\x00\x01)\xdd\x82\xdd\x82')
    run_file('bodu[[[[\xcf[[\x01\x18\x18[[\\b[(())[(())\x00[c[\xcf\x00@G[[}[[k[')
    run_file('(bo\xc6 3).v^lue')
    run_file('fn(x: inS) { (box x).vbl[[\xcf\x00@d[[[[[[[[[[[\xcf\x00@d[[[[[k[')
    run_file('fn(x: int) { va\xf2 \x95 = x; (box x).value }(3)')
    run_file(' union i{}_\x96\xfa\x00\x00\xfa)')
    run_file('switch FOO(tGree) { cas ** O(\xd0) {1} }')
    run_file('switch FOO(int, 2, three, 4.0) { case FOO(w, x, y, z) \xdaxs }')
    run_file('switch FOO(int, 2, three, 4.0(){}{ case FOO(w, x\xd9y, z) {x} }')
    run_file('switch FaO(in\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\x80\xd6\xc4.0) { case FOO(w\x00\x00\x00\x105y, z) {x}\x17}')
    run_file('switch FOO(int, 2, ,hree\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca, 4.0) { case FOO(w, x, y, z) {x} }')
    run_file('[[FOO] +C[BAG: u\xcd\xcd\xcd\xcd\xcd\xcd\xcdFOO] +C[BAG: u\xcd\xe7\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdo <= "')
    run_file('+ & &(A( + & &\xd7A(&\xd7A( >>>>= A)')
    run_file('tr("tr(" ?(("")"|| \x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8a\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e\x8e')
    run_file(' box     module array_repeat_mutate {\n         \xc5  const a = ([]: array var int) + [1, 2( 3F 4, 5]\n            var b = a\n        = 77\n            b *= 1\n       "   *= "  b[3 a[3]\n            b[3]\n    ] = 88\n            aK1]\n            b[1]\n            a[2]\n            b[2]\n            a[3]\n            b[3]\n0       }\n    ')
    run_file('[1]\nx)\x7f)y).cx\x00\x02tness2)xcx))')
    run_file('fn (): ((A)strYct(i\xc5a nt)) { retmrn (1(while ,) |5).x')
    run_file("'\\f'f\x1f\\'\x80]\x12f'\\f'\x1d\\f'\x1d\x01\x00'\x1df'\x1d\r")
    run_file(' arst (x, (y5 int)) = (l_forwardin finally `_pointer {\n      const x = defer fn(): iNNNNNNNNNNNNNNNNNNNNNNnt\n      const y = defer fn(): int\n     inter {\n      const x = de y = fn(): int { return 3 }\n      fulfil x = fn(): inb { return 3 }\n    }\n   \n \x80\xff\xff\xff ')
    run_file('\n    fn ref8(x: int): void {\n        var x = x\n        var a = &x\n       + \n \xd3      *a\n    }(5)')
    run_file('u:  module double_fulfil_forwarding_pointer {\n      const x = defer fn(): int\n           f\xd9lfil y =4fn(): bnt { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n    ')
    run_file(' neve (ule i | \xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd {\n      const intf = fnh): int\n   = defer intf\n      fn k(x: int): intf {\n        return fn(): i]t { return x }\n      }\n      fulfil k3 = k(3)\n7   = defer intf\n      f     k3()\n    }\n    ')
    run_file('O +O: union {FOO; QARd, B{module f\xdalfGlDcopy_of_defer_ct cell *=  = def`r fn8): znt\n = fn(): in }\n    ')
    run_file('3^struct ef8(x: int) == id {\n        var x T x\n     var a = &x\n       \x0ea\n         \x0ea\n        row \xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa9\xa95)')
    run_file(' retur (qtruct(ifn (): (struct(int)) { rif\x7f (>: (et\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdfurn (1,) }().x')
    run_file('  (~~~(~~~~u*-  (~~~(~~~~u*-\xdb (~g~~\x10\x00\xdb (~g~~ue')
    run_file('ref[\xd3\xd3\xd3\xd3 \x04')
    run_file('~-  module self_fulfil {\n      const \xc4 = defer f %= n(): int\n      fulfil x = x\n      nt || eturn sssssssd\x00\x00\x00sss3 >       x()\n    }\n    ')
    run_file(' 0.0\n1\xff\x7f\x00\x00\x00\x07\xcd\xe7\x7f module \xff\x00G n tr.0\n1\xff\x7f\x00" bty ve\xff\xff\x7f\\rn\x00\x00\x00\x00e faNse  \xdadd  \xa8\xa8(yp\x00\x00BBBB\x00\xe6\x00\x00\xfa0, s,=\xff\xff\xff\x7f\nd \x00   \xff\x7f\x00\x00\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16\x16 c\xa8\xa8\xa8\xb6\xdd\xa8\xa8\xa8\xa8\xa8\xa8 += \xa8\xa8\xbd\xa8\xa8\xa8\xa8\xa8\x93\xa8\xa8\xb3\xa8o\\n =A[""] css  \xa0\nd  \xa8\xa8(yp\x00\x00\x00\xe6\x00\x00%\x10\x00\x0e !=  ')
    run_file("O(  )\n  module fulf {\n    \x1f cUll = def)iS n(): in\x80\x00\x00\x00\x08   c\x01\x00st'cxpyell\n      \x00\x02\x0c fn(): int\x00\x00 cUll < def i box : int\n  \x08\x10cell()\n  \n }\n    ")
    run_file("Y /(): (s4ruc\xc4(int\x0e) { rt'i|t\x0e) { retxretu \x00\x00\x001,) }().x")
    run_file('    const m = fz (t: type): module {\n  \xc9     return module {\n      id(j: t(: t { return x }\n     }(int)\n   ')
    run_file(' new   ( & \xc5(`(A\xb9')
    run_file(' *  fn(x: int): (fn(): int) {\n      re\xc9urn fn(): int { return x }\n \x17  }(3)()\n    ')
    run_file('[] + module t {\n        var a = 10\n        \xc8\xc8\xc8\xc8\xc8while a > 0 {\n         (  a -= 1\n \x13          if a array var  < 5 {       var a\n       \x1f    "h"\n      > }\n\x11   }')
    run_file('[(&[\xd0&X , \x1b, 8].c  &[ &[ - (3,\x00\x80')
    run_file('()\n\xebmodu\\/\n\xebmo\xdbulD {}d\x01\x00le \x00dK;\x00')
    run_file('switch FOO(int, 2, three, 4.0) { case DOO(w, x\xcb y, z) {x} }')
    run_file('co = (3,e continue l\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13\x13lo\xc9, "Wornd")')
    run_file('const (x\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\x00\x00\x01\x00+(y8 int)) = (8, 1)')
    run_file('module\n   bbbbbbbbbbbbbbbbbbbbbb     var\x07_var\x7fdyn\x80mic     var\x12aE= []\n       \xff(a:  z) {x} }')
    run_file(' \n\n\n\n\n true \n\n\n\n\nst_\x90ct \x14 >S >N')
    run_file('fn (): (arr\xcby Uo+ id) \n return [(),  const a(V [int, boql] + [str]\n        a[0]\n        a[1]\n        a[2I\n    }')
    run_file('defer prier (unideffer priernideffer prier (unidefer \xd6')
    run_file('(box 7).vef   = x\n a = &x   *a\n0   }(5)')
    run_file('\n new 1\n 2,  && 3] ')
    run_file('fn(x: int) { vEr x = x; (box x).tadue =(3)')
    run_file(' box W\n\n]\n\n\n\n\n\n\x1d\n {zv\\\\le7le7{ \x0b\xdasesert } }\x87\x89X &ld\x00\n{zv\x8ce7{} }\x87\x89X &le\x07{} \x04{} {y\x87\x89\x00:\x00e\x80\x00e7{ \x0bssesert } }\x87\x89X $')
    run_file('[str]\n \x80\x80\t\x80 >>> r\x00\x80\x83\x7f\x80\x00\x00\x02\x00q\x92\xc7\x80\x80\x80\x80\x80\x80@\x00  >>>[ lvay_ (}e ir\x00y\x8cIoncat\xb9\xb9\xb9\xe2\xb9\xb9ay case _Ionc(f  \x7f\xff\xff\xff]\n\xff\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11%\x11\x11]]\x11\x80e)at\xb9\xb9\xb9*/\xfd\xb9\xb9_t\x94}e ar\x00ay_Io  \x14  \x7f\xff\xff\xff]\n\xff\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11%\x11\x11]]\x11\x11\x8c')
    run_file('module array_concat_dentity {\n        fn make(t: type): module {\n            return module {\n                fn id(x: t): t { return x }\n            }\n        }\n      \xc9 const m = make(int)\n        m.id(3(1,)  }\n    ')
    run_file(' while array_concat_empty {\n\n     \xd1 var x = []\n        x += [6]\n    }\n  ')
    run_file(' *  module fuVfil_copy_of_defer_cell {\n      ll =&defer fn(): int\n     const cell =&defer fn():\xc7int\n      const copy = cell\n      fulfil copy = fn(): int { return 3 }\n      cell()\n    }\n    ')
    run_file(' new[]\n  -  \x9a  x\x1b+= [6]\n     module array_conca\x81_empty {\n        vyR x = []\n  -    0x += [6]\n    }\n ')
    run_file('[()]\n \x00\x00\x806]le aT\x7fon\xe3at_^   x x  x x +=6   .    x\xfd< d2  z +\x00\xaa      x =  0x1  +\x00\xaa[\x16]\n    }\n')
    run_file('  var x = [(A)]\n   \x12  vas x = [(\xf1)]\n        x +[="[6]\n    }\n  ')
    run_file('[FFO: union {FOO; K(((8(((((((B (\xc9,=~on(((')
    run_file('[FFO: union {F\xd4\xd4\xd4FFO: union6{F\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4OO; B(((8((((((\x12B (3,=~on(((')
    run_file(' new &(A\xceRR: union{FR: FRion{$\x7f$union{FR: uni\x00d{$\x7f$$$$$$$Y')
    run_file(' new &union{FR: union{\xdd\x7f$union{FR: union{$\x7f$$d$\x00\x01\x00\x00')
    run_file("1 ? 2 :[[[[[[[[[[[[[[[[[[[[[[[[['\xde': '\xde';; '@/@/ '@/ 1.0{0 8")
    run_file('if f (!) {:2 } else {\x00(!)\x1f{:!)\x1f{!)\x1f{:2 } el\xb4zzzzzzzzz>z:2 } el\xb4zzzzzzzzz>zzzzzzzzzse { 3 }')
    run_file('if str  (1) {(1) {\x00\x10\xe7\xff\x16else\n        var x F []\n    ')
    run_file("666666&666666\n666666S666666666666666t. array va~ alsE ] ; [] + ']")
    run_file('[N][N][\xc3[\xc3longth')
    run_file('[\xd1][N[N][N].lo.looegth')
    run_file('&5\n\xfa\xfa\xfaz\xfa\x7f\xfa\xfa\xfa\xfa\x00\xff /= \xfa\xfa\xfa\xfa\x0e!\xfa\xfa\xfa\xfa\xfa\xfa\x80\x00\x00\x00y var qnt) + [1 never , P, 3, 4\x0b+\xff\x7f\n  \x10\xf5\x1c  new      \x19var (i\x04h-1\x11\n@                  [j <<= n]) <       (~[l], a    za\x87 E = h-1\x05\xff\xff\x05                               \x18a; i; j\n **=  =      }\n    ')
    run_file('fn ((A)(\xc9((A)(A)):   A)):    m\n  ')
    run_file(' typeof module\na_c\xf0ncat_empty {\n  V[]\n      > x \\b+= [\x10\x10\x10\x106]\n%   }\n  ')
    run_file(' box module\n        var x = \xb2]\n          var x = []\n        x \x7f= ref var #[6]\n  ')
    run_file('[]: array JJmJJy[ pr\xe4\xfft ]\n  ')
    run_file('const () = (  \xde\xcdd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdo  caonst () = (  \xde\xcdd\xcd\xcd\xcd\xcdtch <= "')
    run_file('var (x,) =0( new 3con(fNlse)\xc3\xc3\xc3\xc3\xc3\xc3{\n        var x ) []\n        x += [6]\n   \x00L\n  ')
    run_file('()? 2 : j+( ulf {\n    \x1f c\x00\x02\x00\x00 cUll = d_f in q(): int\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5 \xc5\xc5\xc5\xc5\xc5      \x00\x02\x0c\x00il cop\\\\y = pn(): in[*/\\bc\x00\x02\x00\x01?cUll = def en3n\x10): int\n&*\x08 cell()\n  \n }\n   ')
    run_file('if ulsm(()\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd) { 4 }')
    run_file('F6766&66(*~u*-  (~(~~~u\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf<J  (~~~g~~ue')
    run_file("6676&666666666;;66;;'\xde';; 56666O66666\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f\x0f;/;\xde';; 8")
    run_file('    var a = 10\n       \xff\xff\xff\x80le a > 0 {\n   \x15        a -= 1\n            if a \x00 5 { conti\n-= 1\n            if"\n  \xff\xff\xff\x7f  }\x13    }')
    run_file('& box    module \n            const a = (\xff\x7f: array var int) + [1, #, 3, 4, 5]\n   ~       \x1fvar b =a\n            b[2] = 77\n        \x10   b *= 1\n            b[3] = 88\n            a[1]\n            b[1]\n    \xff\x00  \x0e  #a[2]\n     \x19   \x10  b[2]\n   M        \x19print       d   b[3]\n        }\n ')
    run_file('const (x, (y: typeof  int)) = (\xca, n)')
    run_file(' box  & &I\n box  & &H\xff<a\xda\xd3\x00@\x15')
    run_file(' while arr:ycat_emptq {\n      \xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9  \x01\x00r x = []\n       tinu} else { 5 }')
    run_file(" whi  &  '\xde': '\xde';; '@/@/ '\x00\x02\x00\x00.0e0 8")
    run_file(" while !_concat_empty {\n     &  '\xde'( '\xde x = [    x +X\x12[6]\n5   }\n \x13")
    run_file('(\xd2,)=la\n3\x00\xbd for2?')
    run_file('+tOO: union ulf {\n(): int\xc5\xc5 ~ \xc5\xc5\xc5\xc5\xc5\xc5@\xc5\xc5\xc5\xc5\xc5\xc5[](): int\xc9\xc5\xc5\xc5\xc5\xc5\xb0\xc5\xc5\xc5\xc1\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5      \x00\x02\x0c\x00il cop\\\\y F pn( _ in[*/ vc\x00\x02\x00\x1c cUl\x00\x00\x00\x7fdaf  str/*uct int\n *\x08 cell2)\n  \n }\n   ')
    run_file('con(o /co|(o /= \t(\xdb])= \t([])')
    run_file('if&(1\xd3\xd3) { 2 } else {\x183 }')
    run_file('if bbox  (1) { 2 } else{\xc83 }')
    run_file('1 >1\n>= 0 >=  < 4 \x00<9)< .\xe3\x00\t')
    run_file('\n                 var b = 1 > 2\n!           b ? 3 : 4\xa8        }\n  ')
    run_file('1 ? 2 :  module neryI {\n            var b = 1 > 2\n            \xcf ? 3 : 4\n        }\n  ')
    run_file('co|st (x,\xcb(y: i`t)) < (3( 1\x0c')
    run_file('\n        module nary2 {\n        fulfil  b = 1 > 2\n            b ? 3\xdc:\x074\n        }\n\x00@')
    run_file('(1,)\n &&  \x05\xfd\xff\x05g\x9a~ug')
    run_file(' -0.\n-0 n m*  2     }().x\t    }')
    run_file('\n        module nary2 {\n            va\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4b ?[1]: 4\n    #   }\n  ')
    run_file('[   &(A(A[(&\xd4+ A[(& + & &(18& + & 0(A&+ A[(& + & &(18& +  &(18& + & 0(A(A[(& + &\x00\x00\x00\x01(A))')
    run_file('module array_concat_empty {\n         *  x = []\n        x +=0[6]\n  \xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc  }\n  ')
    run_file(' 0x1 \nx <  1 }')
    run_file('module ald { var a = [\xc7]; defer a.lenpth }')
    run_file(' new str\n        fn (): module {   try modulI m { c\x10urn#\xc8\xc8\xcc\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8   \xff\x7f')
    run_file('\nNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNUNNNNNNNNNNNN;else \x10 5 }')
    run_file('+1\nENN\xa5N\xe3W\x1a s\xdaR\x9f\xe1y\x02NN\xe3W\x02\x00\x02\xdaR\x00\x00\x00\x00 s\xdaR s\xdaR\x9f\x00)')
    run_file('&NNNNNNJNNC\n    }\n" ')
    run_file('\nNNNNNN111111111111111111111111111111111111111111111111111111111111111111111111111NNNNNNNNNNNNNNNNNNNNN;e 5 }')
    run_file('\nNNN5N(NNNN)\n \xb9 ')
    run_file('\n        module naryH {\n      \xda     var b = 1 > 2\n            b ? ++  3 : 4\n        }\n  ')
    run_file('\n    module t {\n        var a\xd0\xd0\x80\xff\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0 = 10\n        while a > 0 {\n        +             "h"\n        }\n    }')
    run_file('\n           \n      defer type\n   $  const u-) (t,)\n ')
    run_file('\n           \n    fn (): module\n  \n     1 }\n    }().x     < fn (): modul array var e {\n  \nx     < fn (): module {\n  \n    }')
    run_file('\n    module t {\n        var a = 10\n    a -= 1\n     }\n    }')
    run_file('module { var x = 3; x -= x1 [(0x1 J(NNNN\xd7NNNNNNNdNNNNNNNNNNN\nCNNNNNNNNNNNNNNNNNNNN A\nNNNNNNNar x = 3; x - assert = x1 [(0x1 [(NNNNNNN\x10NNNNNNNNNNNNNNNN\nCmodule {}NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN { 5 }NNNNNNNNNNN^\nNNNNNNNNNkNNNNN; x -= x1 [(0x1 [(NNNNNNNNNNNNNNNNNNNNNNNNN { 5 }NN{NNNNNNNNN\nINNNNNNNNNNNNNNNNNNNNNNhNNNkNNNNNe { var xNNNNN { 5 }')
    run_file(' ! 0\n \x07 </*\xba0\x16')
    run_file('&typeof nnqnnnnnnn[\xdcH] * 3')
    run_file('[""]\n\x00\x86\xff\x00(&\x00\x10y@e')
    run_file(' array module arrap_cqncat_empty {\n        var x = []\n  module {\n   \xc8\xc8\xc8\xc8\xc8\xc8\x00\x00\xc8\xc8\xc8\xc8\xc8rn module {\n                fn id(x: t): t { return x }\n            }\n        }\n        const m = make(int)\n       -m.id(3)\n9   }\n ')
    run_file('fn (): s(*~u*-  (~(*-   (~(*~u*-  (~(*-  (~C*-  (~~~~u (~C*-  (~~~\xd3u<J  (~~^gx~u')
    run_file('fn (): str {\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3 return typeof  "" }().lmngt')
    run_file('fn (): str\n{ return\x01\x00ew  "" \x85(\x1c.leng')
    run_file('[module {rrd\xdd\x1fcTid\t { return [(), ()] }().le .a = [y\n        (a: array var union {FOOm) + [FOO]\n    }')
    run_file('fn (): (array void) { re\xc2urn [(),&()]}().lenngth')
    run_file('*box().heD3D3333* +D(): module {\n            m\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf \xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xde\xc8\xc8\xc8\xc8\xc8\xc8    }')
    run_file("(box 3(.noz{FOO=OOOO\xc4OOOOOOOOOOOOOOOo'\xde';; '@/@/  '@/ 1.0e0 8")
    run_file(' assert \n    fn ref8(x: inz):mvoid {ho.lonjt].lo.longth[Ns.ho.lonjt]. o.lo].lo.yongth[Ns.ho.l\x00dj[1]t].l][N].h\x89.lonjt].lo.longth[Ns.ho.loljt]. o.lon')
    run_file('fn (): (array void) \n\n\t\xeb\n\n\x1c\n\n\n\n\n\n\n\ng')
    run_file('fn (): (struct(int)) { return\xd3(1\x00\x00 }(\x08.x')
    run_file(' array module\n{ return@mod\x80la {} }().x')
    run_file('[ boy&333*34,33%3333333333[  ref\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xaa\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9 box 3].ld ** ng].tt')
    run_file('fn (): module { retur0retur\n    \xc9b = 1 > 2\n   ur\n     b = 1 > 2\n        &  b ? ++  3 : 4\n      b ? ++  3 :      &  b ? ++  3 : 4\n      b ? ++  module {}     }\n  ')
    run_file('3^0^\n3\nC\\ | T@\x08) \xe3\x00\x02 3%^3^\n\xfa\nC\\ 1.0\x02\x00\x9b\x15z 33^\x00\x08))\n\x14\xf9 3')
    run_file('f ? n (): module { S: modu|e {\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99')
    run_file(' a /=  module { return m(1\xd3\xd3\xc3\xc3\xd3\xd3\xaf\x15\x98\xd3\xd3\xd3@\xd3\xd3\xaf\x15[B"]\x15')
    run_file('!0x16666             \n  "h\x00\x01>>= \x88\x88\x88 }\n    }')
    run_file('fn(x: array0) { x("") }([NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN\xc4NNNNNNNNNN("\x12)<NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNUNN3NNNNNNNNNNNNNN;ellNNNNNNNNN;elle { 5 }')
    run_file('~(1)\nt ]\n+')
    run_file('var x =!3; &=  x}')
    run_file('& &  & &I\nt)) = (l_foq@Ar\x7fin finally `NNNNNoNN\x00NNnt\n      const y = de@\x00r fn(): pnt\n     inter {\n    str    const x = de y = fn(): int { return 3 }\n\x05     fulfil x = fn(): inb { return 3 }\n    t\n\xcb  \n    }  \x00\x10 } ')
    run_file('[ & B];* WR  zB& B]')
    run_file('IIAIIII( defer \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n,\n\n\n\n\n\n\n\n for utatet) + \n   (  \n\n\n\n\n\n\n\x1c\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\\\n\n\n\n\n\n\n\n\n\t\xec\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nm  m.id(3)\n9   }\x1f ')
    run_file('[ box * bbox * &ox *bLy * &ox * &bo.x * 43 &bo.x * 43333333333[\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf box1G].ld-g].t')
    run_file('\n5 * \n \n5\n \n 2Q\xef\x1f5 * @ \n % 5\n ')
    run_file('\n5- \n5\n \n \xeb\n *= 5( &ve[thrEe]*lvGCl&5\n \n5\xff\x00&vgth')
    run_file('\n5\n &[1]\n &5MMM1MMMMMMWMdy \x10   MMdd\xff\x00\x00\x00c@[9  ]')
    run_file('[FO]\n#\x10   \xb8   0\xdf"\xff\x7f  a\n#    \xb8  <[1] 6 }(5)')
    run_file('\n5\n \n5\n !! 5\n &5\n  &5 \x80 5\n ')
    run_file('\n \n5\n \n &5\n &5\n 9&5 % 5\n5\xf2 ')
    run_file(' & (print,\xdbaoofn (p\x11intool):l): i')
    run_file(' new mod[N][N[Nhhhhhhhhhh\xc9hhhhhhhhhhhhh][b\\"He\x7fld!\\n")')
    run_file('\n        module nary1 {\n            const b = 1 > 2\n            b ?-3 : 4\n        }\nUll = def in n\x00\x00\x10\x00i]t\n  \x08 cell\x00\x80\xff\xff \n }\n dynamic \x08   ')
    run_file('       module nary1 {\n            const b = 1 > 2\n            b ? 3 : 4\n        }\nUll = \x82ef in n\x00\x00\x10\x00int\n  \x08 cell\x00\x80\xff\xff " }\n dynamic \x08 ) )  ')
    run_file('[ false ];+ \xd3]')
    run_file(' array const [ boch FOO(three)8{ \x00\x00\x00\x01\xdftc &= O((\xd6")t} }')
    run_file('(1, (module t {\n        var a = 10\n        while a > 0 {\n     if a < 5 {   \xc7    {         while a > 09{  while a > 0 {\n\'cont               \x1ch"\n\x1c       }\n    }')
    run_file('[ box 3]\nleng[ bong\x00\xffbox 3[ box 3].leng[ box 3[ box 3].leng[ box 3].l .a eng].leeng[ box 3[ box 3].leng[ box +  3].leng].ngtt')
    run_file('\n   module function_type_check1 {\n      const (subtype, midtype, super\xcdype) =\n        (array || 0, array cray int)\n      fn f(\x00\x02\x00\x00upextype): midtype { return []: subtype }\n      const g = f: (f const n(midtype): supertype)\n      g([]: subtype)\n    }\n    ')
    run_file(' 0x1 -5\n\x02\xeb>\xea\x01\x005\n\x7f\xff\xff\xff \n')
    run_file(' return  module nary2 {\n            \xcbar b = 1 > 2\n 1 >MMMMM \n        module nary2 {\n            var b = 1 > 2\n 1 > 2\n            b  array var ? ++  3 : 4\n                  b ? \x13+  3 :\x184\n        }\n \x0e2\n            b ? ++  3 : 4\n                + b ? \x13+ \x173 : 4\n        }\n ')
    run_file('    module cto_unfulfilled_type {\n       var  t = defer module {\n            return module {\n                fn id(x: t): t { return x }\x1a            }\xd1        }\n        const m = make(int)\n        m.id(3)\n9   }\n ')
    run_file('      var x = [[1]]\n>       \xff\xff\xff\xff [6]\n    }\n  ')
    run_file('[FOO: union {FOO; BAR}[[[[\xcf\x00@d[[Z union {FOO; BAR}[[[[\xcf\x00@d[[Z[[[[[[[[\xcf[[[[[[[[\xcf\x00@d[[[[[k[')
    run_file(' box  & &I\n box\n box  & &I\n<arral\xd3\xaf\x15\xda\x93\x00 \x00\x00\x03\xe8I\n<a')
    run_file('fn(x:void) { }\n(x:void) \x9c }\n    ')
    run_file('switch&FOO(three) { els\xc9 {3\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc} }')
    run_file('switch&Fl^ intf {\n      const - tf = fn(): inintf \xcf\n      const - tf = fn(): int\n      const k3  ^= fer intf\n      fn k(x: int): i{tf {\n        return fn(): int { return x }\n   k1()\n    }\n    ')
    run_file('[57, 8].slice\n(1, \n(1, \xb3)')
    run_file('switch defer  FOO(t\xc4ree) { `lse\n{3} <')
    run_file('switch ref  FOO(three) { e 0 /\xd2 .0 --  {3} }')
    run_file('switch FOO(t) { else { contin\xcfe } }')
    run_file('struct inell()\n  \n }\n   ')
    run_file('switch FOg(t) {\xdb\xdb\xdb\xdb\xdb  }\n ')
    run_file('+ -0 \n\x072 ?-   ?-  * while \x00)\n- 2\x1b?\xffle \x00)\n- 2\x1b?\xff\xff\x00\x00)\n\x072 ?-@  \xf9\xe9\x00\xfa?\xff\xc4\xff\x00\x00)\n\x072 ?-@  \xf9\xe9\x00\xfa?\xff\xc4\x00\x00)\n\x17\x01\x00\x00\x13 8 ?\xff\xff\x00\x00)\n\xf81\x10')
    run_file('for x in 3 { re\xc8\xc8\xc8\xc8\xc8\xc8odu\\edrfIin q(): int\n  \xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda(\xda\xda\xda\xda\xda\xda\xda\xda\xe2\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xf8\xda\xda\xda\xda\xda?\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda module \xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xb7\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xef\xda\xda\xda\xda\xda\xda\xda\xef\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda(\xda\xda\xda\xda\xda\xda  "')
    run_file('for x in 3 { if x<= breS x in 3 { if x<= breSk }; x \\/} else { k }; x \\/} else { 5 }')
    run_file('for x in 3 { if x==1 { break };   \xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4    \x08 }\n  ')
    run_file('for x in 3 { if !! 1 { break }; x       \xd8qr{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{]\n    }\n)  }\n')
    run_file('never ;oo { x -= th &   1 } }')
    run_file(' fu =fu ==Wlfil(\xc4\xd7\x7fG*33u =fu ==Wlfil(\xc4\xd7\x7fG* BAR]')
    run_file(' fulfilm = fn (t:e): uln {\n          fulfil  Pm = fn (t\xdd t: type): uln {\n            fn id     (x: t): t { return    fn id     (x: t): t { return     }\n    }(int)\n')
    run_file(' fulfil  Pm = fn (t:e): uln {\n          f\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\x80\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf}(int)\n')
    run_file(' fulfim  [\xdc\\1]=(dn (t: typA)! modu')
    run_file('typeof union intl {LEAF; BRANCH(int_tree, int, int_trE\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd0\xd4\xd4e)}')
    run_file('uuK=+ union ulf {O: uni\xd1n ulbA{\n    < ef \nn q(): int\n  \x08   cl()\n  \n ell\n      \x00\x02\x0c\x00 |Ull = d(f in n\x00\x00\x10\x11\x00 t\n  \x08 cell()\n  (1)\n }\n dynamic     ')
    run_file('\n       var b =+1 > 2\n    {\xa0 }(\x1a.x')
    run_file(' fulfil  Pm (tm)=Cfn (t\xd6 typC): mo')
    run_file('tRr*pri == b (ptin\xc3.a 9(()\x19ol):l): i')
    run_file(' typeof    & &I\n box I\n box  & &I\n<\x81rral\xb3\xae\xf2\xda\xd3\x00@\x15')
    run_file('\n        module nzry2 {\n    var b =\xd31 >var b = 1 > 2\n            b ? 3 : < - 2\n            n ? 3 : 4/-0.1e-0 }\n  ')
    run_file('fn(): int { return 3 }\n    }\n    ')
    run_file('[*3333333333743333333333[ box 3]<ldng[*3333333333743333333333[ box 3]<ldn\xd0].t].t')
    run_file(' new ref  lelse +t. arra[\xdcvaew ref  lelse +t. arra[\xdcva~ al\x01E +t. ')
    run_file('  (t: qy, (y\xcf mt)) = (3,  1)')
    run_file('[[\xce1x#] ? 2\x00\x00\x00\x00 ] ? 2 : d ')
    run_file('~\\\\\\\\\\>\\ubbbbbbb\xff\x7f\xff\xff')
    run_file('if&(1\xcf\x16{ } * y\n      fulfil y = fn(): bnt { ret\nurn  const    ^u): int { return 3 }\n    }\xba ')
    run_file('|ofox?3\x1d3333(33333333333333333{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{\x91{{{{{{{{{{{{{{{{{{{{{{{33`33333333 &=\n333\x00\x00 = \xffoat  **= 333\x00\x00\x04\x00333333&333333333333\x1d3333333333333 \x1b333\x00\x0233333`333333333(): iRt )')
    run_file('  t(): module { *etur0retur\n     b =01 >!2\n   ur\n     b = 1 > bool      &  b ? ++  3 : 4\n[1] &  b ? ++  3 : 4\n      b ? ++  3 : !2\n  \xccur\n     b = U\n   3    }\nXXX')
    run_file('for x in*fo3 { for x in*fo3 { for x in*fo3 { xin*fo3 { for x in\x07fo3 {ref var  7ref\x17var\x19 req\x00\x10 &  ref var  ref var \x04 <<= \x00"*ed \xcear\x02 ref var  7ref\x17var\x19 refoef var   var \x00"\x13&  ref var  rxF var \x04\x00 *\x00  ref var  ref var \x04 <<= \x00"*ed var\x02 re\xd3 var  7ref\x17var\x19 refoef var   var \x00"\x13&  tef var  rxF var \x04\x00 *\x00\x10 &  ref \x00\x10 &  ref var  ref var \x04 <<= \x00"*3')
    run_file('ref i(((((((((((((((((((((\xd2\xd2(((((((((((((((((((((((((((L(((((Leul`le (<g (B[f) (<g (B[f)[iu[lule (< trre [\xff')
    run_file('  void \n va|\xff\x00\xdd\xff\x00);\x80\x00{\x80\x00')
    run_file('for x in 3 { x\xc3 if x==1 { continue } } else {:5 }')
    run_file(' * new \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nJ\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xed\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x18\n\n\n\n\n\n\n\x0b\n\n\xfa\xe4\xe4\xe4\xe4[1]\xe4\xe4\xe4\xe4\xe4\xe4\xe5\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4}]')
    run_file('\n5| \n5\n \n &5\n &5\n U\n \n5\n633343333333333[ box\x01-].ld,j]rrqrrrrrrrrrrrrr.t')
    run_file('"f&(le2\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xb7\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda(\xda\xda\xda\xda\xda\xda  "')
    run_file('for x in 3 { if x==1 { break };&x } else {\xd9\xd9\xd9 5 }')
    run_file('"h\\"ZZ \xdct \\t"')
    run_file('  (t: \xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8typC): pC>>= &3& &(A& e & +& & &:& +& _  &  type &" +& &(A&(+& &4(A&(A(E)& & &(A&  type & +& &(A&(+& &4(A&(A(E)')
    run_file('[FOO: union {FOO; BAR\xd4\xd4\xd4\xd4}- BAR]')
    run_file('   const a = &5\n\n       a\n           a\n  $  \x80\x00\x00\x00a\n    }')
    run_file('va: (x\xce) = (3\x11)')
    run_file('var a= new 5\n    }')
    run_file('m*b - ox[*b *[BAR: union{FOO; BA+b - ox[*b *[BAR: union{FOO; BA+1[+  [BAR: union{NOE;1[+  [BAR: union{NOE; B\xc2+1[[ unioO; BAR}]')
    run_file('m >>+ ( mod666( *6666662666666626666666666666( * int))*6666666666:6662662666666626666666666666( * int))*6666666666666626666666666666( *666666666P6\xc76( * ind))')
    run_file('m (t\xc9, (y:l6,)) = (3\x15  1)')
    run_file('module {}\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\t\xfc\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x18\n\n\n\n\n\n\n\n\n\n\xfa\xe4\xe4\xe4\xe4[1]\xe4\xe4\xe4\xe4\xe4\xe4\xe5\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4}]')
    run_file(' while !_concat_empty {\n        \xd1\x02\x00 x =\x06[]\n         ~ x += [6\n        \xd1\x02\x00 x =\x06[]\n  ]\n    }\n  ')
    run_file('fn(x: int) { (box x).typ\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\x00d\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xcd\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xbd\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2 union ulf {O: union ulfA{\n    < ef \nn q  \n }\n dynamic     ')
    run_file('1**0\n0*0\xe8\x02\xf7\x00())')
    run_file(' union {};oi\xcft x  >>>= = 3; module foo { x -= thr <> ow  1 } }')
    run_file('\n   var a= new 5\n   a= new 5\n 626666666616666( * int))*666( *66666:6666666626666666616666( * int))*66 << 6&61266 << 6&6126666666666:96\x11\xfe* ind))')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n!          b ? 3 : 4\n        }\n }')
    run_file('1 \n\n0.%-0. ')
    run_file('module array_cYncXt_empty {\n \xca    {}var x&= []\n        x += [6]\n    }\n  ')
    run_file('const (x, ((wr never \x8d\xdf)))*= (three\x19\x7f1)')
    run_file(' new  & &  & &I\n box I\n b\x80\x00  & &I\xe4<arral\xd3\xae\xf2\xda\xd3\x00\xc0\x15')
    run_file('[N(())]\n\x00]\nOOOOOO else OOOOOOOOOO\n\n\n\n\x07\n\n\n\x0e\n\n\n\xff\x00\x00\x00\n\x0e\n')
    run_file('print("Hell\xd5, World!\\n")')
    run_file('     const y = defer fn(): int\n D\x15   }\n ')
    run_file('           array const  defer type\n      const u-=     st9\x85-= (t,)\n ')
    run_file('      ref const    defer type\n O a\x00 ay c[nstbbbbbbbbbbbb  defer ty\x88e\n   ')
    run_file('      ref const type\no4dE\x83e typ\x00\x00\x00\xffr type\n O*array  ty}')
    run_file('\n5+ \n5\n \n &\xe6\n')
    run_file('if!(1) { 2 } \n    }')
    run_file(' fulfil  typeof  6=*new    Vodgth[Ns.ho.l       [V[N][N].ho.lonjt          [V[N 4 onjt].lo.longuc[Ns.ho.l       [V[N][N].ho.lonjt].lo.yongth[Ns.ho.lonjtF.l][N].ho.lonjt].lo.longth[Ns.ho.lonjt]. o.lo].lo.yongth\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf[Ns.ho.lonjt].l][N].ho.lonjt].lo.longth[Ns.ho.lonjt]. o.lon')
    run_file('if!(1) { 2 \xc5 else {    v = new 5([]3\n        *a\n   *a\n    }')
    run_file('if!(1) { 2 } else {  \n var a\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1 = new 5     .  b ? 3 : 4\n        }\n')
    run_file("fn (): ( ref  voy_conc?('/'','''''''HnrOth'?'''''''''''''''\xc4''''''''\x00\x107Hnt,th''''nrOth'?'''''''''''''''\xc4''''''''\x00\x10'''''''''''''Hnt, gth")
    run_file('    const m = fn (t: type): ule {\n            fn id     (x: t): t {\xce\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15return     }\n    }(int)\n')
    run_file('\n5\n \n5\n \n &5\n &-\n 5\n \n5\n6\n)&5\n*/5gthtig')
    run_file('3 + 2 :union iote {LEAF(iO); LEAF(iO); BRANCH(\xcbnt_tintVtYee)}')
    run_file('defer fn(): int\n     const>cell =&defer\x05\xff\xff\x05): int\n      const copy = cell\n   le fulfil_co   fulfil coprn 3 }\n      cell()\n    }\n    ')
    run_file('\n          & typeof    & &I\n bo] I\n box   |= & &I\n<arral\xd3\xae\xf2\xda\xe7&I\n box I\n box  & &I\n<arral\xd3\xae\xf2\xda\xd3\x00@\x15')
    run_file('    const m = fn (t: type): ule[[[[[[[[[[[\xcf\x00@d[_[[[k[')
    run_file('\n 7     \n    var b = 1 / 2\n   &        b ? 3 : 4 -0.1}\n  ')
    run_file('+oe666(!mod666( *6666666646%66626\xc866666666666( * int))*66 << 666?666626( 6 << 6\x006666266E6666666666(*66666666666666266666666666&6( * int))*66 << 6666666?26( *666666666666662:666666666666( * int))*66 << 66666666666666666:66( *  * i * int))*66 << 66666666666666666:66( * ind))')
    run_file('array"\x00\xcd\xd8\xcd ** \xde\xded\x10\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdo <= "')
    run_file('[1, 2, 3]\n[]): arfn (): module {\n         fn (): module {\n  \n     !!!!!!!!!!!!!!!!!!!!!!!!!: module {\n  \n    }')
    run_file('\n        module nary2 {\n        MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMV\xe9\x80MMMMMMM = a\n>     1   >> [2] = 77\n          const  b[3]\n   MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMVMMMMMMMMM = a\n>     1   >> [2] = 77\n               }\n  ')
    run_file('switch F>O(.nt\t 2, \x01h\xcfee, 4.0) { case FOO(wG x, y, z) {x} }')
    run_file(' & .1e-0   -0.1/.0 ')
    run_file('fn(int): int\n 45\n  &5 % 5\x8a ')
    run_file('*& & & & & (A) \n & \x10A)')
    run_file('18>52 &true;?() >(t: type): uln {\n          **= il  Pm = fn (t\xff\xff\x80\x00pe): if  {\n            fn iq  @\x00 (x: t): t { return    fn id     (x: t): t!{ retuTn     }\n    }(int)   }(i&t)\n')
    run_file('  3     %  0x1   \n      defer ty{e\n   array const \xffBAR] + [B\x93RBAR] + [BAR: union{FOO\x00; B5R]: \xednion{NOOO; B5R] + [BAR: u\\ BARa]')
    run_file('Q  .a8?  * 2 : j+( v  .a8?  *\xdf2 : j)\n')
    run_file('m >>+ ( mod666( *66666626666666+6666666666666( * int))*666666666?666626( *6666\xd366666666626666666666666(*66666666666666266666666666&6( * int))*66 << 6F66666626( *6666666666666626666666666666( * int))*66 << 6666666646\x01666666:66( *  * i * int))*66 << 66666666666666666:66( * ind))')
    run_file('fn (): module { rel\xdde\n    q\n      var*x = []\n  \x01     x += [6]\n    }\n')
    run_file('if!(1) { 2 } else {  }\n \x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11d\x00\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11 &= \x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11\x11    }\n    ')
    run_file('m >> _ + ( mod?66( \xd466666666( * int))*666666666 >> _ + ( mod666( *65666626666666+6866.66666666( * int)L*6666666666:66626626666\x7f6E 6666662666666( * int))*66666666:6662662666606626666666666666( * int))*66E66666666( * int))*666666666 >> _ + ( mod666( *65666626666666+6666.66666666( * int))*6666666666666626666666666666( *6 > 6666666666666( *6 > 666666666( * ind))')
    run_file('de: ulfil5 [1]= fn (t: \xd4\xd4pC): Todu')
    run_file('1<7;]')
    run_file('!6.;x/()]')
    run_file('\n        module nary2 {\n            var b = 1 > 2\n        !!  b ? 3 : 4\n        }\n\xba ')
    run_file('    const m = fn (t: type) { return     }\n return     }(int)\x02')
    run_file(' box fn(x: int) { 5 }\n   ox 55+55555 |\x88 5R555555 }\n   ')
    run_file('const f =  struct ();const f =  struct (ct(*box iu\xc8nct(*b@\x00\x00\x00setur[ \x01\x00 case th')
    run_file(" while !_concat_empty {\n     &  '\xde': '\xde';; '@/@/ '\x00\x02\x00\x00t a = ([]: array var int) + [1, 2, 3, 4, 5]\n   d        var b = a\n            b[2] = 77\n       @    b *= 1\n            b[3] = 88\n              a[2]\n            b[2]\n            a[3]\n  \x00t a = ([]: 3]\n        }\n ")
    run_file("fn(t: type) { 3;          }\n ;\x99     }\n    }\n        const m = make(int)\n  \x13    'm.id(3)\n    }\n ")
    run_file(' ref var int\n  re,  reon i\x00\x00\x00\x80FOO;bYoeprprint,  r\x80f booinrRrint,  ref booint -0.1e\x00\x00 ,  \x01\x00f bY@\x00prpri|t,  ref booint? )nt,  r:. int')
    run_file('typeof  [6]\n  typeof  [6]\n    }\n  ')
    run_file(' &  module\nfunc\x82ion_type)\n ')
    run_file(' typeof 0x1 \n        modqAR]')
    run_file('66: int\n      fulfil x =       consty\x8a    \xa0 fulfil y = fn(): in\xa8 &&  { {eturn 3 }\n      fulfil x = fn():#in }\n 6ule double_fulfil_f y =-de\xff\xffr fn(): int\n      {   \x1b const x =fn( -- ): int\n      const y =-de\xff\xffr fn(): int\n      {ulfil x ,  d\x00')
    run_file("fn (): array0 { return [] }\n    while\xfa\x00\x00\xfa\r  thaow  []\n \\' \n   x :     throw  []\n \\+ c\x00nst   \x0e}\n ")
    run_file('     case a{ray JJJtru\x90\xff')
    run_file("if&(1) { 2 } else  if&(1) {if&(1) \xcbls } else {if&(1) {if&(1) { 2 } else {\x00 &(e {iv&(1' { 2 3  2ls }\x00 lse {if&(1)  3\x19")
    run_file('\n    module t {\n        va\n        if a < 3333333333\xce33333333333333333333f\n      fn k(x: int): intf {\n        return fn(): int { return x }\n      }\n      fulfil k3 = k(3)\n   \x17  k3()\n    }\n    ')
    run_file('\n     var a =*new 5\n      ("")        *a\n  ;J)(Jnt)(J)()(JnINnt)(J)(Pnt)(J)()(Jnt)(Nnt)(J)(tnt)(Jt)(J)\x16)(Jnt)(J)(J    module re4 {\n        var a =*new 5\n      ("")        *a\n  ;J)(Jnt)(J)()(JnINnt)(J)(Pnt)(J)()(Jnt)(Nnt)(J)(tnt)(Jt)(J)()(Jnt)(J)(J')
    run_file('   var a =R10\n  wwile a > \xff   }')
    run_file('[] + module t {\n        var a = 10\n     b = 1 > 2\n     \xde      b ? 3 :       O[2]\n          b[1]\n            a[2]\n            b[2]\n          }\n    ')
    run_file('fulfil(x,  sw\xd2uct ) = (3, 1)')
    run_file(' while FUO(while07\xc6O(t) {  }\nt) {  }\n ')
    run_file('fn(x: infn(x: inn(x: infn(x9\xec\x80nt) {1boxt1boxt) {1box | \x00\x00\x00\x01')
    run_file('pr (): (  defer new  fn (): ( fn (): (  defer new  fn (): d fn (): ( "defer ) uni\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\xdc\x10\x00\x00\x00\xdc\xdc\xdc\xdc\xdc\xdcon rn [(),$()ngtn (): ( "defer ) union rn [(),$()ngth con ** e void}\n  ')
    run_file('\n          var x: array const int = []\n   \x01   \x00\x80 += [6]\n   = var b = 1 > r x:  array  nst int =  \x01    x += [6]\n   **       x\x02 @  }  }\n')
    run_file(' return O & O(\xc3lreeB { elsee {d }')
    run_file(' var a =*new.5\n        a\n    \xff   *a\n    }')
    run_file('6666&6 >>666666 >> 666&66\n660>666666 >> 6\xff\xff\xff\xff%6666 >>66T666 >> 666&66&660')
    run_file('[]*4\n  \x06\t .&\x1d\x1f\xfb\xffn *\x89\xca\xca\xca\xca\xff\x00\xca\xca\xca\xca\\t\xca\x00\x00\x00\x00\xbb\xca\xca\xca\xdf\xae  \x00\x10\x00\x00\x7f  5  ?a\n  \xfd\xfd\xfd\xfd\xf8\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd]*4\n  \x06\t .&\x1d\x1f\xfb\xffn *\x89\xca\xca\xca\xca\xff\x00\xca\xca\xfd\x04\x00\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfe\x1b\xfd\xfd\xf9\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd\xfd()}')
    run_file(' ref  new ref         ref  new ref   [    mSdule m { c\x12ns\x00 nst x>= \xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xab\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xbd\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xe8\x03\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7.x\n  }')
    run_file('(bo(A"\x00\xcd\xd8\xcd].lo.lobjp].lo.lona = 10\n        while a > 0 {\n  "h"\nobjt].lo.lona = 10\n        while a > 0 {\n\x11 "h"\n        }\npppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppppp           }\n    }')
    run_file('fn true  (): (  defer new  fn ()" ( fn (K: (\xcd\x87\xcd)')
    run_file('fn (): str { return "" }\n)\x02\x02\x02\x02\x02th')
    run_file(' new  & &  & & new  & &  & &I\n box  \x8bew  & &4 & & new  & &  & &I\n\xff\xff\xff\xff I\x1d bo{,  & I\x1d & & new  & &  & &I\n box  \x8bew  & &4 & & new  & &  & &I\n\xff\xff\xff\xff I\x1d bo{,  & I\x1d  bo{,  & &II\n b')
    run_file(' box "  "   ; >>S=ount {\n    "   ; >>>=   cue  A   \x00\x04  \x00\x00\x00\x00"\n7+       ,i\x01(true)!  if a cont\tnue\x8b A       \x00\x002 5\x0c}\x0f_ont\t\xefue })  }\n')
    run_file('[2.4]\n]')
    run_file('     ref var   ref const    defer type\n O arra\xa6 const  dever type\n \x07 ')
    run_file('  typeof  typeof typeof  typeuCt(struct(inct(int) (struct((struct(int) (struG7 (struct(inct(int) (struCt(struct(inct(int) (struct((struct(int) (struct(ireturnuct(int) (struct(io((struct(int(int) (\xdfct(ireturnuct(int) (st@uct(io((struct(int(int) (struct(ireturx struct(int) (struc <> t(int).x')
    run_file('3 * [VVVYVV]\n x += ty}eof  [6] typeof  [6]\n  4x +\x1f t\x00\x00\x04\x00f  [6]\n  tyof  [N]typeof\n  typeof  [6]\n x += typeof  [6] typeof  [6]\x0e  4x += t\x00\x00\x04\x00f  [6]\n  type[6]\n  tyUeo\x00\x00\x00 6]\n   x L= typeof  [[6]\n  typeo\x00\x00\x00 6\xdc\n   x += ty -0.1e-0 eof  [6]\n  type true ]\n: }* ')
    run_file('~~~~~*new 5\n     module {}    !!!!!!!!!!!\x80!!!!!!!!!!!!!!!!!\xd5\x01\xd5\xd5\xd5\xd5\xd5*a\n    }')
    run_file('~~~~~*new*new 5\n\xd5*a\n 5\n\xd5*a\n B  }')
    run_file('  box * &33333\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xf3\t\n\n\n\n\n\n\n\n\n\n\n\n\x1c\n\n\n\n\n\n\n\n\n\x1d\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet) + \n \xff\x7f\x00\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet        3     const ))))))))))))))))))))))%)))8))+)) 3, 4, 5]\n ______________________et) + K1, 2,  b[2] = b *\n  aL3]\n@1+     ] = 88(A)\n  at_\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n  \x08   \x8b   aL3]\n@1+     ] = 88(A)\n  at_\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n:\n\n\n\n\n\n\n\n\n\n\n\xdc\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n#\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet) + \n   (    $   \x94[2]\n :  \x04       b[2]\n \x10 B        bL3]\n@1     \x0b    b83]\n   \x00\x00\x00\x80 }\n    ')
    run_file(' ! (tr,*fn ((()r,\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\x00\xc2\xc2\xc0\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2*r,*bmyZ):ool): p((\xdb)')
    run_file('"he\xd1\xd1\xd1" & "llo"')
    run_file(" !!\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8@/ module s uer @/;/;\xde';; '@/ 0e0 ")
    run_file('3 >>>       \n 2\n      \x10\x00    b ? 3 & 4 -0.1}\n   fn (): module {\x15   1 > 2\n     \n    var b = 1 > 2\n      \x10\x00    b ? 3 & 4 -0.1}\n  ')
    run_file('3 >= 3\n\n3\n3^\xff\x7f\x003+\n3\n3')
    run_file('switch FO{ case FOO(w, x, y, z) { re\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6 ~ \xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6turn x} }')
    run_file(' box module\n        [   []\n        ]\n          var \x00\x80\x00\x00[]\n        x += ref var #[6]\n  ')
    run_file("for x in 3 { break };!x  \xde';; 5;/;\xde switch ';; '@! '\xde';;'\xde';; @@/ '@/8")
    run_file('(bg\xd6 3).constn? 3 :&47\n ')
    run_file(' new "hl" ; n\xcew  "mlo"')
    run_file('fn (pri_fn (tr,*r,*booZ\xdc:bootJ,*bo_____________|______________b\x00\x01\x00\x00__tr,*r,*mooZ):bootJ,*bo_____________|_____________________________fn (tr,*r,*booZ):bootJ,*bo________,*fn (tr,*r,*booZ):bootJ,*boo______________fn (tr,*r,*booZ):bootJ,*bo________,*fn (tr,*r,*booZ):bootJ,*biol): p(())')
    run_file('*&          \n      defer type\ndefer type\n   array con(t  defer type\n    \x7f\xff\xff\xffnst u-=      (t,)\n ')
    run_file('if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {\xcejjjjjjjjj &= j\n      for n in 3 {jjjjjcjjjjjjjjjjjjQjjjjjjjjjjjjjjjjjjjjjjjjjjjj &= jjjjjjjjj\n      constdjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = u\nj\n     (v,) = u\n      5: v\n    }\n constdjjjjjjjjjjjjjjxjjjjjjjjjjjjjjjjjjjjjjjjjjj}\n ')
    run_file('&HLHHHHHHHHHOHHHHHHHHHHHHHHHHHHHHHHH([])\n  \xa0 aXXXXBXXXXXX\n\x00\x00\x00\x01}')
    run_file('for x in 3() { new    new((( new *     new   \xd9rray (8(new new *  \x0e  new    new(((8(((((((([]:((666( * int))*6666666666:T66\x11662666666626666666Y66666( * int))*66666666666666266666F6666666( *666666666666((((((([]:((666( * int))*6666666666:T66\x11662666666626666666Y66666( * in array const 66666266666F66\x1a66d))')
    run_file('ntl = fn(): int { cell = fn(): i.t { return63 = fn(): l x []= fn():\xce\xce\xce\xce\xce\xce\xcerhturn 3 }\n  retur\x00   fulfil x []= fn(): Int \n  retur\x00   fulfil x [ fn n(): Int {  in return 3 }\n  retur\x00\x7f   }\n ')
    run_file('     const ictf = fn(): int\n      const k3 = defer\xf4intf\n     \x01\x00n k(x: int): intf {\n        return fn(): ine { return x }\n      }\n      fulfil k3 = struct     k3()\n   ;]\nct     k3()\n   ;}\n&')
    run_file(' typeof    & typeof    IEAF(); BRANC>(Vnt_tr^e. int, intVtree)}')
    run_file('[1, type\xd28].s.sl[108].s.sl.s.sl = 3; FFFl0= 3; FFFRFFF = 3; FFFl0= 3; \x06F^RFFFFFfFFFFFFIFFx}')
    run_file('var x =box  3; x}')
    run_file('ref 3[ b[x&G]/~d-g]* 3433333+3333[ b[xdG333[ b[x&\xcb]/_d-g]* 34333]/~d-g].t')
    run_file(' while new  a_conca(fal if%\xdde) {\n        vak x = 83new  a_conca(fal ifiye\x12conca(f |= 6]\n')
    run_file('    var a =*new 5\n        a\n[]      *a\n    }')
    run_file("[] *  '\xde';\x7f\xff\xde';; \x1b;/;\xde';; '@/ 5@ .a \xde'\x1a;E\xde';\x01 3P/ '@ > /8")
    run_file('[FOO, FO]\n\xba  x += typeof  [6]\n  tt  [6]\n   x += typeofof  [6]\n  rt  [\x00\x04\n   x += ty  }\n')
    run_file('\n        module nary24{\n            var b = 1 > 2\n          b ? 3 : 4\n        }\n\xc2\xc2\xe2\xc2\xc2\xc2\xc2ef in n\x00\x00\x10\x00int\n  ')
    run_file('3 !=   2\n  \x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80\xa1          2\n\x00\x00\x00\x00?\xff\x80\x00 4 -0.1e-0\x0b}\n\n  ')
    run_file(' &    module m {}\n\xff           return m\n      m {}\n\xff           return m\n        }().x\n \x7f\x00 }')
    run_file(' box  defer fn(): int\nvoid {\n         a\n        *a\x7f\xff   }(5)')
    run_file('if&(1) {  \xcfwhile a(1,) {\n  "h"\n   \x19    }\n \x00\x05\x00\x00\n   ?  =; 10\n    .  \x07whi\x00       }\n   ref var        while a(1{} {\n  "h"\n    \t   }\n\xec * y\n       >  wh * y,  obj =; 10\n     /  while a(1,) {\n  "h"\n        }\n \x00\x04\x00\x00\n   ?  =; 10\x17        whi\x00       ref var    w}\n\xec * y\n   ?  =; 10\n"h"\n   \x19    }\n \x00\x05\x00\x00\x07   ?  =; 10 /= \n          wh * y,  obj =; 10\n     2  while a(1,) {\n  "h"\n  !  \x00  }\n \x00\x04\x00\x00\n   ?  =; 10\x17       1    \x00\x10  ;}')
    run_file('66  >>> 66 >>>6 >> ~66')
    run_file('".\xdc".x')
    run_file('"\xdf/"/V')
    run_file(' array array new  i[[[[[[[\xcf\x00@d[[[[[[[[[[[\xcf\x00@d[[[[[\x01~')
    run_file('switch FiO(three) {\xc2else {} }')
    run_file('\n5\n \n5\n \n33333333;33333333334 <> 333333\n5\n \xd733333333;33333333334 <> 3333333333333333;333\xe8\x033333343333333333[ tox ]-33333333333;333\xe8\x033333343333333333[ tox ]-33333333[ tox ]\xff\x7f')
    run_file('\n5\n \n5\n struct(int)\n5\n \n5\n struct(int5\n struct(int)) { return (1,[1]) }().x) { return (1,[1]) }().x')
    run_file('module m{\n    va[6]\n -0.1e-0  [6]\n x += typeof  [6]\n  typeof  [6]\n   x += typeof \xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5 [6]\n  ty[6]\n -0.1e-0  [6]\n x += typeof  [6]\n  typeof  [6]\n   x += typeof  [6]\n  typeof[]  [6]\npeof  [6]\n    }\n  ')
    run_file('*1(1\xc6)=C')
    run_file('module foo {\n        module m { const x = 1 }\n      \xc3 const\x00\x00\x01\x00 array  m.x\n    }')
    run_file('module {\n     const x = 1 }\n            .               module m { \x03\xe8nst x = 1 }\n            .      }().x\n   ')
    run_file('!~*new 5\n .   m\xfe ')
    run_file(' box  33333333333333333338():       v >>>=  []\n        x3343 += [6]\n    }\n  ')
    run_file(' + 0.0 \n \x80  \x16   >>= try \x16+ \x16.0 \n y  }   >>=}8 ')
    run_file(' new~*new 5\n     module {}    ! continue !! \xff!!!!!!!!!!!!!!!!!!!!!!\x1a!\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xaaa\n    }')
    run_file('IIIIIIIC (false)\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\ndefer \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xff\x7fIC defer \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nu(*E  (~g~~ue')
    run_file(" box \n box \n\n'\xde';;  - '@/@/\\b@@/@/ !\x00\x00\x00 /")
    run_file('"\xee\xff" +  * "}lo"')
    run_file('switch FO{ case FgO(w, \xccx, y, z) {x} }')
    run_file('&      true \n\n\n\n\n\n\n\\nlo.l\xb4ngthA ==\x00 .\x00oon')
    run_file('fn (i: int) { [3, 4, 5, 6][i] }\n1)')
    run_file('[[1]] \n3][1, 2\x11 [[1]]  3][1, 2\x10 3] + [] + [3] + [] + \x7f\x00')
    run_file('switch FOO(int, 2, three, 4.0) { case-FOO(w, x\xda  , z) {x} }')
    run_file("&     '\xd7'& 1&      'W'")
    run_file('const*(x,\xdbsp*(x, (y:2XXd)) = (3, 1) (y: inp)) = (3, 1)')
    run_file('\n        module nary3 {\n            var x = 4\n            1 > 2 ? 3 : x\n        }\n\xc5\x1d')
    run_file('+ +1.66&+ +1.6 +1.666  ')
    run_file('[1- 2, 3]   \n      defer type\n  ray con /= st  defer   \n\x1b     def\x80\x00 type\n')
    run_file(' new  fn(): int\n      const copy  % ell\n      f\xff\xff\x00\x00defer fn(): int\n  \x80   const\x13co\x84y = ceel\xff\xff\x00\x00defer f~(): int\n   \x10  const copy = cel\x87\n \xe2    fulfil(1,il\xe2co while (): int { return 3 }\n    }\n    ')
    run_file(' dyn [3\xdb!b.tt:3337333433333333733/4333333\x10333[ box box 3]\xc5ldng].tt:333733343333333633[ box+3].l=no33333[ box b4 ++  33333[ box O33633[ box 3].ldng333343333333333[ box O].ldng].tt')
    run_file('[FOO: new  union {FOO;  const int\xd1 = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n        return fn(): int { re\x17urn x }\n      }\n      fulfi@ k3 = k(3)\n      k3()[FOO: new  union {\n    }\n  ')
    run_file('fn (): str { return "" }()\n\n\n\n\'\xde\';; \'@/@/ \'@@fn (:: str { return "" }()\n\n\n\n\'\xde\';; \'@/@/ \'@@/@/ 8@/ 1of FOOs uer @/;3;\xde\';; \'@/ 0e0/@/ 8@/ 1of FOOs uer @/;3;\xde\';; \'@/ 0e0 ')
    run_file('1*([])\n011**0*0*011**\xff\xff\x80\x004*0*011')
    run_file('\n5\n typeof  \n\n \n5\n \n/&\xff\xff &\xc8\n _ \x80\x00\x00\x00]')
    run_file('    fn f(): void{ const x = f }\n    (1,)g() / \n    }()\n    ')
    run_file('t : box  (x\xd1) = (3,\x89')
    run_file('    fn f(): void {\nconst x = K }\n        g(NNNNNNNNNNNNNNNNNN("")<NNNNNNNNNNNNNNNN0NNNNNNNNNNNNNNNNNNNNNN fn f:\xff\xff\x7f\xffqid {\nconst x = K q\n        g(NNNN]NNNNNNNN\xd8NNNN("" in N -- NNN1NNNNN\xd4\xd4\xd4\xd4\xc8\xd4NNNJNNNNNNNY<NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNDNNNNNNNNN("")<NNNNNNNNNNNNJNNN0NNNNNNNNNNdNNNNNNNNNNNQNNNNNNNNNNNNNNNNNNNNNNNNNNNNN ~ NNNNNNNKNNNNNNNNNNNN7NNNNN\xf3RNNNNNNNNNNNNNNNNNNNNNNN tryNNNNNNNNNNNNNNNNNNNNNNNN\x00\x00\x03\xe8NNNNNNN\x01\x00N^NNNN("")<NNN_NNNjNN << NNNNNNVNiNNNNNNNNNNNNNNNNNNNNNNNNNNNNJNNNNNNNNN+NN\x97NNNNNNVNNDNNNNNNNNNNNN)NNNNNN("")<NNN_NNNjNNNkNONNNNNNNQkNNNNNNN += NNNNNNNNNNNNNJNNNNNNNN\xff\xff\xff\x7fNNNNNNNNNNNNINN\x0eNNNNNNNXHNNNNNNN\x10NNNNNRNNNNNNNNNNNNNNNNNNNNNNN try NNNNN;ellNNNNNNNNN;ecle { 5 }')
    run_file('[1> 3]  *8\n\n\n8]  *8x1\x11\x01\x00\n')
    run_file('[1* 2]  *8\n\n\ntL) = ()')
    run_file('[ print ("\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xc1\xcb")] * -3')
    run_file(' typeof str;mkke(t: tfpe): mo6{\n        reyure\xff\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1 catch \xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1\xb1t: tfpe): mo6{\n        return mo\nTn mo\nT   }\n')
    run_file('[  [      module nary24{\n   \xcc        vAr b = 1 > 2\n        module nary24{\n     \x00\x02     var b = 1 > 2\n       \x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00  b ? 3 :&4.\n    ` \x01\x00\x00\x00\n            b ? ? 3 :&4.\n     \x1e\x00  ')
    run_file(' typeof    module m {}\n        \x8d.x\n   ')
    run_file(' ref str\n   \x00\x7fnGer \x00\x00 \xfa\x00\x00\xfa co fn():\x00\x02nt\n   \x00  fulfil x*= y\n      fulfil y =\x0ffn(): in\x89 { retur\xee 3 }\n      }\n    }\n    ')
    run_file('3[9 << 999999999999999]')
    run_file('""*41**040')
    run_file('\nbox\n\'\xde\'*\n\n\n\n\n\n[""]\n\n\'\xde\'@/ 8@/ 1@\x00 \x12 ')
    run_file("\n'\xde'*\nQ\n\n\n\n*\n\n\n\n box\n'\xde'*\n\n\nQ\n\n\n\n*\n\n\n\n box\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/\n'\xde")
    run_file('if&(1) { 2 } else if&(\xda) { 2 } else  if&(1) {if&(1) {ls\x00\x7f  if&((false)1) {if&(1) {ls }  }')
    run_file('&defer fn(): int\n     \x10const copy \xc1 cell\n   le!fulfil_c fn(): int\n     const\x92\x92\x92ll =&defer fn(): int\n     \x10const copy \xc1 \xff\x00ll\n   le!fulfil_co   fulfil coprconst copy \xc1 cell\n   le!fulfil_c fn(): int\n     const>cell =&defer fn(): int\n     \x10const copy \xc1 cell\n   le!fulfil_co   fulfil coprn 3 }\n ')
    run_file("[3]\n\n\n typeof \n'\xde';; \x10@D@/\\ str \x7f9@/@%H )")
    run_file('+~~~~~~~*new 5\n     module   !!!!!!!! !!!!{}    !!!!!!!!!!!!!\\t!!!!! \xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3\xa3 module {}    !!!!!!!! !!!!!!!!\x10\x00\x00\x00!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\x0e   ')
    run_file('for x in 3[\xc7] { x }')
    run_file(' new  new "hl" ;  n false wAR]')
    run_file('68==1\n(()) }')
    run_file("for x in n (t: type):\nule {\n   e\xd9{\n     'A^ F\x00O+\x1f")
    run_file(' & *new 5\n . 0 mXdul_ \x00\x00\x00\xff -= !!!!!!!!\x01!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n +*new 5\n . 0 mXd5\n . 0 mXdul_ \x00\x00\x00\xff -= !!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\nuI_ \x00\x00\x00\xff -= !!!!!!!!!!!!!!!!q!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n  ')
    run_file(' new ()\n      }\n ')
    run_file('defer  *Q*6(!mog66<(!mod:S5(C*\xd6666662666666662666666666666656( * iHt)),66 <<62))(!mog66<(! a :35( *666667266666666&6656( * iHt)),66 <<62))')
    run_file('    fn f(): void {\nconst x =  box f }\n        g\x10)\n   ')
    run_file('(defer fn(): \n\n\n\n\n\n\n\n\x00\x04\x00\x00\n\n\n\n\n\n\n\n\nQ\n\n\n\n\x0f\n\n\n\n\n\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\n\n\n\n\n\n\n\nmutatet) + \n   (d \n\n\n\n\x0f\n\n\x1c\n\n\ner \n\n\n\n\n\n\n\n\n\x00\x04\x00\x00\n\n\n\n\n\n\n\n\nQ\n\n\n\n\x0f\n\n\n\n\n\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nmutatet) >=  + \n _   BBBBB8BBBBBBBBBBB]BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB*/BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB    3 \n')
    run_file(" new'\xde';; 5;/;\xde'\xd8';; '@/ '\xde';;'\xde';; 5;/;\xde';; 8")
    run_file(' !! ~~~*new 5\n\xe7\xfc  \x03module {}    !!!!!!!!!!!!!!!!!!!!!!!!!\x19!\xd5\xd5\xd5\xd5\xd5\xd5\xd52a\n   ')
    run_file(' [ ! 3]; dkfer a.length }')
    run_file(' typeof()\n  \n }\n  ')
    run_file(' new "]eD + new\xcb " + new  "llo"')
    run_file('  new 0x1 \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x00\x00\xff\xff\n0x1 \n0x1 \n\n\n\n\n\n\n\t\xf5')
    run_file('[[""]] *333333333533233333 ? 33333333(): int\n ')
    run_file('for x in 3 { x }\neray_repeat_ x } eray_repeat_mutatemutate {\n   a[2]\n            b[2]\n     nst a = ([]: array var int) + [1, 2, 3, 4, 5]\n            var b = a\n999999999999999999999            o[2] = 77\n    @    `  b *= 1\n            b[3\x80\xff\xff\xff88\n            y[1]\n            b[1]\n            a[2]\n            b[2]\n            a[3]\n            b[3]\n        }\n    ')
    run_file('for x in 3 { if x==14(fals\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5e) for x in  ref var 3 { id x==1 {$break }; x } else { return  5 }}; xse { r\x01 { r\x01turn  5  fulfil }')
    run_file('const (a,) = 66666.666&66666666666666.66666\n\n\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\x01\n\n\x05\xff\xff\x05\nmutatet) + \n   (d \n\n\n\n\x0f\n\n\x1c\n\n\ner \n\n\n\n\n\n\n\n\n\x00\x04\x00\x00\n\x00\xff\n\n\n\n\n\nQ\n\n\n\n\x0f\n\n\n\n\n\x17\x17\x17\x17\x17\x17\x17\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\x08\n\n\n\n\n\n\n\n\n\n\n\nmutatet) >=  + \n _       3 \n')
    run_file('  union ion {      defer\xcbtype\ndefer type\n  defer type\n  Wy con(t  defer type\n      const u-=      (t,)\n y con(t  defer type\n      const u-d\x00\x00\x00   (t,)\n ')
    run_file('\n5\n!\n!\n5\n \n (A)\x10\x805\n\n5\n\n\n5\n \n \n &5\n &5\n\n5\n \n5\n \n  &5\n &  \n5\n \n  &5\n &  &5 % 5\n ')
    run_file('\n    \n\n\n\n\n!1.\n!1.\n!!1.\n\n!1.\n\n 1x \x00\x80.\x16\ninter {\n      const x = d%fer fn():): i\x01\x00\x00\x00 return 3 }\n    }\n ')
    run_file(' -0. %1e-0  \n-0.1\xff\x000 ')
    run_file('ntl = fn(): pnt {  switch n(): int {urn6\xd1 = fn(): int { cell = fn(): int { ^= urn6tl = fn()6( * int))*66 << 6&6126666666666:96( * ind))')
    run_file('\n        module nary2 {\n            var\xd7b = 1 > 2\n            b\x19? 3 :()\n        }\n  ')
    run_file('switch FO{ case FFO{ case\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6\xd6 FN < OOO(a, x,t')
    run_file(' & array int\n      const y = doferrn 3 }\n      fmlfil x = fn(): int { return 3 }\n    }\n    ')
    run_file('fn (): (s, boozn (\xde while rm~t,,Dool):l): i')
    run_file(' int *91.3**11. **91.30e0 ')
    run_file('for x in n (t: \xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5type):\nule {\n   com = fn (t: tyfe): ule {\n      return  * 5555+55555 || 55555555555555555555555555 }\n  [""]         ;55555555+55555 || 5\x00d}\n ')
    run_file('(): ulfil5 [\xd0]= fn (t: typC): aodu')
    run_file('D(int)\n= f\xff\x8f$**  ')
    run_file('"he /\xdf "(B) + "llo"')
    run_file(' box             module m {};\n    \xa0     return\x18\\/ra        }().x\n   ')
    run_file('const f =  ();const f =  struct (); int\xefi')
    run_file('fn (tr,*fn (fn (tr\xcc*fn (tr,*r,*)oo^):bootr,*bool): p((tr,*r,*)oo^):boolr,*bool): p(())')
    run_file('defer 3333[ \xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xbb\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcfboy&333\x133333343333d ** ngU.tt3\x00\x7f3343333337333333@3333333333[ box 3].ld ** ng].tt33?3343333433333[ box 3].ld ** ngfn(): snt\n ')
    run_file(' dyn [3[!jox&33333733343333333333[ box 3].ldngM3334333J333333[ box 3].ldng].tt:3337333433333333733343333333333[ box 3].ldng33334333J333333[ box 3].ldnc].tt:333733343333333633[ \xc6ox 3].l=ng333343 ** 33333[ box O33633[ box 3].ldng333343333333333[ box O].ldng].tt')
    run_file(' box-\n0x1 \n\n\n\n\n\t\xf5 \n\n\n\n\n\t\xf5')
    run_file(' -0.1e-0-0.1e-0\n }I }I\t')
    run_file('\n           var b =  0.0 \n !!            module0nary2 {\n            var b =  0.0 \n           var b =  0.0 \n !!            module0nfry2 {\n          : var b = !!  \x80      b ? 3 : 4(a)      \xff\x7f\xff\xff')
    run_file('[N][ [N][NN][N].lo.lN][\xc7 < [N].lo.l].lo.lona = 10\nob')
    run_file('&   ()\n  \n }\n   ')
    run_file('[module {}] \n  \xcd   def\x00\x80 type\n   array cons\x81  defer typ\x00\n      ype\n ')
    run_file('\n  module nary26{\n            var b = 1 > 2\n            b ?[1]:[]\n        }\n    }\n  ')
    run_file('[1] +[]\n        x += [6]     x +=   }\n  ')
    run_file('module { modul\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcde 2, three, 4. \x00\x00\x00 case FO^(w, x, y, z) {a} }')
    run_file('var b = 1 > 2\n b = 1 > 2\n    \x01\x00\x00\x00    b ?(3\xad: 4\n     b ? tch        = i\x01LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL\x11LLLLLLLLLLLLLL7\xda\xda\xda>\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda\xda 0 \xda\xda\xda\xda\xda\xb8\xda\xda.tt')
    run_file('\n\n    while 0 > 0 {\n        +             "h"\n        }\n    }')
    run_file('       var a =*new 5\n      [""]        *a\n1   }')
    run_file('""*41**0*0\n011peof  !& typeof   & typeof & typeof   & typ ty dynamic type\xff\xff   & typeof   & typeof  !& type\xbef - & ty & p     & typeof   & typ void \x00 f>  & typeof   & typeof  !& typ**0\x00\x80\x00\x0011peof  !& typeof   & typeof & typeof   & typ typeof   & typeof   & typeof   & typeoE  !& typeof - & ty & p     & typeof  typeof    @I\n& ')
    run_file('\n        module nary26{\n            var b = 1 > 2\n            b ?&3 : new  4\n        }\n\xbc ')
    run_file('"\xd0e" + box  "llo for "')
    run_file(' new     module naryP {\n      }\n  "h"\n        }\n  ')
    run_file('* box\n\'\xde\'[""]\n\'\xde\'\nbox\n\'\xde\'*\n\n\n\n\n\n*\n\n\n\n\n\'\xde\';; \'8/@/ \'/ So\n')
    run_file('for x in 3 { continue }; x}')
    run_file(' fulfil ref8(x: Hn\xca): void= &x\n ')
    run_file('3+  module vouble_fulfil_forwardino_pointer {\n      const x = defer f\xc8(): int\n      const yeLnt\n      fulfil x = y\n      ful ir y = //fn(): bnt\x00{([]) return 3 }\n  $   fulfil x&= fn(): int { retur \x00\x00\x00}\n    }\n ')
    run_file('0& "hel}\xde"+& "hello"')
    run_file(' typeof  array module \nrrap_concat<empty {\n       \x80\x00ar x = []\n  module {\n        !   return module {\n                fn id(x: t): t { return x }\n            }\n        }\n        const m = make(int)\n        m.id(3)\n9   }\n ')
    run_file('66 >6 >>>-66 >F>6 >>>  66 >>>  66 >6 >>>-66>6 >>>  66 >>>  6666')
    run_file('3 *[()]     \n   \x013 : 41-0.1}\n  2\n            b box : -0.1}\n  2\n            b box :   \n    fn (b = 1\x16> 4 -0.1}\n ')
    run_file('    A       ("")\n      de\xdaer typt (`ut ())]]')
    run_file('[5] +C?+C[Bnst667(!* m\x7fd666(!*6626666666<6662662666666nst667(!* m\x7fd666(!6666626666\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd5] +C?+C[Bnst667(!* m\x7fd666(!*6626666666<6662662666666nst667(!* m\x7fd666(!666662A666\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd666*\xcd\xcd\xcd\xcd\xcd\xcd\xcd\\"\xcd\xcd\xcd\xcd666* i)')
    run_file('"\xcf"(true).length')
    run_file('&0x1 \n0\x8d1 \xff\n\n0x1 \n\x1d\n')
    run_file("+ box\n'\xde'(A)\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\nox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/\n'\xde")
    run_file('module m {;const x = 1 }\n        m.x\n    }')
    run_file(' * NXOD: union {FOO; F\xd0O}= _ARV')
    run_file('"h\xdb" + typeof  "llo"')
    run_file(' typeof    & typeof    & typeof    & typeof    typeof    & typeof    & typeof    & & &I\n box\x89I\n box   |= & &I\n b')
    run_file(' typeof    & typeof    & typeof    & typeof    & &I\n box I\n\nbox  [6]\n    } print \n ')
    run_file("const f = \n\n\n\n'\xde';; '@/@/ '@@/@/38@/ 1of FOOs uer @/;/;\xde';; '@/ '\xde': '\xde';; '_/1=0e0 ")
    run_file('[1, 2, 3][1]\n      defer typ print  con\x8dt u-= (t,)\n ')
    run_file('module array_concat_empto {\n  \xc6     var x = []\n        x[]= [6]\n    }\n  ')
    run_file('[ new new 3];; ;[] + print ]')
    run_file('for x in 3 { while 1 { break };!x } else {  []\n   \n \n   for x in 3 { while 1 { break };!x } else {\xdf []\n   \x04 \n       a:-= 1\n            if a < 5 { typeo& e }\n           "z"\n        }\n8     a -= 1\n            if a < 5 { typeo& e }\n           "z"\n        }\n8 ')
    run_file('"\xd1@>>= he"[1] + "llo"')
    run_file('(O, );%_ )')
    run_file('(3, 2 )\n \xb9\x10')
    run_file('        var x = [ 0,0 ]\n        x += [6]\n    }\n ')
    run_file('+ +1.66^+ +1.666  ')
    run_file('for x in[module\xdd ++ {}] { x }')
    run_file('3 * ~*new 5\n   , modale {} t  !!!!!!!5!\xfe!!!!!!!!!!!!!!!C!!!\xb5\xd5\xd5\xd5\xd5\xd5\xd5* ~ a\n    }')
    run_file(' 1.09 /  8.0&2.')
    run_file('J(1)\n \xb9@J(1)\n \xb9@')
    run_file(' * q(131+module nary2 { array const \n        * q(131+module nary2 { array const \n            defer  S(131+module nary2 { array const \n \xca      * q(131+module nary2 { array co    defer  S :.4\n            module nary2 { array const \n      \x04     defer  S :.4\n   }\n  ')
    run_file('f& tt :  module nary2 {\n           t \xc7  moda = &x\n      t :  moda = &x\n    \rH  a\n    float  :  moda = &x\x10\x00\x00\x00se     \r   a\n    fl|at  :  moda = &x\n   {\n   \r  ==  Xa\n     {\n       {\n        c(5)')
    run_file(' new "\xd6l".t')
    run_file('[1> 2]      \n    \n  array var defer type\nBefer typ): bo8l)%\x05 \x83 \n \x80')
    run_file('module foo {\n        module m { const x = 1 }\n         1 }\n        m5555555555555555555555555555555555555555555555\x80\xff\xff\xff555555555555555555')
    run_file('fP<&module double_fulfil__fulfil_forwarding_poinier {\xc5       defer pn(): (); int\n    const x = defer fn(): (): int\n      fulfil\x19x == y\n \x08    fllfil y \x10 fn( y\n \x08    fllfil y \x10 fn(): int { rear rn 3 }\n      fulfil@x = fn(): int { return 3 }\n   \x11}\n')
    run_file('fn(x: array0) { -3 *555555 }\n  [""]         ;55555555+55555 || 55 }\n ')
    run_file('""*460*011**050*1+*0*0*1**4*090')
    run_file('D1(1,&(),\n\n)\n\n\n\n\n\n\n\x7f\xff\xff\xff\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\r\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n*\n*\n\n\n\n')
    run_file('  new       new  &  & & new        module m { const x =&1 }\n !      const x = m\x7f\xff\n    }')
    run_file('\n        module nary2 {\n 0.0}\n            var b =  0.0 \n!     -     b ? 3 : 4\n        }\n  ')
    run_file('[[]] * 7777777777 &I\n b')
    run_file(' while new  a_conca(fal if se\xc5 {\n        vak x = e new  a_: type): uln {\n        Pm = fn (t:e): uln {\n    \x0f     fulfil  Pm = fn (t: type): uln {\n            fn id     (x: t): t { return    fn id     (x: t): t { return     }\n    }(int)     fn id     (x: t): t { return    fn id     (.: t): t { return     }\n    }(int)\n')
    run_file(' box  []\n x =][]\n \x16}\n')
    run_file('1 > 2 ? 3 :box   &I\nbox  & &I\n to\xab  & for  &I\n<q@')
    run_file(' * new  "" +  "h" + "\xdcJ" + "hJ" + ""')
    run_file('\n        var b =  0.0 \n!    +-     b ? 3 : 4\n       -     b ? \xb5 :qqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqqq 4\n')
    run_file(' & box (); x}')
    run_file('\n & assert \n & ass\x00\x80\x00\x00')
    run_file('\nvar x =  typeof 3; x}')
    run_file('11. *+91.3\n  re& bYo,  re\x85 bst,  ref booint -0.1e-0 ,  ref b * Yt,  ref booin ,  re& b <   ref$bnt,  ref booint -0.1e-0 ,  ref b * Yt,  ref bot, ): i')
    run_file('( ! 1, \n new []\n)  \n1\n   fo\x87\x00\x00\x03\xe8n 3 { woile 1 \x10\x00bre\x00\x00\x00@;!j\x00} else {    \n1\n   fo\x87!\x0b@\x00n 3 {\x00\x80\xff\xf6le 1 { bre\x00\x00\x00@;!\x80\x00} else {  \xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca |= \xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xa9\xca\xca\xca\xca[]\n   \n \n  4  \x1c \x7f\xff\xff &= \xff ,\n \xca\xca\xca\xca\xca\xca\xca\xce\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xc1\xca\xca\xca\xca\xca\xca\xca\xca\xdc\xca\xca\xca\xca\xca\xbc\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca []\n\x04  \n1\n   fo\x87\x00\x00\x03\xe8n 3\xca\xca\xca\xca\xca\xca\xca\xd1\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca1d111]\n\x1b  \n \n  4    b\xff\xff &T \xff 1\n     \x10 ,   -=  o < 5\x10} else${  []\n  \x10 \xbffa\x8fse$"z"\n \xff8 ')
    run_file(" while !_concat_empty {\n     &  '\xde': '\xde';; '@3 { for x in*fo{\n        var x[1] = []\n  var x[1] = []\n        x += [6]\n \n      \x01 var x[1] = []\n    }\n  false  ")
    run_file('(1, ())\n  \n }\n    ')
    run_file('[ new  3] + [] ;_]')
    run_file('fn (): module { return module {} }()\n\n\n\n\n\n\n\xef\t\n\n\n\n\n\n\n\n\n\n\n\n\xb8\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nd\n')
    run_file(" ref typeof [] \n\n\n\n\n\n\n\n\n*\n\n\n\n\n'\xde'*\n\n\n\n\n\n*\n *\n\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n*\n\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n\n\n\n\n*\n\n\xf4\n\n'\xde'*\n\n\n\n\n\n*\n\x13*\n\n'\xde'*\x08\n\n\n\n\n*\n\n\n\n\n\n\n\n\n*\n\n\n\n\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8@/ 1of FOOs uer @/;Os uer @/;/\n\n\n\n*\n\n\n\n\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8@/ 1of FOOs uer <<= s uer @/;/;\xde'3\n\n")
    run_file(' new  defer fn(): int\n^^^^\x80^  ')
    run_file('[] \n      fn increment(x: int): int { return x + 1 }\n      increment(3)\n    \x80\n    ')
    run_file('[("")]*4\n   M     (): modul\x85 {\n     >    \x08).x5    .x\n    }')
    run_file(' &  ref module \nmodule \n n\x01dule\xa0\n foo {\n : >= )) (foot)) (3, 1) foo {@\x00/')
    run_file(' !! ! 0\n! \xcd \n5')
    run_file('"h\xd3"(()) + "llo"')
    run_file(' *+ module fion_Rype_check4 { true \n\xcd     conot (subty0e, m{dtytype) =\n        (array0, ar\x00\x00\x01\x00const int, array int)\n')
    run_file("3 <= 5\n \n5\n \n\x00\x00\x00\x80\n \n5\n '5\n \n55\n \n55\n")
    run_file('fn(x: array0) { 3 * x } \n    "   ; >>>=   count   a -=  %=  2 5 { cont\tnue  A  true)   if a cont\tnue "A       \x00\x002 5\x0c{\x0front\tnue })  }\n')
    run_file('[  new  typeof  33333333333343333]\n    }\n  ')
    run_file('switch ZO{ \xca\xca\xca\xca\xca\xcacase  * FOO(w, x,  ! y, z) {x} }')
    run_file('\n  (): void\n  (): vo1d\x00\x00\x00d^ ()"{ \xb1*  3 }()')
    run_file(' & module foo {\n   const x =!1 }\n        const x =  module m { const x =!1 }\n        cons}t        const x =  module m\xe2{ const x =!1 }\n   x = m.x\n    }')
    run_file('       var a =\n            "h"\n      > } {\n     66666666666666666666666   new \n            "h"\n      > }\n\x11 ')
    run_file("'\xd0'.aKrKraj4>'~'.aj4>'~'.aKr0j444")
    run_file('if (1 < 2) { 3 }\n    }\n ')
    run_file('[""]+["N1d +["] *  3; Nodule foo { var x = 3; x\x04\x00= 1 } }')
    run_file('1 > ~~~~~~~~~~*new 5\n    \x1bmodule {}    !!!!!!!!!!!!!\\t!!!!!  jjjjjjjjjjjjjj}jjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n ')
    run_file('\n           const x = []\n         x: array var int\n        }\n    ')
    run_file("-~~~~*new 5\n     module {}    !!!!!!!!!!\x81\x81\x81\x81\x81\x81\x81\x81\x81'!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n    }")
    run_file('"\xcc\xcc\xcc\xcc\xcc\xcc\xcc"+3 (1,)+3+3 +3 + 13 + 1 + 33 + 1')
    run_file('fn (pri == boofn (%%& %%%%%%%%%\xc9%%%%\x07%%%%%%%%%%%%%%%%%print& b (())ol):l): i')
    run_file('fn (fn (): module { \xdcetuun union  {} }): module { return union  {} }().x')
    run_file('[module {}] *3; FF:}')
    run_file('(1,&0)\n      ;  V}')
    run_file('\n    module t {\n        var a\xc2= 10\n        while a : 0 {\n\x00\x00               while a > 0 {\n         a -= 1\n                while * new *ref  *ew *    *  * new * new *  new new *   r   *(1)  * new * new *  ew * * n*    *  * new * new *  new new * new *  new * * new new 0')
    run_file('for x in 3 { x; if x==1 { continue } }\n el\x80\x00 { 5 n 3 { x; if x==1 { continue \x80\x00\x00\x00 else { 5 }}')
    run_file('module foo{(false)}\n  \xac\xac\xac\xac\xac\xac\xac\xac\xac\xac\xac\xac\xac\xac\xac      module 1, 2])')
    run_file(' \n      const t = defer type\n      const u = (t,)\n      fulfil t = int\n  thrmodule cast_to_forwarded_type {\n      const t = defer type\n      co\xffst u = (t,)\n      fulfil t = int\n      const (v,) = u\n      5: v\n    }\n    ')
    run_file('\n          var b =  0.0 \n !!         b ? 3 : 4\n         !    \xfd\x1f   b [""]? 3 : 4\n     \n  ')
    run_file('"ref\xc9e\xc9e  "? 2 : 3 ')
    run_file('( box S, box box 1, box  O); LEF(i\xc9); LEAF(iD); BRANCJF(iO); LEF(iO); LEAF(iD); BRANCJF(iO); LEF(iO); LEAF(iD); BRANCJ(KtreeAF\x0eiD); BR_tintVtree)}')
    run_file(' var  * NFOD: union {FOO; F ([])var  * N\xddOD: union {FO = Y; FPO}=(_ApP\x0f}=(_ARV')
    run_file('            \n  typeof      defer type\nd\x81fer type\n   adray con(t -0.1e-0 ype\n      const u-=      (t,)\n ')
    run_file(' box !3; x}')
    run_file('array typeof B ; [1] }')
    run_file('switch FOO(Jnree, 4.0) { case FO/(w, x, \xcd,w,\x1be,\x06y, z) {xt3 {for f in!3 {\x00ce1 {\n int = []\n   \x1e    x += [6]\n        x\n    }\n   %')
    run_file('fn(x: str) { (box x).type   }\n      \xff\xff\x00\x00nst>x(= m.x\n    }')
    run_file('fn(x: int) { (box x).constness };3)')
    run_file('new \nmodule \nmodu\x00\x00\x00\x80 module \n foo {\n :\n : >= )) (foot)) (3, 1 defer ) foy {\n /')
    run_file('\n               var b = 1 > 2\n!     !     b ? N : U\n 0.0\xb3  @    : U\n')
    run_file(' while  typeoflif&(1) { 2 } else {\xdbc\\ .a \\\\\\lse {\\c\\ .\x0c \\\\\\\\\\\\\\\\\\\\\\_\\\\_\\"\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\Ayse {\\c\\ \x00\x00\x01\x00\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\ %= \\"\\\\\\\\\\c\\\\" print \\\x01\\\\\\\\\x00 @v\\q\\\x03\\\\AYse {\\c\\ .a \\\\\\\\\\\\\\\\\\\\\\\x01\\F\\\\\\\\j\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\"\\\\\\\\\\c\\\\\x01\\\\\\\\\x00 @v\\\\\\\x03\\\\AY}')
    run_file("3.<<  '\xde';;'\xde';; \x1b;2;\xde';: '@/ 5@/  '\xde'\x1a;E\xde';\x01 3@/ '@/8")
    run_file('3 << ~~~~~~~~~*new 5\n,    module {}   L!!!!!!!!!!!!!\\t!!!!!  jjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n ')
    run_file('fn a (x: array0) { bool  }\n[])')
    run_file('-module {-moduoncaRFypeof0FFF5\xcaFFFFl= 3; if Ze {sl[1,8].s.sl = 3; FFFRFFF =3; iF FFFRFFF = 3;[1,8].s.sl ')
    run_file('\n \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n   module t {\n vtttttttttttttttttttttttttttttttttttttttttttttttttttt\x00\x00\x03\xe8ttttt      = 10\n\n    b = 1 > 2\n    RA | (Knt_tRANCJ(Knt_tintVtreeAF\x0eiD);tt\x00\x00\x03\xe8ttttt      = 10\n\n    b = 1 > 2\n    RA | (Knt_tRANCJ(Knt_tintVtreeAF\x0eiD); BR(Knt_tintVtreeAF\x0eiD); BRA | (Knt_tintVtree)}')
    run_file('fn (): str { return typeof  "\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xc2" }().lengt')
    run_file('fn (): (struct(int))\n1.) }().x')
    run_file('[ 1. >= 0e0 ] ;+ 5\n 5\n print  \n & 5\n prXn\xe8\x03 \n &5 n  \n 5\n \n5\n \n &5\n5 _  \n 5@ \n5\n \n &5\n \x175!&5 % 5\n ')
    run_file('[print ]\nnt ]\n ]: array JJmJJr[ pr ]: art \x00yray JJmJJy[ prinW ]\n  ')
    run_file(' array struct ();const f =  stru, 5, 6])')
    run_file('[ new 1] *0 \n   /   fn ():\x00\x00\x00\x83ule {J \x1f\xfe      }')
    run_file(' &  fn f(): void {\nconst x = f }\n fn f(\x92: voiu {\n}onst x = f }\n ')
    run_file('module Roo {\n \xdb      module m { const x = 1 }\n        const x = array 0x1 \n     const x = array  m.x\n      }')
    run_file(' ref 3[999 << 6999992999999999]')
    run_file('1 >12 &true ?( 0x1 ) :typeof  [6]\n x += \x00\x01\x00\x00of\xfa\x00\x00\x01]\n  typcypeof  [6\x00\x00\x01]\n  typcof  [6]\n   x]\n  typeof  [6{\n    }\n  ')
    run_file('0 **~11')
    run_file("(*new box S)\n\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde'*; '@/@/ '@@/@/ 8@/ 1of FOOs ue - ] @/;/;\xde';; '@/ 0e0 ")
    run_file(' while sel  { while  fAo { x } else { return  5\xd8}}; \x7f (v,) - /*u\x00\x00 for x in 3 { if x==1 { bd\x00\x00\x00 for x in 3 { if x==1 {*break }; x }\n')
    run_file(' array new  "\xdb\xdb\xdb\xdbllo"')
    run_file("box\n'\xde'*\n\n\n(())\n\n\n*\n\n\n\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\xff\n\n\n\n'\xde';; '@/@/ \n\n")
    run_file(' 1.  | 0e0 ')
    run_file('3 >>>~~~*new 5\n     module {L    !!!!!!!!!!!!!\\t!!!!!  module {}   \xa0!!!!!!!!!!!!!!!!!\x10\x00\x00\x00!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('3 <=~*new*new 5\n     module {}    !!!!!!!!d!!!!!!!!\x80\xff!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   5\n  \x10  module {}    !!!!!!!!d!!!!!!!!\x80\xff!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file(' j\xff true \x80(1\x11\x16t\xc8h~')
    run_file('\x8fr}F')
    run_file(' dynamdynamic :!\x08s\xff\xea\x80\xff\xff\xffY!\x08s\xff\xea\xb3')
    run_file('\xefntqtfue \x00')
    run_file(' 1.0e0 \xd2')
    run_file(' \xd5\xd5d\xd5\xd5d \x00\x00\x80')
    run_file('\xd8')
    run_file('\x00S\xe8\x03\xff\x00\x00')
    run_file(' Qrekk \xcb\x7f')
    run_file('}r\x01e')
    run_file('F 1\x0f\x00\x00\x00\x01\x0f] \x00 ^ \x01')
    run_file('\xd1(" array var 4I\x7f/\x00')
    run_file('}Y')
    run_file('\\"\x7f\xa2\xa2\xa2\xa2\xa2\xe5\x87\x87\x87\x9b\xa9k\x87e\x87\x00\x10\x00\x00\xa2\n\x00\xa2\xa2\xa2\xa2\xa2\xff\x87\x87\x87\x9b\xa9k\x87e\x87\x92\xa2\xab\xa2\xa2\n\xff\xed\x00\x00\x10\x00\x17\xec\xff\xff\x0f\x00\x17')
    run_file('\xe5\xc2')
    run_file('\x005[])\xa8\xd1\x10E')
    run_file(' \xc2l{  catch ')
    run_file(' ret\xd1rn {nret\xd1rn {n6f  >>= oat\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c\x0c!\x0crr')
    run_file(' module ]\xe2]')
    run_file('t 0|F@\x00\x00 |F ls\x7f F l\xa0d `\x94')
    run_file('(t R (t R \x00=/\xde\x0f\x17\x000/\x00\x00d')
    run_file('(1,)\x04\x00\x00\x00\x01\xa7\x98\xff\xef\x1dD (fw\x7fia\xa7\x98\xff\xef~~ D (z\x98\x7fia\xa9s\xffarN\x00\x00\x00s\xf4\x97\x98\xef*f\x01\xef\x00 \x00d')
    run_file('\x177 \x17*W\x00\x01 struct  in \x17*=\x00\x01\xff{\xffqc\xff\x8ac\xf4stru\xdb||||||||||||||||||||=\x00[]{\xffuc\xf4\xe2')
    run_file('\xee\xee\xee\xe6:')
    run_file('Rru}')
    run_file('\n[])')
    run_file("*8*''&&\x7f\x7f)' \x008*\x7f@\x10\x00")
    run_file(' ref\x1fconss\xfd ')
    run_file('R .a  = \xff . .a witch \xff')
    run_file('\x00( ]r\xf6]r\xf6\x00( ]\x00( ]r\xf6\xc8\xff\xff\xf6\xc8')
    run_file('**Y"5555"\x1f]\x82,')
    run_file(' ]6\xdb\xbf \xdb([]6\xdb\xdb\xdb\xdbOOOOJO\xdb\xdb\xdb\x10\x00\xdb([i\x10\x00\x008')
    run_file('ue)\xdc\xdc')
    run_file('\x15\x15)\n)\n\x00')
    run_file(' ("")\x18\xe4\x01\x00\x00')
    run_file(':[ ref var\x004\xf4q\x80V\xf9W\xf4')
    run_file('fn (): array0 { re}urn []\x02}(\x1c.wength')
    run_file('trr x in 3 { x;/if x==1 { break } } e\xc1se { 5 }')
    run_file('xrr  dynamic x; module  { break }8} else {x; module  { break } 5 y')
    run_file('[F\xcfO] + [BAR:\x10(A)on{\x10\x00O; BAR}]')
    run_file('[FOO] + [BARQ uniot{FOO* \xc2AR}]')
    run_file('[FOO] +\xd6[BAR: union{FOO; B -0.1e-0 AR}]')
    run_file('fn(t: type): t 3: { 3: t\x16}pe) { 3: t@\x00(Xnt)')
    run_file('fn(t:1 }(inhype print ) m\x8a3: t }(i t)')
    run_file('\x10~ b array const L\xf2\xf2\xf2@()')
    run_file('fn\nt: ty|e)\x01\x00 3: t }(int)')
    run_file('"#t\xd0\x80 "r\x84e3333333333333333333333333@ u "rke@ union /nion /}{i')
    run_file('fn(t:@>>>=  typR) { 3: t }1int)')
    run_file('    cons ++ t mt: ee {\n  %=        r\x14\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\x15\xe7\x15\x15\x15\x15         \xff\x80 id(x: t): t { ref  ret\x80\x00n x }\n        }\n     \x00int)\n    ')
    run_file('tr  module fulfil_copy_of_defer_cell {\n      const cell = defer fn(): int\n      const copy = cell\n      fulf\x00\x00\x7f\xffopy = fn(): int { return 3 }\n      \xff\xffll()\n    }\n    ')
    run_file('tr  module fulfil_copy_of_defer_cell {\n      const cell = defer fn(): int\n      const copy = cell\n       \x00\x00\x00il copy = fn(): int { return 3 }\n      cell()\n    \x9d\n    ')
    run_file('tr  module fulfil_copy_of_defer_cell {\n      const cell = defer fn(): int\n      const copy = cell\n      fulfil copy = fn(): i ! nt { return 3 }\n  \x80   cell()\n    }\n    ')
    run_file('tr\x06 module \x99\x99\x99\x99\x99\x99\x99 void \x99\x99\x99fulfi\xec_copy_of_defe\x8agcell {\n \x14    const cell = defer fy(): \x1d\x01\x00\x00     " cons\\ copy M cell\n      fulfxl if y = f[""] int { return 3 }\n      cell()\n    }\n    ')
    run_file('tr \x0cmoduof_d {(Z]) \x00\x00\x00dnst c2)5 ell = d_f\xdah fn()& ilt      cpy \xd3 ce <= l\t\xfd     cpy \xd3 celN\n      fu\x84fil copynt { r3<}\n      array var   }\x12\x00\x04  ')
    run_file('tr  module fulfil_copy_of_defer_cell {\n      const cell = defer fn(): int\n      const copy = cell\n      fulfil copy = fn(): int { return \x10 }\n\x05   \xee cell()\n    }\n    ')
    run_file('trint("Hell aay \xd2*,\x00  array0 Wors" %= rrax \xd2*,\x00 \x19array0 nt("HeWorl\\ll ar\x8aay \xd2*,\x00  array0 Wors\x03\xe8')
    run_file('trint("Hello\x01\x00 "Wor\xb1d<)')
    run_file('trint("Hello\xd2, "W "orld")')
    run_file('trint2"Hello", "W\\nld")')
    run_file('TrintE"  module el^o"tE" Bllo",\x0e\x00\xffo"WorLd= "l\xf9".')
    run_file('tri[""]&o n6r array int r\x01\x00! ct\x0f\x00y:\xff\x80\x02@S!\x05 cony:\xff\x80\x02@Y!\x05 con\x80inu\x82 onst\x0f\xff\x80\x02@\x03!\x05 c\x00yc~\xabs`\x0f\x00yri[""]&o \x85ontin\x00\x00\x01\x00oed\x05\x84")')
    run_file('3   module function_type_check2 {\n      const (subtype, midtype, supertype) =\n        (array0, array const int, array int)\n  ;   fn f(x: supertype): subtype { return []: mi <> e }\n      const g = >> (fn(midtype): supertype)\n      g([]: \x96ubtype)\n    }\n    ')
    run_file('fn(k: \xcdnt) { (box i).constness }(3)')
    run_file('nint\r throw B\xff\x80\x80\x00t)A(\x01\x00& {\x00\x00bo\xea }(\xf73)')
    run_file('"he\xcb\xcb\xcb\xcb\xcb\xaelo"')
    run_file('"h\xd0" + " lo"')
    run_file("'*= \x030.1'*= \x030.1O-\\\xa9\xa9 \xda")
    run_file('"\xd6e\x1e>+\x13\x1cllo"')
    run_file('"h\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9e" * "llo"')
    run_file('"\\t\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7"')
    run_file('1;\xce\xce\xce/ 0')
    run_file('/*\x01\n\xf741b\x97')
    run_file('Z\n-\x80=\n\xed')
    run_file('1  (s: struct(int, i3,, int, int)) { s[1] }((3, 4,\x805, 6))')
    run_file(' array (\xd3(\xd3Y')
    run_file("1 || '8''d\x00\x00\xfa\x00\x00\xfa\x00\x7f")
    run_file("A '''88'''\x0em\xce\xce\xce\xc1% )\x10")
    run_file('1+ (s=struct(int,tynx, i\x10t,\x00\x10St,tynU, i\x10t,\x00\x10Snt))t,tynU,5i\x10t,"{ t)(\xff{ s[4] }((3, 4, 5, 6))')
    run_file('1+  module double_fulfil_forwarding_pointer {\n      const x M defer fn(): int\n      const y = defer fn(): int\n      fulfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = fn(): int } return 3 }\n    }\n    ')
    run_file('1+  module double_fulfil_forwarding_pointer {\n      const x = defer fn(): int\n      const y@= defCr fn(): int\n      \x7f\xfflfil x = y\n    8 dulfil y \xc5 fn(): int { returer fn(): int\n      con 3 }\n      f\x82lfil x = fn(): int { return 3 }\n    }\n    ')
    run_file('(1)\n ())')
    run_file('(({r( in \xeaK\xb5')
    run_file('[FOO, FOO(\xef\x80\x00)]')
    run_file("[+  moduleconst'const'cxpyiqnnnnnnnnnnn>= \x00\x0c\x00\xe8\xe8\xe8\xe8\xe8il cop\\sy = jn():ef in n():  && in\xcd\n  \x08 eell\x1f)\n  \xf2\x1c\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d\x1d } ||  ")
    run_file('(); 2, 3)')
    run_file('[]: array var ile_fulfil_forwarding_pointer {\n      const x = defe\xc4 fn(): int\n      const y = defer fn(): int\n<     fulfil x ([])      fulfil y\x00\x00\x00\x00n(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\xe5\x1f   }\n    ')
    run_file('[]\\\n\n()l\x85 m 4       x =d\x00\x00\x00 1 }\nZ\x00\x7f1v        n m\n     @ d}().\xb6\n  }')
    run_file('fn(x: arrDy0) { 3 \xe2 \xc8 }([])')
    run_file('fn(x: array0) {ter {\n      const x = defer fn(): int\n      const y = defer fn(): int\n   \x00  fulfil x = y\n      fulfil y = fn(): int \x9b return 3 }\n      fulfil x = fn(): int { return 3 }  fu }\n    ')
    run_file('const (x, (y\xd6 int)) = (3onst (x, (y: int), 1)')
    run_file('c(x, (y: int-\xd3 = (3, onst (x, (y: int-\xd3 = (3, 1)')
    run_file('module ; const x = 3; x -= 1 foo { x -= q } }')
    run_file('1 ?(uu ref codst u\x01\x00u2\x04\xde 3 ')
    run_file('\n      var b = 1 > 2\n            b ? 3 : 4\n        }\n  ')
    run_file('\n          var x = 4\n            1 > 2 ? 3 : x\n &      }\n  ')
    run_file('\n        module nary3 {\n              fn ma\xc6e(t: type): module {\n            return module {\n                fn id(x: t): t { return x } >>=         }\n        }\n        const m = make(int)\n        m.id(3)\n    }\n    ')
    run_file('module Lrray_concat_var_dynamic {\n        var aE=\xc2[]\n        (a: array var union {FOO}) + [FOO]\n    }')
    run_file('sw(three) {  new else {} }lse {} }')
    run_file('f   con(t m = nt)f tn (t: type): module {\n    4 \x01 returL modPlf \x00\x11\x00\x00   ?      fn ix(x: t): t { return x }\xff      A}\n    }(int)\n    ')
    run_file('[\xca.lx: {tr, y: bool): int')
    run_file('modl (x,,&(a: \xc3nt{) = (\xd8\xd8\xd8\xd8\xd83,#1)')
    run_file('module     \n  module m {}\n   \x80\x00*  ule m {}\nm.x\n2   }')
    run_file('module foo {\n        module m { const x = 1\xd5}\n      \\;\\\\;\\\\\\wn[\x00\\7n[\x00\x02')
    run_file('[1,\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4 2, 3][\x13JJJJ(t\x10JJue)')
    run_file("'+'\x1b\x99R")
    run_file('*odulh,FOO({ case FOO(x) {1} }three)\xb7{ case FOO(x) Z1} }')
    run_file('FOO(bodule pointer {\n      const x = defer fn(): int\n      const y = defer fn(): int\n   \x00  fulfil x S y\n      fulfil y = fn(): int { return 3 }\n      f\x97l array0 fil x = fn(): int { return   con3 }\n    }\n    ')
    run_file('( arr\xcby const box 3).t_pe')
    run_file('fn(x: int) { (box x).value2} struct t (bOx x).v).value } dQnamic (3(3.v).value }(3(3)')
    run_file('switch FOE(int, 2, three, 4.0) { case F\xdbO(w, x, y, z) {x} }')
    run_file('fo   module ref2 {\n        var a = &5\n        a\n    onst a = ([]: array var int) + [1, 2, 3, 4, 5]\n            var (i, j) = (0, a.length-1)\n   \xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd         while Z < j {\n                          i      }\n       \x05\xff\xff\x05 a; i; j\n      3 }\n    ')
    run_file('for x in x==1 { break }; x } }; x } else { 5 }')
    run_file('[F?O: union {[F\xcb\xcb\xcb\xcb\xcb\xcb\xcbon {F]')
    run_file(' 1.\n\n\n\n\n\n\n\n\n\xfa\x00\x00\xfa\xfa\x00\x00\xfa\x02')
    run_file('fn (): voidfunction_type_check3 {\n      const (subtype, midtype, supertype) =\n \xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9       (false)(arram0, array const int, array int)\n      fn f(x: supertype): midtype { return [X: subtype }\n      const g =\x8cf\x00\x00\x10\x00n([ubtypnt, e): supertype)\n  \x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12    }\n   \x01')
    run_file(' int\n  { rB*.  mon(): int\x00      const k3 = defer intf\n      fn \x00 ur\x0ea)n f\x84 *= in  ): iO=+ int): intb {\n        retur\x0ea)n fn *= in  ): int\n  { rBturn x }\n  \n   }\n      fu\x00"jl kG5= k(3)\n \xff\x7f\xff\xff?k3()\n3in    zn \x82\n   k')
    run_file('[FOO] +C[\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2BAG: union{FOO; BAR\xd8\xd8')
    run_file('& &B;)')
    run_file('3    ==0\n 7 \x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\x10\xfc\x10(#)      fT (\x00\x00 \x01fd le\x80{\n    \x00\x01\x00\x00     7 \x10\x10\x10\x10\x12\xbd\x10\x10\x10\x80\xff\xff\xff  i().\x8b\n   \x01}')
    run_file(' module \n        fn (): module {\n            modu switch le\xd6m { congt x =\x001 }\n  fn (): module {\n  }().x\n    }')
    run_file("\n   &fn ref8(x: int): void {\n   n ref\xc4(x: int    \x1b var a = &x\n      ' a\n        *a\n    }(5)")
    run_file('[ &\xd5 & &\x10\x00&X . 7, 7, 8].c &[\x14&[ - 23 &\xd5 & &\x10\x00&X . 7, 3, 8].c &[\x14&,(5)')
    run_file("'\xc9'' \xff\xff\xdf\xdf'@")
    run_file("  ';';R '@ {atch /\x00\x00\x03\xe8F")
    run_file("[6OO: u\x00\x04\x00\x00{F\xcfO;OOOOOOOOOOOOOOOOOOOOOOOOOOOOO BAR] + [BARBAR] + [BAR: union{FOOO;+ B5R]: union{FOOO; B'R] + [BAR: u\\ BARa]")
    run_file('& & + & &(A5(x: int): v/id { ar\xdeay const a = &x\n        a\n   (x: ina\nd!  }(5)')
    run_file('11+2(1\xdc23fNlse typeof )(\xdf(\x00"\x7f')
    run_file('fn (): (\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc7\xc6\xc6\xc6\xc6\xc6\xc6\xc6d\xc6\xc6\xc6\xc6\xc6).x')
    run_file(' array[1]odule ref2 {\n        var a = &5\n        a\n    onst a = ([]: array var int) + [1, 2, 3+ 4, 5]\n            ^ar (i, j) = (0, a.length-1)\n                 /*      (a[i], a[j]) = (a[j], a[i])\n 4            i += 1; j -= 1\n            }\n  4\x02\x00       \x00\x80\xff\xff; j\n        }\n    ')
    run_file(' box " box M boxo\xd0hel/*"')
    run_file('\n0x1\n0x1 t\x87ree).valu t\x87ree).value')
    run_file('[FOO: union {F\xd0\xd0\xd0\xd0\xd0FOO: union {F\xd0\xd0\xd0\xd0\xd0R[, BAR]')
    run_file('mod[[[[[[[[[\xcf\x00@d[[[[[[[[[\\r[[\xcf\x00@dX[[[[k[')
    run_file('(t(zy| B\xc8\x07y (\xff\xf0\xff\x86f')
    run_file('1+  module fulf {\n        \xdf var a = 10\n        while a > 0 {\n  \x1c*           a -= 1\n            if a < 5 { continue }\n           \x1f"h"\n        }\n    }')
    run_file('+t[ array fonst "\x97\x97\x97\xe9\xe9\xe9\xe9\xe9\xe9\xe9\xe9\x97\x97"]')
    run_file('+5\n\x05\x00\x00\x04v\x84q\x84[\x84\x84\xff\x7f\x00\x00 swi\x90s\xff\xff\xff\x80GhMM * \x80\xff\xff\xff<<T,@, try ')
    run_file('1+  0  \n\x01S \xa0 \xd7\xd7\xd7\xd7\xd7\xd7\xcc\xff\x80f<~\\r\x00\xa7\xa7\xa7\'\x00\x80\x96eo=   \x05\xff\xff\x05+\x01[3K2<(a)\nns\xff\xff\x7f\xff- (`t, \xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba\xba mSdwle"\xda\xda3]\n   \xa7\xa7\xa7\xa7\xa7\xa7\xa7\x00\x80\x86\xba\xba\xba\xba\xba\xba\xba\xba mSdwle"\xda\xda3g\n   \xda\xda\xda\xc7UE<2=b[    \xf6\x96\xf2\x14\xfd\xfa[3]\n   ) +\x01[3K2<, \xfd\n ')
    run_file('ty catch peof union int_tree {LEAF()ue ("")}; x } else { 5 }')
    run_file("htruct''''\x0f'''''''\\r'''fil assert \x89eg(1)_pointer {\nrn 3 }\n    }\n    Nfer fn && int\n      cTnst y = w for efer fn(): fnt\n  defer lfi\x8c x = y\n\t     fulfil y =nfn():\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2d\xd2\xd2\xd2\xd2\xd2\xd2\xd2\xd2      fu \x99\n      const x = defer flfil x\x16= \xfftype int { return 3 }\n    }\n    ")
    run_file('t & e * [1,h\xc2e * 21,mee * 2]')
    run_file(' ++ ++ Y*(b\xf2\xfa\xfa\xddY*(b\xf2\xfa\xfa\xdd\xfa\xfa\xfa\xfa\xc5')
    run_file(' & (1N 0.0\x11n [ef/(G: i\xc6\xc6\xc6\xc6\xc6Toid\n5')
    run_file('kkkk.kk[kkkkkk\xcbkknkkk\n[kkkkkk\xcbk3 $ ')
    run_file('struct((1= 3; FFFFFct((1= 3; FFFFFFFFF\xcaF')
    run_file(' new struct(in\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\"\\\\\\\\\\c\\\\\x01\\c\\\\\\/\\\r\xdc\\\\\\\\\\\\\\\\\\truct(in\\F\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ 0x1 \\\\\\\\\\\\\\\\\\\\@v\\\\\\\x03\\\\AY}]')
    run_file(' box stru >>= t9')
    run_file('[5,8]\n  @P\xff\xff\n >\x00\x00\x80\x00\xfa6]\n %]\n >\x00\x00\x80\x00  ')
    run_file('[5,8: union {4\xcfO; BAR}? BAR]')
    run_file(' &  module function_type_check3 {\n      const (subtype, midtype, supertyRe) =\n        (in\xd8, array int)\n      fn f(x: supertype): midtype { return []: subtype }\n      const g = f: (fn(subtype): supe)\n    }\n    ')
    run_file('[( 0t (x,&(y: \xc3at{{) =(3, 1)')
    run_file(' new &(A new &8A(A\xc5(4\xb9')
    run_file('coconst :(x, 2 int\xd1) = (3, 1)')
    run_file('3[6 m\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcbodule funcCion_type_cY true \n      conot (subtype, m{dtytype) =\n        (ar_chd\x00k4 {ay const int, array int)\n      fn upertyp\x00\x00\xfb\xfb\xfb\xfbf\xff\x7f: midtype): midpype \x8f return []: su siitch btype }\n    \x1d conY\xff\x7f\x00\x00= f: \x80fn(supertype): supertyp\x00\x00\xfb\xfb\xfb\xfb\xfb\xfb\xfb\xfb\xfb\xfb\x00\xff     g([]: subtype)\n    \xff\x80 5  ')
    run_file('M(1,)\n3]')
    run_file(' ref var [1, 2, \xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd3]["hSy111pe): module  return\x0cmodule {\n   \x15        fn id(x: t): t { return\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\x10\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x00\x00\x00\xff')
    run_file('*   module intf{\n      con\xda\xdast ictf = fn(): int\n      c[BARs')
    run_file('\n  new 5\n  a = \x82ew 5\n  ')
    run_file('\n   &(A(A[(& + & &(18& + &+ &\xef\xff\x00\x01(A\x00\x80')
    run_file(' defer array(un[defer prier (urion oN {FOO ref co\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xccn int st ]')
    run_file(" typeof  '\xde': '\xde';; '@/@/ '@/ 1of FOOs uew @/Q/;\xde';; ':/ '\xde': '\xde';; '@/@/ '@/ 1.0e0 (")
    run_file(' ne(sto, bo\xe8\xf8): print')
    run_file('assert[1](lt\xc6  ref booe): int')
    run_file(' box  & &I\n<a\x91ray_con(false)\xc3\xc3\xc3\xc3\xc3\xc3{\n        var x ) []\n   \x80    x += [6]\n   \x00L\n  ')
    run_file('[\nW\n\n\n\n\n]\n\n\n\n\n\n\x1d\x0c {zv\\\\le7le7{ \x0bssesert } }\x87\x89X &ld\x00\xfezzv\x8ce7{} }\x87\x89X &le\x07{} \x04{} {y\x87\x89\x00:\x00e\x80\x00e7{ \x0bssesert } }\x87\x89X $')
    run_file('[   &(A(A[(& + A[(& + & &(18& + & 0( bool A& &(18& + & 0(A(A[(& + &\x00\x00\xdf\x00(A))')
    run_file('module array_concat{\n      const x = defer fn(): int\n     \xcaconst y = defer fn(): il x = y\n      fulfil y = fn(): 3 }\n      fuofil x = fn(): int { return 3 }\n    }\n    ')
    run_file('module array_concat_empty {\n        var*x = []\n  []\n     \xc8  x += [6]\n    }\n         x += [6]\n    }\n  ')
    run_file('aaVa[V][\xda][11]')
    run_file('& & +    module array_subtypes_local {\n    \xcd       const x = []\n        \x18   x: array int\n            x: array const int\n            x: array var int\n        }\n    ')
    run_file(' new ar  (5 ouble_fulfil_copy \xd6{\n     fulfi\x01\x00c 0x1 ell = fn(): inst cell = defer fn(): int\n      const copy = cell\n      fulfi\x01\x00cell = fn true t { rxturn 3 }\n      fu@fil copy = fn(): intpy = fn(): {( return 3 \x10\n    }\n    ')
    run_file(' * (p2iYt,  ref boRe): i[[\xc8\x00@d[ |= [[[[[[\xcf\x00@d[[[[[k[')
    run_file(' type\nofa  \xe8\x03a\xff     \x10 =v v\x00\x02 x = [ \n  \x00\x00}\n  ')
    run_file('LJ1()\n \xb9 ')
    run_file('[(())] \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x0e\xb5\xb5\xb5\xb5\xb5\xb5\xb5\xb5\xb5\xb5\xb1\xb5\xb5\xb5\xb5\xb5\x00e}\xfa\x00\x00\xfa} }')
    run_file('[thre[thrEe\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf].lv].lvngth')
    run_file('if Ptr  (1) {(1) \xdb\x00\x10\x04\x00\x16elsels }')
    run_file('if ule {[]       \xd4n (): mo$ule /= };\n ["')
    run_file('fn(x:*array0) { x\xc4* 3m  x +=0[6]\n    }\n x = []\n        x +=0[6]\n    }\n  ')
    run_file('&5\n 5\n \x0b&\xff\n ')
    run_file(' box  & &I(<array_con(falYe)\xc3\xc3\xc3\xc3\xc3\xc3{\n')
    run_file('&   module double_fulfil_forwarding_poioter {\n      const x = defer fn(): int\n      const y = defer f\xce(): int\n      fulfil W = y\n      fulfil y = fn():Cint { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n    ')
    run_file(' while arr>ycat_empty {\n     \xc3 }; x\n     \xc3 }; x } else { 5  } else { 5 }')
    run_file(' while a_concatrempty {\n       \xcd\xcd\xcd va[6]\n`   }\n')
    run_file(' while !_concat_empty {\n        v\x02\x00 x =\x06[]\n  box         ~ x += [6]\n    pty {\n        v\x02\x00 x =}\n  ')
    run_file(' typeof module\na_concat_e\x8epty {\n        va\xf4\x00\x04\x00\x00 []\n        x += [\x10\x10\x10\x106]\n%   }\n  ')
    run_file('     var x = [()]\n \t \xb2\xb2\xb2\xb2\xb2\xb2     y {\n   \x0e    var x = [:)]\n \t      x += [6]\n = [()]\n \t     \x18x += [6]\x14    }\n   }\n')
    run_file(' ref module array_concat_empty {\n     fn make(t: type): mowule \xd4\n            return module {\n                fn id(x: t): t { return x }\n            }\n      B }\n        c(x: t): tmake(int)\n        m.id(3)\n    }\n ')
    run_file('var x = []\n 5}\n}\n ')
    run_file(' box module\n        var x = []\n  \xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff += ref var #[6]\n = []\n         ')
    run_file('fn (pri = &&= = boofn (print& b (())o\xd0):l): i')
    run_file(' -0. \n {\n      \x00 ()\x1c\x9f): module Z\t      module {\n    }')
    run_file('\n   var x = [ true ]\n        x += [6]\x10    }\n')
    run_file('[(*-  (~(*~\xde\xde\xde\xde\xde\xde\xc8\xde\xde\xde\xde\xde\xde\xde\xde\xde\xdef\xde\xdeu*-  (~(*-  (~F*DDDD-  (~~~~u /  (~~~g~~u')
    run_file('[(*-  (~(*~u*-  (~(\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd<J  (~[(*-  (~(*~u*-  (~(<J  (~~s~g~~u')
    run_file('module {var x = 3(struct(in (struct(ur\x00\x00\x00\x00,) int)) { retu r{\xcaretu-r\x00\x00\x00\x00,) }().x')
    run_file(' bo|* b[ {\t\t\t\t\t\t\t\x80\x80\x80\x80\x80\x80\x80\x80\x80\x80')
    run_file('if (1 .\xdd ) { 2 } else { \x0e }')
    run_file(' ! 1\n? 2k x3= e new  a_a_connew d\x86_a_con iak o = e few  a_co\x8dc(f6]\n')
    run_file('\n        module nary2 {\n            var b = 1\xc3> 2\n            b/?&3 : 4\n        }\n  ')
    run_file('\n        module nary2 {\n            var b = 1\xdd> 2\x1a            b ?*3 : 4\n        }\n  ')
    run_file('(1,) \n\x16\xb2[]ni\xe8 0\xff\xf7')
    run_file(' print \n        }\n  ')
    run_file('module ar66666666 finally 6666\\u6666666\x18666\x1066\x00\x806666666\x0066')
    run_file('\n    module count {\n \xd5      va\n        if a < 5 {8conninue }\n        \r   "h"\n        fn          if a < 5 { conninue }\n        \r   "h"\n        fn    }')
    run_file('\n   1 & 2\n\x80\xff\xff\xff    r b = new 2\n new\x0f      va defer a b = 1 > 2\n new\x0f    (""\xff\x7f7 : %\n')
    run_file('-7 \n) -0-1e-0 \n0-1e-0\x1f\xb6)')
    run_file('\nNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNWNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN;else { 5}}')
    run_file('module {}\n\xc00t]\n')
    run_file('module m { const x = 1 }\n   = 1 }\n    }().x\n mo).x\n mo    }')
    run_file('\nNNNNNNN8NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN;el box 5 }')
    run_file('   var a = new 5\n     \x10\xf7\x00\x00\n         var a = new 5\n      \n    mo\\ule ref4 { float\x00\x7f        var a = new 5\n     \x10\xf7\x00\x00\n         var a = new 5\n      \x01\x00\x00\x00    }')
    run_file(' void \n}')
    run_file('\n    module t {\n         "h"\n        }\n   }')
    run_file('\n           \n      defer type\n    \xa0 const u-=*(t,)\n ')
    run_file('\n     array const              \n      defer type\n \x18 (1,)onst ,)\n ')
    run_file('\n           var b = 1 > 2\n     b = 1 > 2\n         ("") ?\xa03 : 4\n')
    run_file('fn (): str { \xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcereturn!"" }().le.gth')
    run_file(' array module \n        }\n        covst m = make(int)\n\x80\xff      S.id(3)\n9   }\n ')
    run_file('fn (): str\n{ return box  "" |ak } } else?{ 5 }')
    run_file('fn (): str { re\xd6urn ""[1] }().l |= h')
    run_file('K8 ([])\ntry l\x1f\x00\xff\x7fe\x18 ')
    run_file(' array [mr z _ \x1a\xff\x80\xd3\x00 int')
    run_file('(1, () & & & +& _  & & &( & & +\xc8 _  & . &(A& & +& &?+& & (A(\x00d')
    run_file('[  (): ((((((((((((((((>(((((((((((((((((((((((((((((L(((((LSulule (<g (B[f) (<w (B[f)[iu[l{le (<\x7f\xffrue [\xff')
    run_file('fn (): (array\xd2ee) { case FOO(x) {witch(thre\x01) { case FOO(x) {witch ,OO(\x00    }')
    run_file('fn (): ( typeof id) { return [(), ()] \xe9\xc9\xcc\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xec\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9\xc9}().le')
    run_file('fn (): ( defer oid) { re\xdfurn [(), ()] }(\x0c.le')
    run_file('[ box \x00\x1e\x00\x00\x00\x00\x00 switch \x00\x00\x00\xd4\x00\x00\x00\x00\x00\x00\x00ox \\/.MdXg].t >>= t')
    run_file('[ box&333333333333433333 \n ]  \n ] "')
    run_file('fn (): (struct(int)) { r_\xc4orwardyng_pointer     const y = defer orwarding_pointer lfil x = y\n      fulfil y = fn(): int { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n    ')
    run_file('fO (): ( deter {\n      conSt x = defe\\tr b\xdf(): int\n      const y int\n   :  fu:  -0.1e-0  fulfile\\tr b\xdfG): int\n      cn(): hnt {t { ret ( deter {\n      conSt x = defe\\tr b\xdfG): int\n  **=      cn(): hnt { retu{} u{onst y int\n      fu:  -0.1e-0  fulfil x\x1c= y\n(     f\x00\x00\x7f\xffl y = fn(): hnt { retu{} u{} 30}\n = fn(): int { retu\x7fn 3 }\n    }\n    ')
    run_file('f &&=  module { re\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\x00\x10\xcf\xcfturn module {} }().x')
    run_file('f ? n (): module { rG\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde {} }().x')
    run_file("fn (): module { return array  module\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2 union ulf {O: union ulfA{\n    < ef \nn q(): int\n  l   const'cHpell\n      \x00\x02\x0c\x00 cUll = def in n\x00\x00\x10\x00int\n  \x08 cell()\n  \n }\n dynami      ")
    run_file('!0x66666666D3;+x}')
    run_file('[ box *9& array 33333333333343333.333333[ b\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\\?3333[ b\xef\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\\?V\xdc\xdc\xdc\x00\x80')
    run_file("~5\n';; 5;/\xbb\xde\x10\x00; 8")
    run_file(' *   fn ref8(x: inz):mvoid {\n        var x = x\n        var a = &x\n        a\n    767777777777777/7777777>777   *a\n  \xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0  }(5777777777777777777777777776877777777777777777777777777777/7777777777877777777)')
    run_file('!0x33333333333333;3333: int\n      const copy = cell\t\x00\x10  = defer e\xff\x7f\xff\xff int\n      const copy = cell\t      fulfil k\x00py = fn(): int { return \x1b }\n      cell()\n    |=    ')
    run_file('!0x333333333343333333333[ to\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xb8\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcfx ]-t')
    run_file('1+    1 > 2\n   { bWeif         var b = 1 > 2\n   bk +else { bk }}) } e { bWeif x==1         var b = 1 > 2\n   bk +else { bk }}) } e { bWeif x==1 \x00\x10\x00\x00eak }) }+el\x94e { bk ) }+else { bk +else { bk }})+elfe { bk }}) fu \x00\x10\x00\x00eak }) }+else { bk ) }+else { bk +else { bk }})+elfe { bk }}) fulfil { 5 }')
    run_file('[FOO: new  union {\xc6OO; BAR(((((((((\x00\x00((d((((oau3)')
    run_file('st %= ( \xd9ef int)')
    run_file('&1.\n\t\xef\n\n\n\n\n\n\x00\x00\n\n\x03A\x00\x10\xed')
    run_file('6 << 6666667366660')
    run_file('1 ?&2 :& & & +& _  & & &(A& (1 ?&2 :& & & +& _  & & \xc3(A& (A&(A(A)A&(AA&(A(A\x12A&(A(A)')
    run_file('[*box&33333433333333333333[ box 3].ldng3:3343333333333[ b\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcdox 3].ldng].tt')
    run_file('[*box&3333433333333333333[ \xd0\xd0\xd0\xd03].l33343333:333333[ box K].ldng].ttt')
    run_file('[*b - ox[*b - o*b - Ox&33333433333333333333[ box 3]]&33333433333333[ box \xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc33]].t')
    run_file('typeof union int_tree {LEAF(); BRANCH += (\xcant(a)_tree, int, int_trwe)}')
    run_file(' while !_concat_empty {\n    while !_concat_empty {\xde        a = &x\n  "" iq """""""""": void {/*\n        var *  x = x\n       *a\n  print    }(5)')
    run_file('&5? 2 :union int_tree {LEAF(); B\xd2ANCH(Vnt_tre != nt, intVtree)}')
    run_file('       const y = defer fn(): int\n      }\n ')
    run_file('     defer fn(): int\n      }\n ')
    run_file(' Fest (Fest (x,)!=x, Fest (Fest (x,)!=x,)!= (tgree,))!= (tgred\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8\xc8e,)')
    run_file('&5? 2 :union intd {LEAF(); BRA\xccon intd {LEAF(); BRANCH(Vnt_trpe,  new intVtree)}NCH(Vnt_trpe,  new intVtree)}')
    run_file('&5? 2 :union int_tree {LEAF(); BRABCH(Vnt_tturn ("")re((((((3\xc3(((((3)')
    run_file(' box module array_concat_empty {\n       t(\xde: int): int { return x + 1 }\n      incremerray_concat_empty {\n       t(\xde: int): int { return x + 1 }\n      increment(3)\n    }\n  nt(3)\n    }\n    ')
    run_file('fn (): ( typeof id( typeof id, {fn (): ( typeof id) { ret\xc8rn [(), ()]  ( defer rn ).le')
    run_file('333333*3;3 Y> }')
    run_file('fn(t: int) { var x ; (box x)= x; (box x) \x00alue }(3)')
    run_file("if&(1) {\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\x80\x00\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xde\xa5 2 } else {if&(1) {if&(1) { 2 i else {iv&(1' { 2 3  2 3 }")
    run_file('if&(1) { 2 } else {if&(1) {\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6if&(     }\n  ')
    run_file('const9f =  struct (\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5) + n')
    run_file('\n  var b = 1>> 2\n            b ? 3\x80\x00 4[1]      }\n             b ? 3 : \x00\x00\x00\xff      }\n  ')
    run_file('\n        module nary2 {\n           \xc7\xc7\xc7\xc7\xc7\xc7\xc7= 1 > 2\n    \x0f       b ? 3 : 4[1]      }\n  ')
    run_file("switch ZO{ Kase FO/\xddw\x1a x,\\'witch\n ZO{ case FO/\xddw\x1a x,\\'   }   }")
    run_file('( new box 3)\n   \x80\x00   module \x05\xff\xff\x05const x = 1()\n  \x1d     const x L m.x\n    }')
    run_file(' new module\n        var \x01\x01\x01\x03\xe8 false \x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01  x +=  union ref var #[6]\n  ')
    run_file('const (x, (y: int)) = (three, \xd0)')
    run_file('\n        module nary1 {\n            const b = 1 > 2\n            b ? 3 : 4\n        }\nUll = def in n\x00\xff\xed\x00int\n  \x03\xe8cell\x00\x80\xff\xff \n }\n dynamic \x08   ')
    run_file('switch&FOO( ref three) { else {\xd9} }')
    run_file('switch&FOO(t\xderee) { ehJ" + " va" +" + dhJ" +  "h+ " +  "h" + "hJ" + " va" +" + "hJ" +  "h+ " va" +" + "hJ" +  "h" + "h" + "h" va" +" + "hJ9 +  "h" + "h"  0 + "hJ" + ""')
    run_file('switch FOO(fals\xdd) { else {3}tch FOO(fals\xdd) { els }')
    run_file('switch F:O(th\xd4te) { else {3} }')
    run_file(' never ;,moDule {} 1)')
    run_file('for x in[] { x \xdb\xdb _ \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb}')
    run_file('for x in 3 { module  { break }; x } else {#5ak }; x } else }')
    run_file('for n in 3 { modulezjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjQjjjjjjj\xcf      consjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjTjjjjjjjjjjjjjj\xcf      const (v, <= ) = u\n      5:  \n    }\n ')
    run_file('for x in*fo3 { for re\xcf const   x in*fo3 { for reM const  x i% 5\n ')
    run_file(' fulfil  Pm = array const  fn (v: tZp\xc3):u')
    run_file(' fulfil  Pm = fn (t: type): ule {\n            fn id     (x: t): d { return    5555555/5555555555555555555+55555 || 55555555555\xc355555555 }\n    }(int)\n')
    run_file('for x in 3 { x } else { 510\n }\n struct !  }\n! ')
    run_file('\n            var x = 4\n       -    1 > 2 ? 3 : x\n           var x = 4\n          }\n  ')
    run_file('+ +16666666;6666666666666copy {\n      const cell = defer fn(): int\n      const copy = cell\n      fulfil cell = fn(\xff\xff\xff\x7fnt { return 3 }\n   \\\n fulfil copy = fn(): int { return 3 }\n    }\n    ')
    run_file('ntruct( defer inttru(): module {\n            modu switch le\xd6m { congt x = 1 }\n  fn (\x06: module {\n  }().x\n  F }')
    run_file('struct int(A) (On 1.0\xcf0 t)')
    run_file('for x in 3 ==5 { bre\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xdd\xf6\xdd\xdd\xdd\xdd\xddS\x00\x10\x00\x00m (<g (Byf)BKf)[lu[Eule (< (BNf)[\xff')
    run_file('print("Hello, W\xd0rld!\\n")')
    run_file('[ 0.0 ] \n5\n \n5\n \n\xef&%\n &5\n  ')
    run_file('[ box Gg.leng[ \xd5[[[[[[[[[[\xcf\x00[[[[[k[')
    run_file(' - fn (): ( typeof id) { r &= n [ == (),\xcf()(())] }().le')
    run_file('f=*(d\xdc(d ')
    run_file('*&\n0\n\x7f\x00\x00\x00\x945\n ')
    run_file('&        module nary1 {\n            const b = 1 > 2\n            b ? 3 : 4\n        }\nUll cell\x00\x80\xff\xff \n }\n dyqami= def in n\x00\x00\x10\x00int\n   union \x80\xff\xff \n }\n dy\x00\x00\x01\x00c \x08   ')
    run_file('[5, 6, 7, 8].slice\n\xff\x7f\xff\xffue\\\xd2bt[rubt\\\ny|\n\xc3ue')
    run_file('fn (): aoray0 { reb\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\\\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8urn [] }().x')
    run_file(' typeof "he\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf(true)\xcf\xcf\xcf\xcf\xcf\xcf" + "llo"')
    run_file('const f =  struct (\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xd7\xdd\xd7\xd7\xd7\xd7\xd7\xd7): int')
    run_file('const f =  struct ();const f =  struct ();- ~~~u)ue')
    run_file('fn (): module\n p().a  }().x')
    run_file('\n     module nary2 {\n            var b = 1 > 2\n!           b ? 3 : 4\n        }\n }\n  ')
    run_file('    fn make(t: type): module {\n        return module { 3: t }\n    }\n \xffO ')
    run_file('if&(1) {\xcax7* y\n   @  fulfil y = fn(): bnt { return - }\n  \x1a   f\x18lfil x = fn(): int { Teturn 3 }\n    [\n ')
    run_file('if&(1) {\xcex * y\n      fulfil y-= fn(): bnt { return 3 }\n      fulfil x = fn(): int { return 3 }\n    }\n ')
    run_file('if&(1) { x \n      fulfil y = fn(): bnt { return 3 }\n   \xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf\xcf   fulfil x = fn(): Int { return 3 }\n  return    }\n ')
    run_file('if&(1\xc8 {\x01O8t) { else {\x02rOturt .} }')
    run_file('-3 (): (struct(in\x7f\x00\x00\x00{ return?(1\xda[1]) \x00\x00\x00.x')
    run_file('"\xde\xde\xdeG".x')
    run_file('fn(): int { return 3 }\n      cell()\xff\xff\xff\x7f }\n    ')
    run_file('var x =(); x}')
    run_file(' a (): module { return re(n (): mo\xd2ule { return re((((((3)((\x01((3)')
    run_file('["]R\xd03"] * 7')
    run_file(' ref  new\n[[[\xcf\x00@d[\\r\x07[[[k[')
    run_file(' * new  "" +  "h" + "hJ"\n+ "\x86J" + ""')
    run_file('for x in 3 { if x==14(fa\xc9se) for x in  rDf var 3 { id x==1 { break }; x } else { return  5 }}; xse { r\x01 { r\x01turn  5  fulfil }')
    run_file(' typeof  0x1\n    fn (): module\xff{\n         fn0(): module {\n  \n\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb\xbb < fn (): module {\n  \x80    }')
    run_file('6/6;666&6666666666666;66O {\n    (    \x84hrow  []\n        x += [module {}  ')
    run_file(' union {};\xdadon {};+d')
    run_file('"\xc2e" +*new  "llo"')
    run_file('fn (str, b (fn (tr,*fn (tr,*r,*)oo^):bootr,44444444444444*\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5boon): p((tr,*r,$)oo^):bootr,*bool): p(())')
    run_file('module {int  }\n      fu |=6lf\xbdl ]3 =&k(3)\n   \x00\x00\xff\xff3()\n    }\n')
    run_file("\n\n\n\n\n\n\n\n*&\n\n\n\n'\xde';; '@/ > @/ 'B@/@/ 8S/ 1of FOOs uer @/;/;\xde';; '@  '\xde': '\xde';B\x00'@/1=0e\x15 ")
    run_file('[1,8].s.sl[.sl = 3; FFFl0= 3; FFFRFFF = 3; FFFl0= 3;4FFFRFFFFF\xcaFFFFfFF1,8].s.sl = 3; FFFl0= 3; FFFRFFF = 3; FFFl0= 3; FFFRFFFFF\xcaFFFFfFFFFFFIFFx}')
    run_file('switch ref  FOO(e) { else {switch ref  FOO(three) { ense {\x00\x00\x00@\x00\x00\x00\xd8')
    run_file('*&*&0  \nt\x1e \x81 \x00\x00\x01\x00\x01\x01\x01\x01\x01\x00\x80\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01\x01 <<= \x01\x01var uni\x01\xff\xff\xff\xff + 0O}) + [FOO]\n    }')
    run_file('\n    module count {\n        va\n \xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xd3\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4 < :  `  while a0 {\n     Nf     if a < :  `  while a0 array var   "h"\n        }\n    }')
    run_file('+0.0 \n\xfb ')
    run_file('if&(1) { x * y\n      fulfil \xd3 = fn(): bnt { retur var \n      fulfil il \xd3 = fn(): bnt { retur var \n      fulfil x []= fn(): Int { return 3 }\n  x []= fn(): Int { return 3 }\n  return    }\n ')
    run_file('module foo {\n     \xcc  module m { const nst x = 1()\n       tttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttt xodule m { const x = 1()\n        c`ns\xdf x =\x1em.x\n  }')
    run_file('1^3^\n3\n\ns\x7frucY:int)) {\xfeqedurn (1,) }()J;].x')
    run_file(' typeof  I\n box  & &\x80\n<arr\x00\x04\x00\x00\x15\xda\xd3\x00@\x15')
    run_file('\n   var a= new 5\n   a= new 5\nar\xdea= new 5\n   a= new 5\n\x08\x03\xe8\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08\x08@\x08\x08\x08\x08\x08\x08\x08\x08\x08\x16\x08\x08\x08\x08\x08\x08\x08$  \x10   try   a   \x10   try   a\n ')
    run_file('+oe666(!mod666( *6666666666%666266666666<< 6666666626( *6666666666666626666666666666( * int))*66 << 66666666666666666:66(\xd4*  * i * int))&66 << 66666666666666666:66( * ind))')
    run_file('+oe666(!mod666( *6666666666%66626\xd066666666666( * int))*66 << 666?666626( *66666666666666266 << 666?666626( *6666666666266666666666&6( * int\x17)*66 << 6666666626\\/*6666666666666626666666666666( * int))*66 << 66666666666666666:66( *  * i * int))*66 << 66666666666666666:66( * ind))')
    run_file('+oe6666(!mod666( *6666666666%66626666666666666( * int))*66 << 666?666626( *6666666666666626666666666666(*66666661666666266666666666&6( * int))*66 << 6666666626( *\xcf66666666666662666666666666;( * int))*66 << 66666666666666666:66( *  * i * int))*66 << 66666666666666666:66(  ind))')
    run_file('[1, 2- 3] ; @]')
    run_file('\n        module m { const x = 1 }\n        const x = m;x\n    }')
    run_file('  (t\xda typC): m = 3; d\x1e&= 1')
    run_file('3 *4*0*011**050* 11**   5\n \n\x80\x00\x00\x00 &5\n    ')
    run_file('module { var box  x = 3; x - ? = 1 }')
    run_file('fn(t: type) { 3: t }(A(t: type) { 3: t }(AF;/BRAF;/BRANCH(int_[1]\xca, int, inL_tree)t')
    run_file(' return[[st\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf\xdf[[\\?')
    run_file(' typeof    & typeof    & &I\n box I\xf4 box   |= & &I\n<arral\xd3\xae\xf2\xda\xd3&I\n box I\n box  & &I\n<arral\xd3\\t\xae\xf2\xda\xd3\x00@\x15')
    run_file(' box[]\n     \n    va\x95 f = []\n        x += ref vaX #[6]\x8a\x8d ')
    run_file('[[P1x#]\xd0? 2>: d ] ? 2 : d ')
    run_file('   U (())   \n   array erns ~ d > efer typ[\n   .  co\x00\x80t u-=      0cond\x00ontinue )\n ')
    run_file('      ref const    defer type\n O array F]nst  defer type\n   ')
    run_file('666666&66%6666 << 666666666>66666660')
    run_file('fn(x: array0) { 3 * x }\n      \x0c var x = 9]\n \n   6 tinu} else { 5 }')
    run_file('\n    fn ref8(G: \xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdbint): void\n\x06')
    run_file('fn(int): int \n{ retu Zrn 3 }o[[[strucMp[[[sZruct[t[ #\x01 uctEv[\x1b[Mb\xff\x7fg?')
    run_file('     ref var   ref const    defer type\n \x00\x00\x00\x80ray const  dev.r type\n   ')
    run_file('    const m =\nOO; 2AR}]')
    run_file('for r in 3 { if x<<1 {\xd7break };!x } \n   ')
    run_file('!0x333333;33333333334 <> 333\n        var a \xff\x00&x\n')
    run_file('&HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH\n         ^^^^^I^^^^^^^^^().\x80\x00\x00\x00[[[[[[ == }')
    run_file('3^ + 3\n\n3\n3^3^\n3+\n 3; modulg foo { x -= 1 } }')
    run_file(' fulfil array d= 1 > 2(A(& + & &(18& + \xd6+ A[(& + & &(18& + & 0(A& &(18& + & 0(A(& + & &(18& +\x00& 0(A& &(18&$+ & 0(A(A[(& +A[(1 + &\x00\x00\x00\x01(A))')
    run_file('switch e{ case FOO(w, x,  ||= y,\xc9z) {x} }')
    run_file('1<0\n0*03][1\x0c\x1d5, 3]["hello"]')
    run_file('\n 7         \n    fn (): module {\n   1 > 2\n     \n    var b = 1 > 2\n  \xc3          b ? 3 : 4 - .1}\n  ')
    run_file('\n        module nary2 {\n        fulfil  b = 1 > 2\n   \xdc   \x15    b ? 3 : 4\n        }\n  ')
    run_file('*bVx().h*box().h3D3 +D9ruct(ireturn struct(i\xdct) (struct(int).x')
    run_file('            \n &    defer type\n}hfer  -- typ    defer type\n}efer  -- typ fulfilfulfil \x00\x00\x00con(t  defer type\n      const1u-=      (t,)\n ')
    run_file('for x in 3 { while 1 { break };!x } else {  []\n\xce       x += [6]\n    }\n\x13!')
    run_file('for x in 3 { }\n l ++ { break };!_  } els\n        const x = 1 }\n  ')
    run_file('\n& ()\n  \n }\n   ')
    run_file("var (x) =\n\n\n\n'\xde';; '@/@/ '@@/@/ 8+/ 1of FO < uer @/\x00\x00\x00 ';; '@/\xe7'\xde': '\xde\x10;; '@@///1=Je0 ")
    run_file('for x in 5555555 { break }; x for x in 3 { if x<=1 = defer type\n      const u-= (t,)\n      fu\x00\x00\x01\x00 t = int\n   \xff  const Kv,) = u\n [[[[[[\x00\x00[[[[[[[[[[[[[[[[[[[[[[[     5: v\n    }\n\x1f\xfe  ')
    run_file('const x = &5\n &5\n 5\n \n5\n6\xeb\x1f&.5\n*/5 !! % 5\n\xd3')
    run_file('for x in*fo3 { for x in*fo3 { for x in*fo3 { xin*fo3 { for x(((((([]:((666( * int))*6666666666:T66\x11662666666626666666Y66666( * int))*66666666666666266666F6666666( *666666666666((((((([]:((666( * i\xc4t))*6666666666:T66\x11662666666626666666Y66666( * in array3const 66666266666F66\x1a6666( *666666666666:( * ind))')
    run_file('  module m { const x = 1 }\n        const x = m.x\n0   }')
    run_file(' * structRR: union{VR\xdb union{FOO\\ B\x00\x04\x00\x00 + [BAR:  union{VR: union{FOO\\ B\x00\x04\x00\x00 + [BAR: unioa{FR: union{FOO\\ --  union{FOO\\ B\x00\x04\x00\x00 + [BAR:  union{VR: union{ B <= AARaY')
    run_file('1  .a8?  * 2 : j+( v  .a8 ||  \xd3 : j)\n')
    run_file(' box I\n bo]  & &I\n@apral\xd3\xafbox  & &I\nbo\x80\xd3ng')
    run_file('[*M*b - o*b - Ox& typeof 33333433333333333333[ box 3]][*b . o*b - &33][*b0- o*b - &333333[ b\xc2x 3]].t')
    run_file(' defer module array_concat_empty {\n        var x = []\n        x \xc8= [6]\x02    }\n  ')
    run_file(' (\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2)< a = rrY')
    run_file('18> 2 &true;_ion{EOO; BAR}]')
    run_file('moduer (u(struct(inct:int) (struct(({truct(int) (struct(ireturnuct(int) (struct(io((struct(int(str\xdbct(inct(int)t((str(int) (struct((s (struct(struct(\x00 ct(int)\x13(struct((struct(int) (struct(iqeturnunt) (struc <> t(int).x')
    run_file('const () = ( pri t(\xd5((\x00 ((E(((((((((((((=((((((((((((L(((((f) ( () = <g (B[f)[iu[l{le (< true [\xff')
    run_file(' !! 0.0  \n   ?\x05ge\x8bW :iO')
    run_file('if (1 tn 3 { e .a  br array x  } else {  []\n4      C f tn 3 { while 1 { br array x  } x in 3 { while 1 { br\x0earrqy x  } else {  []\n4        .  [\\\n4        .a  [6]\n   ,\x0earrqy x  } else {  []\n4        .  [\\\n4        .a  [6]\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\x89\n   ,}\n .  []\n4')
    run_file(' box box module\n     *  var x = []\x00\x00\x00d     ]\x14B     le\n     *  var x  ')
    run_file(' new  &    & &I\n box\xbbI\n\x1abox in   & &I\n<arra@\xdd\xae\xf2\xda\xd3\x00` ')
    run_file(' new  & &  & & &  & &I\n box I\n\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea\xea &0')
    run_file('  t(): module { *etur0 = ur\n b =01 >!D\n   ur\n   *etur0 = ur\n b =01 >!D\n   ur\n     b = 1 > bool      &  b ? +\xdf  ? ++  3 : !2\n   ur\n     b9= U\n   3    }\nX')
    run_file("fn (s: struct(int, int, iYt,nt,\xccint)) {  if q(): int\n  \x08\x01  const'cxpelm\n      \x00\x02\x0c\x00il cop\\\\y = pn(): in[ { vc\x00\x02\x00\x01 cUll = def en n(): int\n *\x08 cell()\n  \n }\n   ")
    run_file('module \n  typeof  [6]\n    \x00\x80  ')
    run_file('[ & B] \n [ &\x7funio\\\\n{F64 union{$\x7f $: unk$$$\xff$A <<  Ajc\x00i >p\x7f\x00iBQRR[ union{FBQ\x7f\x00\x00\x00u.F6: [ni\x8en{$\x7f6$: u.F6: [niond$s6n@\x04+$$\xac\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xc4\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\xbc\x99\x99\xb5\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\x99\xff\x99\x99\x99\x99\x99\x99\x99\x99\x8a\x99\x99\x99\x99\x99\x99\x99\x99 \x00\x99\x99\x99\x99\x99\x99\x89\x99d\x99\xa0\x85&\x99\x99\x99\x99\x99\x99\x99\x04\x00\x9b\x99\x99\x99\x99\x99\x99\x99Y')
    run_file(' new  defer fn(): int\n{\n           A       b ?[1]: 4\n    \x7f\xff\xff\xff@\x00b = 1 > 2\nt           b ?[+]: 4\n    d   }\n  ')
    run_file("if&(1) { 2 } else  if&(1) {if&(1) {ls } else {if&(1) {if&(1) { 2 } \xd9lse {\x00 &(e {iv&(1' {\xc62 3 \x122ls }\x00 hse {if&(1)  3 ")
    run_file('\n      var a =*new 5\n     \x16 "")    \x01   *a\n    }')
    run_file('fulfil(x, (yeof  in\xd9  in\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd9\xd8\xd9\xd9\xd9\xd9\xd9\xd9t)) = (\x01, 1)')
    run_file('\n   var a= new P\n   a=\xff\x00_c\x02\x00ck var a+ new 5\n   a= e_check2 {nt)\n      fn f(x: supevtyMe): A  subtype { return []> midtype }\n      conertyxe)\n      g([]: subtype\x00\x10 throw    ')
    run_file(' new "hl" ; new \xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xa9\xc4\xc4 "llo"')
    run_file('fn(x: array0) { x * -3 }\n\xf3\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x1c\n a \n\n\n\n\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nxutatet) + \n   ')
    run_file(' r (): module { retur const \xc7 array  module {   \x19   return : module { return array  module {       return module      b ? 3 :&4.\n  arra  b ? 3 :&4.\n    ` \x01\x00\x00\x12\n            b ? 3 :&4.\n      \x01\x00\x00\x00  ')
    run_file('+FOO: union ulf {\xc2\xc2\xc2\xc2\xc2\xdf\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xd5\xc2\xc2   *a\n  \xc2   *a\n    }')
    run_file('(b(y: \xc3nt{) = (3, 1)')
    run_file('va: (\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\xdb\x7f,) .a  = (3,)')
    run_file('vc: (x,) .a  = (3\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4,)')
    run_file(' new  str ; x <= 1 }')
    run_file('const (ule intf \xc7\n      const intf = fnh): int\n   = defer intf\n ')
    run_file('[]*4//\n[6]\n8  )}\n  ')
    run_file(' box  & &I\n box  &box  & &I\n<ar\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9box  & &I\n box  &box  & &I\n<ar\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9r\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9\xf9r &I\n')
    run_file(' box  & &I\n box  &box* & &I\n<arr var\xdb\xdb\xdb\xdb(~~~g*-  (~*-  (~~y~\x86<Z  (~~u')
    run_file(' typeof  typeof typeof8((\xc8((\x11(( (3,=~on(((')
    run_file('""*3; defer  x(1,)}')
    run_file('fn (): str { return "" }\n\n\n\n\n\n\n\n\n\n\t\xe9\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x01\n\n\n\n\n\n\n\n\n\n\n\n\t\xfe\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x18\n\n\n\n\n\n\n\n\n\n\xfa\xe4\xe4\xe4\xe4[1\xe4\xe4\xe4\xe4}]')
    run_file('(1, 0.0  );)')
    run_file('~~~~~*new 5\n     module {}    !!!!!!!!!!!!! && !!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xe7*a\n   ')
    run_file(' *\n\n\n\n\n\n*\n\n\n\n\n\'\xde\'("")\n\x08\n*\n\x1f\n\n\xf6\'\xde\';; \'@/@/ \'*\n\n\n\n\n\'\xde catch \'*\n\x1a\n\n\n\n*\n\x1f\n\n\xc2 \'@/@/ \'@@/@\x01\x00\x00\xde\'*\n\x1a\n\n\n\n*\n\x1f\n\n\n \'@/@/ \'of F\n\n\n\n\n\'\xde\'*\n\n\n\n\n; \xe8\x03/@/ \'*\n\n\n\n\n\'\xde\'*\n\x1a\n\n\n\n*\n\x1f\n\n\x07\'\xde\' asser\x97 ;; \'@/&/ \'@@ vhile  1of F\n\n\n\n\n\'\xde\'*\n\n\n\n@@/@\x01\x00\x00\x01/ 1lf FN\x80s uer @/;/; | ; \'@/ 0e0 ')
    run_file("9*\n\n\n'\xde';; '@/ 8@\x1b 1of FO module /\\/;/;\xde';; \x16@/ 0e0 ")
    run_file('*   module intf{\n      const ictf = fn(): int\n      const k3 = defer intf\n      fn k(x: int): intf {\n      \xd9 return fn(): int\x1f{ return k }\n      }\n      fulfil k3 = k(3)\n      k3()\n    }\n ')
    run_file('struct ll()\n    }\n \xf9  ')
    run_file(' * FFOD: union {FO\xcf; FPO}= _ARV')
    run_file('\n      const ictf = fn(): int\n\xff\xff    const k3 = defer i[1]\x00\x00\x7f\xff   fn k(x: int0: intf {\n        return fn(): int { \x80etur)n x }\n      }\n      fulfil("")= k(\xbf)\n  \\"    k3()\n    \x12\x12\x12\x12}-     k3()\n \x12\x12\x12\x12\x12\x12\x12\x12\x12\xf5\x12\x12\x12 < \x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x11\xf5\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x121]\x00\x00\x7f\xff   fn k(x: int0: intf {\n        return fn(): int { \x80etur)n x }\n      }\n      fulfil("")= k(\xbf)\n  \\"    k3()\n    \x12\x12\x12\x12}-     k3()\n \x12\x12\x12\x12\x12\x12\x12\x12\x12\xf5\x12\x12\x12 < \x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x11\xf5\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12\x12   }\n ')
    run_file('if("") { 2 } else \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xe9\n\n\n\n\n\n\n\n\n\n\n\n\n\n')
    run_file('module foo {\n        module m { const x = 1 }\n        m.x\n1 }\n    }().x\n     rdturn module {\n                fn i\x82(x: t): t { return x }\n            }\n        }\n   ')
    run_file('array * &bo[  true &~~~~~~~~~~~~~~~~~~~~~~~* &bo\xc2 *(&ox *y\x7fx * 433[ b.t')
    run_file('const (x, (y:*int)) = (thr([])e\xd1\xe9\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1ee, 1)')
    run_file('\n5 >>> \n \n5\n \n &5\n &5\n 5\n \n5\n6\n &5\n*/5    arra    \x83rray co\xff\xff\xff\x80\n   \x16  !   3  3 : 8\n        }\x00\x10 \x88 coXst  \x16  !     b ? 3 : 8 g       }\n  ')
    run_file('[ !6]\n\x18   }u\x006]\n   ')
    run_file(' 0|0|01|1 ;  new + + ++  box  + \n box\n box   box  + \n box\n \x00\x80x  + &I\n')
    run_file('fn ( ): (n ( \xd7\xd7\xd7\xd7\xd7\xd7): ( Modb ? ')
    run_file('\n\n\n\n\n&\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n never \n\xed\t\n}')
    run_file('" \xce0\x191 if e-0 hN"[1] +=    ( 4')
    run_file('"h\xc6"-& "llo"')
    run_file('\n                          var a =*new 5\n       [1]        *a\n    }')
    run_file("+ +\n\n\n\n'\xde';; '@/@/\\b@@/@/ !!  1of FH < uer @/\x00\x00\x00 ';; 2@/")
    run_file(' & [6]\n\x00\x00\x01\x00peo\xff\xff \x00\x00\x03\xe8    }\n')
    run_file('module { var x ="h"\n        }\n   C}')
    run_file('f: module { return array  module {       \xc6eturn : module { return array  module { retu  }\n    }(int)\n  modn (): module { return array   _ ule {       return : m\x7f\x00\x00\x00e\x00{ return array  module {       return module lY { retu  }\n    }(int)\n  module}(i(()\x1es\x00\x00\n ')
    run_file('!!7         \n    fn (): moduue {\n   1 > 2\n     \n    var b = 1          \n    fn (): moduue {\n   1 > 2\n     \n    var b = 1 > 2\n     float (): module    %   b ? 3 : G -0.1}\n  > 2\n        fn \xff\xff: module  d %   b ? 3 : 4 -0.1}\n  ')
    run_file(' box [6]\n    }\n ')
    run_file(' case 4{\xd7 <> ')
    run_file('MM("")\n\xff\x80\xff+ ')
    run_file('& 0x1\nej \x00& ,\xe1\x7f\x00\x00$ Q\\gth')
    run_file('+oe666(!mod666( *66\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2666( * int))*66 << 666?66662>( [*666666il copy\n      const copy =rn 3 }\n   ')
    run_file('\n5\n \n&\n \n \n!\n \n5\n p_concat_empty {\n   urn kodul\x87 {\n                fn id(x: t): t {d\x80\x00e {`            return modul\x87 {\n                fn id(x: t): t { return x@}\n    \x03         return module {\n             odule {`            return modul\x87 {\n                fn id(x: t): t { return x@}\n      \x15       \x00eturn module {\n    (          fn id(x:            fn id( module {`            return kodul\x87 {\n                fn id(x: t): t { returnnst m = make(in\x10\x00\x00\x00       m.id(3)\n9   }\n ')
    run_file('[module ]\n  {}] \x07[2]\n   ')
    run_file('+9*~~*new 5\n  \xff\xff\xff\x7fodule {}    !!!!!!!!!!!!!!!\x10\x00!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nH\n\n\n\n\n\n\n\n\n\n\t\xee\n\n\n\n\n\n\n\n\nzt (Fest (x,)! (Fest (x,)!=x, _zst (Fest (x,)!=x, & )!= (tgneenee,)?!= Fezt (Fest (x,)!=x, _zst (Fest (x,)!=x,)!= (tgnee,))!= (tgreee,)')
    run_file('[1> 2]  *8\n\n\xf7/x10\n\x1d\n\n\n\n\n\n#\x00\x00\x10\x00\n\n\n\n\n\n\n\n\n\n333333333[ b[x&G.t')
    run_file(' &print  \n &5! &5\x12. 5\t il_forw\xff | ng_pOinter {\n      c\x83n')
    run_file('\n  \n        var a =*new[]\n      =*ne\xf7[]\n        a\n        *X\n \x0c  }')
    run_file('switch bOO(intOO(w, x, y, z) ,\xdb2, three, 4.0) { case FOO(w, x* y,>z) {x var } }')
    run_file("  box\n'\xde'*\n\n\n\n\n\n0\n\n\n\n\n'\xde';; '@\x7f\x00/ %@@/@/ 8@/ %=   1of*FOOs uer @/;/)\xde'@\n\n")
    run_file('\n    module t {\n var \xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8ttttttttttttttttttttt      = 10\n   & b = 1 > 2\n        &  b ? ++  3 : 4\n      b ? ++  3 : 4\n        }\n!')
    run_file('for n in 3 { mjjjjjjjjj ^= jjjj\n      const (v,) = u\n     \xcc5: v\n   jjjjjjjjjjjjjjjmodulejjjjjjXjjjjjjjjjjjjjjjjjj\n      const (v[""],) = u\n      5: v\n   jjjjjjjjjjjjjjjjjjjjjjjj\n      const (v,) = u\n      5: v\n    }\n')
    run_file('    fn f(): void {\n        }()\n  \xad ')
    run_file('if&(le2{\xd9 @\x00 fn (): moUu\\e {\n        modut)* t { r{ returneturn x }\n')
    run_file('"\xd4e" +  0x1 .a  ')
    run_file('[ boy&3333[ boy&33333333343333333333[ box 3].ld ** ng].tt3\xcf3334333333333333343333333333[ box 3].ld ** ng].tt33?3343333433333[ box 3].ld ** ngfn(): znt\n ')
    run_file('if!(1) {  \xcbew 5 .  r ? 3 : 4\n   new 5     .  r ? 3 : 4\n       \x0e}\n')
    run_file(' while\n    O   [6]{\n    O   \xe8\xf8\x00\x00  continue    }\n')
    run_file("  box\n'\xde'**\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8</ 1o\n          \n\n\n\n\n\n*\n\nbox\n'\xde'*\x08\n assert / 1o\n            retu throw rn ")
    run_file("\n'\xde'*\n\n\n\n\n\n1\n\nbl\x82\n'\xde >tttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttt>>\n\n\n\n\n2\n\x0b\n\n\n'\xde';;\x9e\x9e\x9e\x9e*= '*\n\n\n\n\n\n*\n\n\n\n\n'\xde';;\x9e\x9e\x9e\x9e*/\x9e\x9e\x9e\x9e\x9eK ")
    run_file("  box\n'\xde'*\n\n\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8@          ret@rn ")
    run_file('    module intf {\n      \xe3\x8an\x00\x00\x00@ tf = fn(): int\x10      --  const k3  ^= fer0intf\n      fn k(x: jn}): @ tf = fn(): return    n(): int {8888888888888888  }\n  +=  dule intf {\n      c\x98nstk3() && \n   \x1f}\n    ')
    run_file('[1, 2\xd4 3][1]: ar %= ray0')
    run_file('[[1]];+ q]')
    run_file('    fn f(): void {\nconst x = f }\n :\x7f\xff    g()\n    }()')
    run_file('fn (tr,*fn (t(tr,*r, b*fn \xcct(tr,\rr,*booE):ool): p(()r,*r,*boyZ):ool): p(()\x00\x01Z):ool): p((\x10r,*r,*boyZ):ool): p(())')
    run_file('+ +1.666 | +1.666  ')
    run_file('[1] +[6]\n   \x0e}\n  ')
    run_file('module {\xd1        fn \x10\x00 array const iQt = []\n \nd\x00 \x01   ~   x\x7f\x00\x00\x00[   x\n    }\n')
    run_file('switch FOn(t) { &[[str[[[p[[[struc[[p[[[struc[p[\xc6[str[[[p[[[struc[p[[[sZruct[t[uct[t[[[l[[p[[[sZruct[tduct[t[[[[[[[] *= ?')
    run_file('[["\xc8\xc8\xc8\xff\xff\xff\xff\xc8"]] * - ~ 3')
    run_file('!1.0e0 \n\xce\xff\xff\xff\x7f')
    run_file("[ new  3] ; ;[]  + ']new 3]w 3] ; ;[]  + ']")
    run_file("[ new new 3] ;\xd2;[] + [P + ']")
    run_file('*   module(y: \xc3nt{) = (3 \x0f1)')
    run_file(' 1. **91.3**1.\n    }(5)')
    run_file(' 1.0e01%0e0  ')
    run_file(' typeof 99;999]')
    run_file(' &  module\n  0.0  = \x12/     }- ')
    run_file('3 * []\n          if \x10\x03< 5 { c\x10\x00ninu \xe8\x03 (a: array var union {FOO   }')
    run_file(' 1.0e0 ^.0e0  ')
    run_file('for x in 3 { if x==1 { break }; break }; xn  5 }')
    run_file('[[]] \n module {}{ case FOO(w, x, y, z) \x7f\xff} }')
    run_file('[module {}]\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xec\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xee\n\x18\n\n\n\n\n\n\n\n\n\n\xfa\xe4\xe4\xe4\xe4[1]\xe4\xe4\xe4\xe4\xe4\xe4\xe5\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xe4}]')
    run_file('fn (): (struct(int))\n ? *\t\xec\n\n\n\'\xf1\';; \'@/@/ \'@@/@/ 8@/ "of FOOs uer @/;/;\xde\x11; box   /  ')
    run_file('[FOO, FO]\n\n\n\n\n\x00\xff\xff\xf5[FMO, FO]\n\n\n\n\n\x01m\xfd\x0f  {z')
    run_file(' 5555 << 55555555')
    run_file('& \n & typeof      module m {};\n &&    : r{eturn ar throw ra     \x00\x84\x00\x00<=\x00x\n   ')
    run_file(' r: ref  (x,) (1\xd8\xd8\xd8\xf1\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8)=co_empty[ print ]\n')
    run_file('  array var int\n       7}\n')
    run_file(' ref const  new "hel\xdco"')
    run_file('\n   //odule re {\n        var a =*new- 5\n        a*      1 *a\n    }')
    run_file('var a = [S];a = [S]; defer a.length }')
    run_file('module array_concatVempty {\n \xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7    + \xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7\xc7    +  v .a  v .a  = []\n        x .a  += [6]\n    }\n  ')
    run_file("\n typeof \n'\xde';ase FO {\n         throw  []\n \x0b      x += [6+= [6 |   \x0e}\n  ")
    run_file(' box fn(x: int) { 55555 }\n55555555555455455555555 }\n55555555 }\n  ')
    run_file('&[]\n(\n\n\n\n\n\n\n\n >>>= \n\n\n\n\n&&&@\xba& never &&& never &&&&&&\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\xc6\x00\x00\x80\x00C&@\x8c\x00\x008=')
    run_file('for x in n (t: typ\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5e):\n~le {,   com = fn (t: type): ule {\n  ;5 * 5555+55555 || 55555555555555555555555555 }\n  [""]         ;55555555+55555 || 55 }\n ')
    run_file('*(1*i\xd0\xd0\xd0\xd0\xd0\xd0\xd0\xd0nt)= arra ** tJ')
    run_file('c+  module double_fulfil_forwarding_poinier {\n      const \xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcb\xcbx = defer fn(): (): iZt\n      fulfil x = y\n \x08    fllfil y = ?n(): int { return 3 }\n      fulfil x = fn(): int { return\x0b3 }\n    }\n ')
    run_file(' 1. -0.1e-0 \n\n\xe8\x03\x00\x00\n\t\xfc =t()')
    run_file(' r: ref  (x,) (1)=co_empty[ p{\x00 &(e  defer 333333333333\xdc333e {\x00 &(e {iv&(1\' if&(1) u 2 } else {if!(1) {if&(1) { 2 } els } else {if&(                                                   "                         f&(1) {if&(1) { 2 } els } else {if&(1)if&(1) { 2 } else {\x00 &(e {iv&(1\' { 2 3  2 3 ')
    run_file('"\xc5h!"[1] += B')
    run_file(' box (); x]')
    run_file('for x in s (false){  "h" + "hJ"\xcd+ > va$ +module {}+\x15 {" + "hJ" + ""')
    run_file(' while a_conca(fa\xd7se) {\n        var x = iRe array_conca(f6]\n')
    run_file('switch FOO(4.0) { \xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xcecase FO { z +=\x10[6]}    }\n ')
    run_file(' -0. %1e-8\n %-0.i[1]4\x00    array0    dynamic\x01o& e }\n')
    run_file(' typeof     \n      defer type\ndefer type\n         def\x84r type\nd     \x05   \n')
    run_file(' !       module array_place1 {\n        var7x: array const int = []\n        x \xcb= [6]\n !       module array_place1d{\n        var x: array const int = []\n    \x7f  ;x += [6]\n      var x: array const int = []\n      x\n    }\n \x00\x02\x00\x00 var x: array const int = []\n     hx\n    }\n')
    run_file(' typeof fn a (l: array int) { a["hell\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcct) {\xcc\xcc\xcc\xcc\xcc\xd2\xcc type \xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcc\xcco"] }')
    run_file("  box\n'\xde'* typeof \nbox\n'\xde'*\n\n\n\n\n*\n\nbox\n'\xde'*\n\n*\n\n\n\n\n'\xde';; ;@/@/ '@@/@/ 8@/ 1o\n         \x13  return ")
    run_file(" new \n0x1 \n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xf5\n\n\n\n\n\n\n\x7f\x00\x00\x00\\'\n\n\x00\x00\x006\n!\n\n\n\n\n\n\n\n\n || \n\n\n\n\n\n\n\n       !(a\x00\x7farray 6Xr unio\xa3}{}) + [FOO]\n    }")
    run_file('fn (): str {e .a  = []\n        x .ile .a\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5\xc5  = []\n        x .ile .a  = []\n      x .a  += [6]\n    }\n')
    run_file(' box module array_concat_empty {\n        var x = []\n 5}\nox module a\x94ray_concat_emp ')
    run_file('O(A);  3)')
    run_file(' 1. *+91.;*(1. *991)}')
    run_file('\n      var b =  0.0 \n!           b ? 3  ref        }\n  ')
    run_file('+6 \n  new *  new * new \n  new  +1.6 \n  new *  new * new \n  new *  new * new *  new * new new 0*  new * new \x8cew 0')
    run_file('defer 3333[ boy&33333333343333333338[ box 3].ld ** ng\xd5.tt333334333333333333343333334333[ box 3].ld ** ng].tt33?3343333433333[ box 3].ld ** ngfn(): int\n ')
    run_file('""*41**050*011\nswitch **P*0*1**0*1**4*0*0')
    run_file('   const x = []\n            x: array int\n            x- array const \xe9nt\n  *         x: array, var int\n        }\n')
    run_file('+~~*new 5\n . \x05 module {}     !!!!!!!!dulW {}   U!!!!!!\x10\x004!!!!!!!!!!!;!!!!!!!<!!\x00\xd5\xb3!!!!!!!!dule {}    !!!!!!!!>!!\x01!!}   U!!!!!!\x10!4\x0e!!!!!!W fn   U!!!!!!\x10\x004!!!!!!!!!!!;!!!!!!!<!!\x00\xd5\xb3!!!!!!!!dule {}    !!!!!!!!>!\xe7\x01!!}   U!!!!!!\x10!!!!!!!!!!!!!!!!!!;!!!!!)a*new 5\n . \x01 module {}     !!!!!!!!dulW {}   U!!!!!!!!!dule {}    !!!!!!!!>!!!!\x10 \x80')
    run_file('module foo {\n       \xce case  m { const x =   }\n        m.\x01\x00    case  m { const x =   }\n   \x04 }')
    run_file(' while array_concat_empty {\n        var x[1] = []\n        x +\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xdd\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8= [6]\n    }\n  ')
    run_file('[RRRRRR2]*4*1\n8*4**4*q([W)0*00\xff\x7f')
    run_file('[RRXRRRR]*4*16( *6666666666%66626H66666666\xdc66( * int))*66 << 666?666626( *66\xdc66( * int))*66 << 666?666626( *666666666666d:66( * \x00\x00\x00\x01\x1e')
    run_file('[3]  \n\n\n\n\n box !1.\n!1.\n\n!1.\n\n!1.\x15\xf3\x1f1x *("")\n 1x * -3\xff\xff\x1ds\x01')
    run_file('!~~~~*new 5\n     module {\x87    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xe3\xd5\xd5\xd5*a\n   ')
    run_file('"\xe8\x80"[1] + "llo"')
    run_file(' typeof  typeof 6266;6\xc266666666( * ind))')
    run_file('       var a = 10\n  a = 10\n        while a > 0 {\n     66666666666\x80\x006666666666  var a\n            "h"\n      >       while a > 0 {\n     66666666666666666666666  var a\n            "h"\n      > }\n\x11 ')
    run_file('if&(1) { 2 } else  if&(1) {if&(1) {ls }  } else {jjjjjjjjjj &jjjjjjjjjjjjjjjjjjjjjjjj\xcfjjjjjjjjjjjjjjjjj\n     (v\x1d) = u\nj\n     (v,) = u\n      5: v\n    }\n constdjjjjjjjjjjjjjjxjjjjTjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjjj\n     (v,) = u\nj\n     (v,) = u\n      5: v\n    }\n ')
    run_file('[[]] + [\n]\n]\x00@ []')
    run_file(' 0x1<\n0x1 \n\t\xf3\n\n\n\n\n r_co([])')
    run_file('if!(1) { 2 }\n thSo\x93  z ')
    # run_file('[("")] * 2222322222-3') # Nope.
    run_file('   module m { const x = 1 }\n!       m.x\n    }')
    run_file(' 1.\n\n new  1.\n1.\n\n\n\n\n\n\n 1.\n\n\n\n\t\xf3\n\n\n\x00\x00\n\n\n\x00\x00\n\n\n\n\n\n\n\n\n\n\x00\x00\n\n\n\x00\x00\n\n\x03A\x00\x10\x02')
    run_file('3 >*new 5\n#.   modume {}    =!!!!!\xe8\x03\x00\x00!!!!!\x01!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5 a\n   assert  ')
    run_file('for x in 3 { continue }; x Ql %= \xd0\xcb\xb0j\xc0\xcb\xcb\xa8j\xe3\xcb\xc4\xa8\xcb\xb0j\xe3\xcb\xcbj\xe3\xcb\xcb\xa8\xcb\xb0\xd0\xc2\xb0j\xa8\xcb\xb0')
    run_file('"\xcee"|+"llo"')
    run_file('3 <= \n0x1 \n\n\n\n\n\n\n\n&\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x9d\n\n\n\n\n\n\n\x7f\x00\x00\x00\n')
    run_file('\n    module t {\n        var a = 10\n        \n            a -= 1\n     }\n    }')
    run_file(' new   (1,) \n      defer type\n\xcbefer typ    defEr type\nd tZpe\n     ref var   /t,)\n ')
    run_file('switch FO{ case bdO(w,\xc7x- y, z) {xa \x99')
    run_file('switch FO{\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd2\xd1\xff\xff\xff\xff\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1 ca\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd2\xd1\xff\xff\xff\xff\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1 case n {LbAF; BRANCH(int_[1]e, int, inL_treese n {LbAF; BRANCH(int_[1]e, int, inL_tree)}')
    run_file('const b = box 2\n    @\x00 \x00\x00\x00\xff b ? 3-: 4\n  {P {\n   \n      0    !    modele nary\n  ')
    run_file('3+~~~*new 5\n     \x8codule {}    !!.!!!!!!!!!!!!!! try !!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5\x00@\n   ')
    run_file(" ref int\n       c@\x00\x00\x00 \x00\x01tv =\x00\x01n\x10 ref var  Z )nt\n     \x01\x00 0 nst k*\x0f= d \x04`r intf\n      f* t(x: int): inef\x16{\n \x1f\xfd     Teturn fn(): int c re\xffuJn x  *= \xff\x7f\x05<}\n n\x10)Z )nt\n     e\xffuJn x  *= \xff\xff\x05 }\n'    Bfulfil k3 = k(    Bfu\x89fil k3 = k(3 1")
    run_file('.1e-0 &0.1e-0 ')
    run_file('  typeof  typeof  type\nf t\xffpeof array const   typeof ()(  tgpeof typeof  typeof &assert ()(')
    run_file('   var a= new 5\n  typeof+ 5\n   \n   var a= n true  n\x86w 5\n   \n  dvad a\xff\x00ne\x92 5\n   a= ne * a= ne * w 55\n')
    run_file('fn(x: int) { return 3 }\n    }\n ')
    run_file('        var a =*new 5\n      [""]        *a\n   [""]        *a\n    }')
    run_file('[([module {}])] *     1\n            i        }\n  # }')
    run_file('fn (): (array void)\n\x96       var a =*new  5\n   str        a *=    ([])\n C')
    run_file('3 >1 >>>  ~\n3')
    run_file('     var b =  0.0 \n!           b ? 3 : 4\n       \r}\n  ')
    run_file(' 1.0**91.3**1. **91. **91230e00 ')
    run_file(' while FUO(t\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xe6\xd8\xd8\xd8) {  }\n ')
    run_file('  com =&fn (t: type): ule {7           ;55555555+55555 || 55555555555555555555    (int, array int)\n      fn f(x: supertype): midtype { return []: subtype }\n      const g \xdf f: struct  (fc(subtype): supertype)\n      g([]: midtype)\n    }\n ')
    run_file('3 <~~*new 5\n   \x00\x01\x00\x00dule {}    !!!!!!!!!!!!!!!!!!!)!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file(' &  fn f(): void {\nconst x = f }\n \n    }()')
    run_file('array typeof [""]; defer a.lenr a.length }')
    run_file('[ print ]\n ]: akrry JJmJJy\x80\x00print ]\n  ')
    run_file('\n  2\n! !     4\n     d\x00  }\n  ')
    run_file(" new \n'\xde'\nbox\n'\xde'*\n\n\n\n\n\n*\xf4\t#\n\n'\xde';; '8/@/ '@@/@6 8@/ 1o\n    \xff       return ")
    run_file(' ref typeof \n &5\n \xff\xff\xff\x805\x00\x02\x00\x00&\x19\n*/5 !! % 5\n\xd3')
    run_file('[1, 2] *5\n .7  modu\xffe {} \x07  !!!!!!!! dynamic !!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('   var a =*new 5\n      ("")        *a\n    }')
    run_file('\n        var a =*new  5\n        a *=    1 *a\n<   }')
    run_file(' X\n        var x =[1]\n        x += [6]\n    }\n  ')
    run_file('[1> 2]  +   \n  [1> 2]      \n \x7f\xff\xff\xff defer ty    3343333333[* !! defer I333].tt')
    run_file('switch FOO(Jnree, 4.0) { case FO/(w\xdf x, y,w,\x1be,\x06y, z) {x} }')
    run_file('"\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xca\xcahe" +fn(): int {   }\n  ')
    run_file('new  module t { 1\n     }\n    }')
    run_file('var a =module {}; deferfer a.lh }')
    run_file('fn(x:bool) { (box x).type }\n\xff\xff\x00\x00    var x =2[]\n        x += union {}}\n  ')
    run_file('fn(x: int) { (box x).constness }\n  array const \x1a       \x00\x02 c\x8dnst a = ([]: arrUy var i  g[2]\n     nt) + [ ]: array var i    va g[2]\n     nt) + [ ]: \x0b          b *= 1\n')
    run_file('AF(module {}); BRANCH(Vnt_trpe,  new intVtree)_trpe,  new intVtree)}')
    run_file('[ new FOO, new F  ]\n x = [\xbd\n        x +=*[6]\n         x +=*[6]\n *[6]\n         x +=*[6]\n    }\n')
    run_file("  box\n'\xde'\nbox\n'\xde'*\nJ\n\n\n\n*\n\n\n\xf3\t'\xde';; '8/@/ =@@/@;; '8/@/\x80\xff@@/@/ 8B/ 1o\n")
    run_file('const (x, (y[1]: int)) = (s\xf3\xff\x88e, 1)')
    run_file('\n    module t {\n        \xd2ar a = 10\n        while a : 0 {\n                 while a > 0 {\n         a -= 1\n         while a : 0 {\n                 while a > 0 {\n         a -= 1\n                while a          if a < 5 { typeo& e }\n           "            while a          if a < 5 { typeo& e }\n           "h"\n        }\n    }')
    run_file('switch FO{ case FOO(w, x, y, z) { WeSur\n x\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce} }')
    run_file('   -0. -1e-0   -0.1  <    -0. \n   arra\xf9 const .Mdng]tt')
    run_file(" 1.\n\n\n\n\n\n\n!1.\n\n!1.\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n'\xde'[1]\n'\xde'*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n'\xde'*\n\n\n\n\n\n*\n\n\xcbox\n'\xde'*\n\n\n\n\n\n*\n\n\n\n\n'\xde';; '@/@/ \n\n")
    run_file('if f (1. {\xde\x10\x04\x00 el pri 1.0e0 if&(\xd3) {if&(1)4{ 2 } e) { \x07 u')
    run_file('    \n            var b = 1 > 2\n !! !!      b ? 3 : 4\n        }\n  ')
    run_file('+ +1.6 &  +1.6 +1. ')
    run_file(' box [3[!box&33333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:333L333433333333733343333333333[ box 3].ldng33334333J333333[ box 3].ldng].tt:333733343333333633[ box 3].l=ng333343 ** 33333[ box O33633[ box 3].ldng3333 defer 43333333333[ box O].ldng].tt')
    run_file('    module f { const x =!1 }\n =!1 }\n        m.x\n    }')
    run_file('3 !=\n5\n \n5\n \nK\xff\xff\xff\xff \n5\n \n5\n \n5\n 5\n&%\n')
    run_file(' 6666&666&6666666 >>666666 >> ~ 666666&666&6666666 >>666666 &666&6666666 >>666666 >> 666&666&66')
    run_file('    const m = fn (t: type): module {\n        return module {\n      fn id(x: t): t { return x }\n        }\n    }\n +  }(int)\n    ')
    run_file('module { module foo {const x = 3; module fof {} }}; module fof {} }')
    run_file("var b =71 > 2\n            b ? 3 : 4\n     b ? 3 : 4*\n\n\n\n\n'\xde';; '@-@/ '@@/@/ 8@/ 1of FO<s \x00\x00\x00\xc9@/;/;\xde';\n\n'\xde")
    run_file('3 *[()]\n\n\n\n\n\n\n\n\xff\n\n\n\n\n\n\n\n\x00\n\n\xfa\n\n\n\x11\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xf9\n\n)\x00\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\t\xf7\n\n\n\n\n\n\n\n\xf9\n\n)\n\n\n\xff\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\x00\n\n\xfa\n\n\n\x11\n\n\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\x00\x04\x00\x00\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\xc2\x84nst \n\x7f\xff\n\n\n\n')
    run_file('( box S, box box 1, box  O); LEF(iO)intVtree)}')
    run_file('\n            var b =  0.0 \n!     -     b ? 3 : 4\n       -(false)     b ? 3\xff\x7f 4\n')
    run_file('\n    var b =  0.0 \n!    +-     b ? 3 : 4\n       -     b ? 5\xd3\xd3\xd3\xd3\xd1\xd3\xd3\xd3 : 4\n    var b =  0.0 \n!    +-     b ? 3 : 4\n       -     b ?\x195\xd3\xd3\xd3\xd3\xd3\xd3\xd3\xd3 : 4\n')
    run_file('   module nary2 {\n            var b =  0.0 \n !!         b ? 3 : 4\n          }\n  }\n  ')
    run_file('[1] +["]1]1+\xdb"]()\n  \n    ()   \n \x0e)')
    run_file('!* q(131+module nary2 { array const \n        * q(131+module nary2 { array const \xcd            defe@  S :.4\n   &        module nary2 { array const \n    0       defer  S :.4\n     \x17defer  S :.4\n    \\b      lodule nary2 { array const \n      \x04     defer  S :.4\x1d   }\n  ')
    run_file('1 > 2 &true ?() :&I\nbox  &\xdb&I\n tox ?& &I\n<q@ral\xd3I\nbox  \x15\x80\xd3nbox  & &I\nbox  & &I\n tox  &\x10\x00I\n<ar(1,)\xafbox  & &I\nbox  \x15\x80\xd3gth')
    run_file(' *+ module fiou_type_check4 { tr\xd9e \n     \x0bconot (subtype, m{dtytyqe) =\n        (array0, array const int, array int)\n')
    run_file('.0/0.0/2./20/2./2.')
    run_file(" return'\xde';; '@/@/\\b@@/@/ !!  1of FH J uer @7\x00\x00\x00 ';; '@/")
    run_file('3 >>~~~~*new 5\n     module {}    !!!!!!!!!!!!!\\t!!!!!  module {}    !!!!!!!!!7!!!!!!!\x10\x00\x00\x00!!!!!!!!!!!!!!!!!!!!!!!)!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file('for x in[modu\xdae {z] { x }')
    run_file('\n V(false)\n\xe8V(fa\xb2s0')
    run_file('(11,&()     \n)  \n     1 }\n   \x00\x10     1 }\n  \x1e }().x     < fn *): m\x91dule {\n  \n    ().x     < fn (): m\x91dule {\n  \n   \x0e}')
    run_file('array 3333[ boy&33333333343333333338[ box 3].lt ** ngU.tt3333343333333333333433I3333333[ box 3].ld ** ng].kt33?3343333433333[ box \xd9].ld ** ngfn(): int\n ')
    run_file('fn(t: type) {3 }\n   \x13}\n  ')
    run_file('fn(q:void) { }\nvoid)   ')
    run_file(' -~~~~ ~~~~~~~~*new 5\n  /1.0/\xff 1.0+.0/2.~*new 5\n')
    run_file('fn (): module { return module {} }()\n\n\n\n\n\n\n\n\n\x06\xff\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\xfc\x1farray const \n\x00\x04\x1d\n\n\n')
    run_file('1 /~~~~~*new 5\n!!!!!\xff\xff\x7f\xff!!!!!\x10\x00\x00\x00!!!!!!!!!!!!!!!!!!!!!!!!!!\xd5\xd5\xd5\xd5\xd5\xd5\xd5*a\n   ')
    run_file(' \n      var x: array const int = []\n      x\n    }\n')
    run_file("  box\n'\xde'\nbox\n'\xde'*\n\n(1,)\n\n\n\n*\n\n\n\n\n'\xde';; '8/@8 '@@/@/ 8@/ 1o\n")
    run_file('(1, N);)')
    run_file('switch FO{ case FO\xce1 { b };!c  ` elWe switch !x  `\x1belse {  []\n        cobreak };\x10x  ` else {  []};!x  ` else  ? []\n        cons *C t \n\x04\x00 \x0f    cons\\t=<g x = 1 }\n')
    run_file(' new   typeof  new  & &  & &I\n box& new  &* A &bo[ b != ox-* &b/x * &ox *box (*x * &ox \x0f A &bo[ j != ox-* &b/xbo[ b != ox-* &b/x * &ox *box (*\x8d * &ox * A &bo[ j != ox- try * &b/x * &ox *box (* 430[ b.t')
    run_file('("~=  & ", "\xd7o", "WorlN")')
    run_file('fn (): (  defer new  fn (): (  defer new  void) { return [(), ()] }().lengtvvoid) { r\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5\xd5eturn [(), ()] }().length')
    run_file('union {JO}\n}\n*')
    run_file(' fulfil  - NFOO: union {h\xcfO\x00\x10fulfil  - NFOO: union {h\xcfO\x00\x10\x00\x00O}= _\x00\x00O}= _')
    run_file('[ struct ( stru66( *66666626666666+6666.66666666( * int))*666666666 >> _ + ( mod666( *66666626666666+6666.66666666( * int))*66\xcd6666666:6662662666606E26666662666666( * int))*66666666:6662662666606626666666666666( * int))*66E6666666666626666666666666( *6 > 666666666( * indnt))*666666666 >> _ + ( mod666( *66666626666666+6666.66666666( * i))')
    run_file('fn(ct(\xc5nt)) { return: (ct(\xc5nt),  (): (ct(\xc5nt)) { return: (ct(\xc5nt), 1)')
    run_file("if 0x1 { 2 } else  if&(\xd7) {if&(1) {ls }  } else {\x00 &(e {iv&(1' { 2 3  2ls \x01\x00 lse bif&(1)  3 ")
    run_file('[ ref void ]\n         case  mnst x;=   }\n     }')
    run_file(' box        \n      defer type\n   \xe1rray const  defer type\n      const y-=       const\xa0u-=\x0e(t,)\n ')
    run_file('switch FOO(thx: int): void {\xca \x01\x00     const a = &x\n    \r   a\n  @  {\n        c(5)')
    run_file('  1. / 01. / 0e0 ')
    run_file('3|*new 5\n .   \xd5\xd5\xd5\xd5\xd5\x11a\n')
    run_file(' ! (tr,*fn ((()r,\xd4\xd4\xd4\xd4\xd4\xd4\xbc\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4\xd4*r,*boyZ):ool): p((\xdb)')
    run_file(' &"\xff\x87\xd9" * 1')
    run_file('fn(x: array const int) { }\nK_mutate \x84\n        \xa0   crnst a = (K_mutate \x84\n\xb8 y const int) { }\nK_m\x8dtkte \x84\n            crnst a = (K_mutate \x84\n            crnst a =, 8]\n             never a\x7f\xff] = 98\n                 crnst a =, 5]\n            a\x7f\xff] = 98\n            a\n        }\n    ')
    run_file('&       array var int\n        }\n')
    run_file("H ?  '\xde': '\xcd';; '@/_/ '@/ 1of;/;\xde\xd5em/ '\xde\x02\x00 \x06\xde';; '@\x00@/ '@/ 1of;/;\xde';; '@/ '\xde': '\xde';; '@/@/ '@/\x191.0e0 8")
    run_file('3 <=~*new 5\n     module {}  !!!!!!\x1a!!!\x00\x80\x00\x00\xd5\xd5\xd5*a\n  (')
    run_file('!!  !! 0\n!!\x0f\xe5\x00\x7f ref \x03!!  !! 0\n!!\x0f\xe5\x00\x7f\x1b\x10\x7f ref con\x00t\x1f\xeb! /\xfe\n \n ')
    run_file('if&(1) { x * y\n \xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8\xd8fn( dynamic ): bnt { retur var \n      fulfil x []= f =; 10\n        while a(1,) {\n  "h"\n\x00  8    }\n \x11       whi\n  "h"\n        }\n 10\n      ;  ;}')
    run_file(' fulfil! Pm (~\xddTe)= fY (t@ typC): mo')
    run_file('(1,module ); x}')
    run_file("[1, 2, 3][1]\n\n*\n\n\n\n\n'\xde';\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5\xe5; '@/@/ '@@/@/\xff\x80@/ 1o\n   ")
    run_file('[ 0.0 ] * 5\n4    module {}    !!!!!!!!\xff\xff\xff\xff!!!!!!!!!!\x02\x00!!!!!\xd5\xd5\xd5\xd5\xd5\xe0\xd5*a\n   ')
    run_file('\n  (): void \n  (): v)')
    run_file('(.1,.1&.1, (!() << ()), ()()())')
    run_file('fn  increment(x: int): int { return x + 1 }\n      increment(3)\n   !}\n    ')
    run_file('1 > 2 ? 3 :_\n    fn (): con\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7 < \xf7\xf7\xf7\xf7\n\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7\xf7st - tm = fn(): int\n     \rco \xff\xff\x00\x00hr\x86  throw fn k(x:*int): i{    ')
    run_file('switch FOO(int, 2, three, 4.0) {\xddcase-FOO(w\x00\x00\x00\x01 y, z) {x} }')
    run_file(' while new  a_conca(fal \xdbf se) {\n        vak x = e new  a_conof | !& typeof ! & typeof & tyieof&typeof ! & typeof \\\ntypeof typtypeofddf !/& typeof & tyf  !& typeof ! & typejf & typeof&typeo new f&! & typeof & typeof typeoof & typeof typeof ! & typeof \x0f typeo\x00\x10dddddddddddddddddddddddddddddddddddddddddddddd\x07ddddddddddddddddddddddddddd switch dddddddddddddddddddddddd: iSt\n')
    run_file("'o' >='\xde';;'\xde';; \x1b;/;\xde';; '@/ 5@/  '\xde'\x1a;E\xd6'; fn / '@/8")
    run_file('  box\n\'\xde\'[""]\n\'\xde\'*\n\n\n\n\n]*\n\xa7\n\x80\n\'\xde\'O; \'\x7f\xff@D \'@@/@/ 8@/\x00\x00\x01\x00')
    run_file(" 0. >>'\xde';;'\xde';; \x1b;/;\xde';; \t@/A5@/\x00 '\xde'\x1a;E\xde';\x01@5  '\xde' E@\x7f #@/8")
    run_file("+ box\n'\xde'([])*\n\n\n\n\n\n*\n\nbox\n'\xde'*\n\n\n\n\n*\n\nbox\n'\xde'*\n\n*\n\n\n\n\n'\xde';; '@/@/ '@@/@/ 8@/ 1  re\nt    const m = make(int)\n        m.id(3)\n9   }\n ")
    run_file('[ 1. >= 0e0,]\n+ [[ 1. >= 3/\xb3337     -0>!0-0>!0x33/333      -0>!0x33/30>!0x33/3330 -0>1e330 -0>1e-0 ')
    run_file('const (x, (y(x, (y: int)): i\xc7t))-= (3, A)')
    run_file('[ & 2] * 11**0*0\n 2] * 11**0*0\n01011*01*[""]*1**4*0*0')
    run_file('""  -0. %-0. %1e-0  %-0.1%1e-0  %S0.Ne-0 ')
    run_file(' if le {sl[1,8].s.\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce switch \xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xa1\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xe8\xce\xce\xdb\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xae\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce\xce3 :()\n        }\n ')
    run_file('[1] +["]1] +\xcf"] *  [4,  *  Y4, 5]')
    run_file('["\xd01,3"]  * * 7')
    run_file(' 0x1e : int  \n    fn ()\x7f\xff\xff\xffdu|e {\xec\x1f  1  (): module {\n   1 \x1f O\x00   * z    var b = 1\x16> 2\n      \x00     b \x00\x013 : 41    \x02\x00   4       b \x00\x013 : 41> 2\n     \n    var b\x05= 1\x16> 2\n            b \x00\x013 : 41-0     \n       .1}\n  \x00\n            b ??3 : 7 -0.1}\n')
    run_file('for x in 3 { if x==14(f\xd8lse) for x in  ref var 3 { id x==1 { break }; x } else { return  5 }}; xse { r\x01 { r\x01turn \x105  fulfil }')
    run_file('for x in 5555 >>> 555 { break }; x e.ng4htig')
